package giden.CORE;
//import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.Point;

public class GdnNetworkReaderV3 extends GdnNetworkFileV3
{
    LinkList UiNetComments;
    LinkList UiNetNodesComments;
    LinkList UiNetEdgesComments;
    
    
    // Column index values
    int NET_NETINDEX_COL=1;
    int NET_NAME_COL=2;
    
    int NET_COUNT_COL=1;
    int NET_MAXINDEX_COL=2;
    
    int OBJ_COUNT_COL=1;
    int OBJ_NAME_COL=0;
    int OBJ_STRING_COL=1;
    
    GdnCsvInput Csv;
        
    // UiNet values
    String UiNetName;
    Node UiNodes[];
    
    public GdnNetworkReaderV3(String path, String filename)
    {
        Csv = new GdnCsvInput(path,filename);
        Csv.readLine();
        Csv.parseCommas();
        if(Csv.getString(0).equals(Version_3_0))
            FileValid=true;
        else
            Csv.close();
    }
    public boolean readFile(GUINetwork net)
    {
        String tag;
        LinkList headercomments = null;
        UiNetComments = null;
        UiNetNodesComments = null;
        UiNetEdgesComments = null;
                
        boolean result=true;
        while(nextLine())     // outer level through file
        {
            tag=Csv.getString(0);
            if(tag.equals(this.UINET_TAG))
            {
                UiNetComments=headercomments;
                UiNetName=Csv.getString(NET_NAME_COL);
                UiNetIndex=Csv.getInt(NET_NETINDEX_COL);
                readUiNetwork(net);
                net.GetNet().UiNetComments=UiNetComments;
                net.GetNet().UiNetNodesComments=UiNetNodesComments;
                net.GetNet().UiNetEdgesComments=UiNetEdgesComments;
            }
            else
            {
                if(headercomments==null)
                    headercomments = new SingleLinkList();
                headercomments.AddItem(Csv.LastLine);
            }
        }
        return result;
    }
    boolean readUiNetwork(GUINetwork guinet)
    {
        LinkList list=null;
        Network net=guinet.GetNet();
        int i,j,count,col_count;
        String tag,text;
        int x_col,y_col,index_col,radius_col;
        int source_col,target_col,location_col;
        Node node,snode,tnode;
        Edge edge;
        int x,y,r,index,s,t;
        boolean gui_array;
        boolean edge_spline_x,edge_spline_y;
        Point spline = new Point();
        //int edge_x,edge_y;
        int field_length;
        UiNodeInfo nodeinfo;
        UiNode uinode;
        int location;
        
        boolean result=true;
        while(nextLine())     // read node header info
        {
            tag=Csv.getString(0);
            if(tag.equals(NODES_TAG))                       // NODES TAG
            {
                UiNetNodesComments=list;
                list=null;
                UiNetNodeCount=Csv.getInt(NET_COUNT_COL);
                UiNetMaxNodeIndex=Csv.getInt(NET_MAXINDEX_COL);
                UiNodes = new Node[UiNetMaxNodeIndex+1];
                
                nextLine();                                 // node names
                col_count=Csv.getCount();
                UiNetNodeColNames = new String[col_count];
                UiNetNodeColTypes = new int[col_count];
                UiNetNodeArrays = new NodeArray[col_count];
                x_col=y_col=index_col=radius_col=-1;
                for(i=0;i<col_count;i++)
                {
                    text=UiNetNodeColNames[i]=Csv.getString(i);
                    gui_array=true;
                    if(text.equals(INDEX_TAG))
                    {
                        gui_array=false;
                        index_col=i;
                    }
                    if(text.equals(X_TAG))
                    {
                        gui_array=false;
                        x_col=i;
                    }
                    if(text.equals(Y_TAG))
                    {
                        gui_array=false;
                        y_col=i;
                    }
                    if(text.equals(RADIUS_TAG))
                    {
                        gui_array=false;
                        radius_col=i;
                    }
                                        
                    if(gui_array)
                    {
                        guinet.GUI.createNodeDataField(text,null,false);
                        UiNetNodeArrays[i]=net.GetNodeArray(text);
                    }
                    else
                        UiNetNodeArrays[i] = new NodeArray(100,text);
                }
                nextLine();                             // node data types
                for(i=0;i<col_count;i++)
                {
                    text=Csv.getString(i);
                    if(text.equals(INT_TAG))
                    {
                        UiNetNodeColTypes[i]=IndexArray.INTEGER_TYPE;
                        UiNetNodeArrays[i].Fill(0);
                    }
                    if(text.equals(DOUBLE_TAG))
                    {
                        UiNetNodeColTypes[i]=IndexArray.DOUBLE_TYPE;
                        UiNetNodeArrays[i].Fill(0.0);
                    }
                    if(text.equals(STRING_TAG))
                    {
                        UiNetNodeColTypes[i]=IndexArray.STRING_TYPE;
                        UiNetNodeArrays[i].Fill("");
                    }
                }
                for(j=0;j<UiNetNodeCount;j++)           // create nodes
                {
                    nextLine();
                    x=Csv.getInt(x_col);
                    y=Csv.getInt(y_col);
                    index = Csv.getInt(index_col);
                    
                    while(index > net.GetCreatedNodesCount() )
                        net.IncrementNodeIndex();
                    node = net.CreateNode();
                    nodeinfo = guinet.GUI.GetDefaultUiNodeInfo();
                    nodeinfo.x=x;
                    nodeinfo.y=y;
                    nodeinfo.label=new Integer(node.GetIndex()).toString();
                    
                    //boolean ok = guinet.CreateNode(node,new Point(x,y));
                    // may want to create with nodeinfo preset
          
                    if(radius_col!=-1)  // update nodeinfo
                    {
                        r=Csv.getInt(radius_col);
                        nodeinfo.radius=r;
                        //uinode = guinet.Node2UiNode(node);
                        //nodeinfo = uinode.GetUiInfo();
                        //nodeinfo.radius=r;
                        //uinode.PutUiInfo(nodeinfo);
                    }
                    boolean ok = guinet.CreateNode(node,nodeinfo);
                    
                
                    UiNodes[index]=node;
                    for(i=0;i<col_count;i++)
                    {
                        switch(UiNetNodeColTypes[i])
                        {
                            case IndexArray.INTEGER_TYPE:
                            UiNetNodeArrays[i].Put(node,Csv.getInt(i));
                            break;
                            
                            case IndexArray.DOUBLE_TYPE:
                            UiNetNodeArrays[i].Put(node,Csv.getDouble(i));
                            break;
                            
                            case IndexArray.STRING_TYPE:
                            UiNetNodeArrays[i].Put(node,Csv.getString(i));
                            break;   
                        }
                    }                    
                }                
            }
            else if(tag.equals(EDGES_TAG))                   // EDGES TAG
            {
                UiNetEdgesComments=list;
                list=null;
                UiNetEdgeCount=Csv.getInt(NET_COUNT_COL);
                UiNetMaxEdgeIndex=Csv.getInt(NET_MAXINDEX_COL);
                               
                nextLine();                             // edge names
                col_count=Csv.getCount();
                UiNetEdgeColNames = new String[col_count];
                UiNetEdgeColTypes = new int[col_count];
                UiNetEdgeArrays = new EdgeArray[col_count];
                x_col=y_col=source_col=target_col=index_col=location_col=-1;
                for(i=0;i<col_count;i++)
                {
                    text=UiNetEdgeColNames[i]=Csv.getString(i);
                    gui_array=true;
                    if(text.equals(INDEX_TAG))
                    {
                        gui_array=false;
                        index_col=i;
                    }
                    if(text.equals(X_TAG))
                    {
                        gui_array=false;
                        x_col=i;
                    }
                    if(text.equals(Y_TAG))
                    {
                        gui_array=false;
                        y_col=i;
                    }
                    if(text.equals(SOURCE_TAG))
                    {
                        gui_array=false;
                        source_col=i;
                    }
                    if(text.equals(TARGET_TAG))
                    {
                        gui_array=false;
                        target_col=i;
                    }
                    if(text.equals(LOCATION_TAG))
                    {
                        gui_array=false;
                        location_col=i;
                    }
                    if(gui_array)
                    {
                        guinet.GUI.createEdgeDataField(text,null,false);
                        UiNetEdgeArrays[i]=net.GetEdgeArray(text);
                    }
                    else
                        UiNetEdgeArrays[i] = new EdgeArray(100,text);
                }
                nextLine();                             // edge data types
                for(i=0;i<col_count;i++)
                {
                    text=Csv.getString(i);
                    if(text.equals(INT_TAG))
                    {
                        UiNetEdgeColTypes[i]=IndexArray.INTEGER_TYPE;
                        UiNetEdgeArrays[i].Fill(0);
                    }
                    if(text.equals(DOUBLE_TAG))
                    {
                        UiNetEdgeColTypes[i]=IndexArray.DOUBLE_TYPE;
                        UiNetEdgeArrays[i].Fill(0.0);
                    }
                    if(text.equals(STRING_TAG))
                    {
                        UiNetEdgeColTypes[i]=IndexArray.STRING_TYPE;
                        UiNetEdgeArrays[i].Fill("");
                    }
                }
                location = UiEdgeInfo.LABEL_NORTH;
                
                for(j=0;j<UiNetEdgeCount;j++)           // edge rows
                {
                    nextLine();
                    index = Csv.getInt(index_col);
                    edge_spline_x=edge_spline_y=false;
                    if(location_col!=-1)
                    {
                        if(Csv.getString(location_col)!=null)
                        {
                            location=Csv.getInt(location_col);
                        }
                    }
                    else
                        location = UiEdgeInfo.label_position_default;
                    
                    if(x_col!=-1)
                    {
                        if(Csv.getString(x_col)!=null)
                        {
                            x=Csv.getInt(x_col);
                            edge_spline_x=true;
                        }
                    }
                    if(y_col!=-1)
                    {
                        if(Csv.getString(y_col)!=null)
                        {
                            y=Csv.getInt(y_col);
                            edge_spline_y=true;
                        }
                    }
                    if(edge_spline_x && edge_spline_y)
                    {   // process spline point at (x,y)
                    }
                    if(location_col!=-1)
                    {   // process edge label position
                    }
                    s=Csv.getInt(source_col);
                    t=Csv.getInt(target_col);
                    snode = UiNodes[s];
                    tnode = UiNodes[t];
                    while(index > net.GetCreatedEdgesCount() )
                        net.IncrementEdgeIndex();
                      
                    edge = net.CreateEdge(snode,tnode);
                    UiEdgeInfo info = guinet.GUI.GetDefaultUiEdgeInfo();
                    info.label=new Integer(edge.GetIndex()).toString();
                                        
                    info.label_position=location;
                                        
                    if(edge_spline_x && edge_spline_y)                       
                    {   // process spline point at (x,y)
                        spline.x = Csv.getInt(x_col);
                        spline.y = Csv.getInt(y_col);
                        info.setSplinePoint(spline);
                    }
                    

                    
                    guinet.CreateEdge(edge,info);
                       
                    //edge = guinet.CreateEdge(snode,tnode);
                    for(i=0;i<col_count;i++)
                    {
                        if(Csv.getString(i)==null)
                        {
                            UiNetEdgeArrays[i].Put(edge,null);
                            continue;
                        }
                        
                        switch(UiNetEdgeColTypes[i])
                        {
                            case IndexArray.INTEGER_TYPE:
                            UiNetEdgeArrays[i].Put(edge,Csv.getInt(i));
                            break;
                            
                            case IndexArray.DOUBLE_TYPE:
                            UiNetEdgeArrays[i].Put(edge,Csv.getDouble(i));
                            break;
                            
                            case IndexArray.STRING_TYPE:
                            UiNetEdgeArrays[i].Put(edge,Csv.getString(i));
                            break;
                        }
                    }                    
                }                
            }
            else if(tag.equals(OBJECTS_TAG))                   // OBJECTS TAG
            {
                list=null;
                int object_count = Csv.getInt(OBJ_COUNT_COL);
                int oi;
                String name;
                String string;
                for(oi=0;oi<object_count;oi++)
                {
                    nextLine();                 // read object
                    name = Csv.getString(OBJ_NAME_COL);
                    string = Csv.getString(OBJ_STRING_COL);
                    net.AddNamedObject(name,string);
                }
            }            
            else
            {
                if(list==null)
                    list = new SingleLinkList();
                list.AddItem(Csv.LastLine);
            }
        }
        return result;
    }
    
    boolean nextLine()
    {
        int count;
        String result;
        Csv.readLine();
        Csv.NEWstripEmptyFields();
        Csv.parseCommas();
        count=Csv.getCount();
        System.out.print("#="+count+": ");
        for(int i=0;i<count;i++)
            System.out.print("|"+Csv.getString(i));
        System.out.println("|");
        return Csv.LastLine!=null;
    }
    
}