package giden.CORE;
//import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.util.Date;
import java.awt.Point;

public class GdnNetworkWriterV3 extends GdnNetworkFileV3
{
    GdnCsvOutput Csv;
    int StartNodeArrayIndex;
    int StartEdgeArrayIndex;
    
    public GdnNetworkWriterV3(String path, String filename)
    {
        Csv = new GdnCsvOutput(path,filename);
        Csv.addString(Version_3_0);
        Csv.addString(new Date().toString());
        Csv.writeLine();
        StartNodeArrayIndex=1;
        StartEdgeArrayIndex=2;
    }
    
    public boolean writeFile(UiNetwork uinet)
    {
        boolean result = writeFile((GUINetwork)uinet);
        return result;
    }
    
    public boolean writeFile(GUINetwork net)
    {
        int ni,na,na1,na2;
        int ei,ea,ea1,ea2;
        int oi,oa,oa1,oa2;
        
        String name;
        
        na1=StartNodeArrayIndex;
        na2=net.GUI.GetNodeArrayCount();
        NodeArray NodeArrays[] = new NodeArray[na2-na1];
        ni=0;
        for(na=na1;na<na2;na++)
        {
            name=net.GUI.GetNodeArrayName(na);
            NodeArrays[ni]=net.GetNet().GetNodeArray(name);
            ni++;
        }
        
        ea1=StartEdgeArrayIndex;
        ea2=net.GUI.GetEdgeArrayCount();
        EdgeArray EdgeArrays[] = new EdgeArray[ea2-ea1];
        ei=0;
        for(ea=ea1;ea<ea2;ea++)
        {
            name=net.GUI.GetEdgeArrayName(ea);
            EdgeArrays[ei]=net.GetNet().GetEdgeArray(name);
            ei++;
        }
        
        ListIter lit;
        int index;
        Object obj;
    
        index=0;
        lit = net.GetNet().GetNamedObjectIter();
        NamedObject named_objects[] = new NamedObject[lit.GetSize()];
        for(obj=lit.GetFirstItem();obj!=null;obj=lit.GetNextItem())
            named_objects[index++]=(NamedObject)(obj);

        
        return writeFile(net,NodeArrays,EdgeArrays,named_objects);
    }
    public boolean writeFile(GUINetwork net, NodeArray node_arrays[], EdgeArray edge_arrays[])
    {
        NamedObject obj_arrays[] = new NamedObject[0];
        return writeFile(net,node_arrays,edge_arrays,obj_arrays);
    }
    
    public boolean writeFile
        (
        GUINetwork net,
        NodeArray node_arrays[],
        EdgeArray edge_arrays[],
        NamedObject obj_arrays[]
        )
    {
        
        GUINodeListIter nit;
        GUIEdgeListIter eit;
        UiNode node;
        UiEdge edge;
        Edge e;
        UiNodeInfo node_info;
        UiEdgeInfo edge_info;
        int ei,emax;
        int ni,nmax;
        LinkList list;
        ListIter lit;
        Object obj;
                
        boolean result=true;
        
        UiNetIndex=0;
        list = net.GetNet().UiNetComments;
        if(list!=null)
        {
            lit = new ListIter(list);
            for(obj=lit.GetFirstItem();obj!=null;obj=lit.GetNextItem())
                Csv.writeLine((String)obj);
        }
        Csv.addString(UINET_TAG);
        Csv.addInt(UiNetIndex);
        Csv.writeLine();
        
        //=======================================================
        // WRITE NODES
        //=======================================================
        
        // Nodes tag
        UiNetNodeCount=net.GetNodeCount();
        UiNetMaxNodeIndex=net.GetCreatedNodesCount()-1;
        list=net.GetNet().UiNetNodesComments;
        if(list!=null)
        {
            lit = new ListIter(list);
            for(obj=lit.GetFirstItem();obj!=null;obj=lit.GetNextItem())
                Csv.writeLine((String)obj);
        }
        Csv.addString(NODES_TAG);
        Csv.addInt(UiNetNodeCount);
        Csv.addInt(UiNetMaxNodeIndex);
        Csv.writeLine();
        
        nmax=node_arrays.length;
        UiNetNodeColNames = new String[nmax];
        UiNetNodeArrays = new NodeArray[nmax];
        UiNetNodeColTypes = new int[nmax];
        for(ni=0;ni<nmax;ni++)
        {
            UiNetNodeArrays[ni]=node_arrays[ni];
            if(UiNetNodeArrays[ni].GetAlias()!=null)
                UiNetNodeColNames[ni]=UiNetNodeArrays[ni].GetAlias();
            else
                UiNetNodeColNames[ni]=UiNetNodeArrays[ni].GetName();
            UiNetNodeColTypes[ni]=UiNetNodeArrays[ni].FillType;
        }
        
        Csv.addString(INDEX_TAG);
        Csv.addString(X_TAG);
        Csv.addString(Y_TAG);
        for(ni=0;ni<nmax;ni++)
            Csv.addString(UiNetNodeColNames[ni]);
        Csv.writeLine();
        
        Csv.addString(INT_TAG);
        Csv.addString(INT_TAG);
        Csv.addString(INT_TAG);
        for(ni=0;ni<nmax;ni++)
            Csv.addString(DataTypeToTag(UiNetNodeColTypes[ni]));
        Csv.writeLine();
        
        nit = net.GetNodeListIter();
        for(node=nit.GetFirstNode();node!=null;node=nit.GetNextNode())
        {
            Csv.addInt(node.GetNode().GetIndex());
            node_info = node.GetUiInfo();
            Csv.addInt(node_info.x);
            Csv.addInt(node_info.y);
            for(ni=0;ni<nmax;ni++)
            {
                switch(UiNetNodeColTypes[ni])
                {
                    case IndexArray.INTEGER_TYPE:
                    Csv.addInt(UiNetNodeArrays[ni].GetInt(node.GetNode()));
                    break;
                    
                    case IndexArray.DOUBLE_TYPE:
                    Csv.addDouble(UiNetNodeArrays[ni].GetDouble(node.GetNode()));
                    break;
                    
                    case IndexArray.STRING_TYPE:
                    Csv.addString(UiNetNodeArrays[ni].GetString(node.GetNode()));    
                    break;
                    
                }
            }
            Csv.writeLine();
        }
                
        //=======================================================
        // WRITE EDGES
        //=======================================================
        boolean location_flag=false;
        boolean spline_flag=false;
        Point spline_point;
        eit = net.GetEdgeListIter();
        for(edge=eit.GetFirstEdge();edge!=null;edge=eit.GetNextEdge())
        {
            if( ((GUIEdgeInfo)(edge.GetUiInfo())).spline_positioned )
            {
                spline_flag=true;
                break;
            }
        }
        for(edge=eit.GetFirstEdge();edge!=null;edge=eit.GetNextEdge())
        {
            if( ((GUIEdgeInfo)(edge.GetUiInfo())).label_position!=UiEdgeInfo.label_position_default )
            {
                location_flag=true;
                break;
            }
        }
        

                                
        UiNetEdgeCount=net.GetEdgeCount();
        UiNetMaxEdgeIndex=net.GetCreatedEdgesCount()-1;
        list = net.GetNet().UiNetEdgesComments;
        if(list!=null)
        {
            lit = new ListIter(list);
            for(obj=lit.GetFirstItem();obj!=null;obj=lit.GetNextItem())
                Csv.writeLine((String)obj);
        }
        Csv.addString(EDGES_TAG);
        Csv.addInt(UiNetEdgeCount);
        Csv.addInt(UiNetMaxEdgeIndex);
        Csv.writeLine();
        
        emax = edge_arrays.length;
        UiNetEdgeColNames = new String[emax];
        UiNetEdgeArrays = new EdgeArray[emax];
        UiNetEdgeColTypes = new int[emax];
        for(ei=0;ei<emax;ei++)
        {
            UiNetEdgeArrays[ei]=edge_arrays[ei];
            if(UiNetEdgeArrays[ei].GetAlias()!=null)
                UiNetEdgeColNames[ei]=UiNetEdgeArrays[ei].GetAlias();
            else
                UiNetEdgeColNames[ei]=UiNetEdgeArrays[ei].GetName();
            UiNetEdgeColTypes[ei]=UiNetEdgeArrays[ei].FillType;
        }
        Csv.addString(INDEX_TAG);
        Csv.addString(SOURCE_TAG);
        Csv.addString(TARGET_TAG);
        if(location_flag)
            Csv.addString(LOCATION_TAG);
        if(spline_flag)
        {
            Csv.addString(X_TAG);
            Csv.addString(Y_TAG);
        }
        
        
        for(ei=0;ei<emax;ei++)
            Csv.addString(UiNetEdgeColNames[ei]);
        Csv.writeLine();
        
        Csv.addString(INT_TAG);     // index
        Csv.addString(INT_TAG);     // source
        Csv.addString(INT_TAG);     // target
        if(location_flag)
            Csv.addString(INT_TAG);     // location
        if(spline_flag)
        {
            Csv.addString(INT_TAG); // x spline
            Csv.addString(INT_TAG); // y spline
        }
        for(ei=0;ei<emax;ei++)
            Csv.addString(DataTypeToTag(UiNetEdgeColTypes[ei]));
        Csv.writeLine();
                
        eit = net.GetEdgeListIter();
        for(edge=eit.GetFirstEdge();edge!=null;edge=eit.GetNextEdge())
        {
            Csv.addInt(edge.GetEdge().GetIndex());
            edge_info = edge.GetUiInfo();
            e = edge.GetEdge();
            Csv.addInt(e.GetSource().GetIndex());
            Csv.addInt(e.GetTarget().GetIndex());
            if(location_flag)
                Csv.addInt(edge_info.label_position);
            if(spline_flag)
            {
                spline_point = ((GUIEdgeInfo)(edge_info)).getSplinePoint();
                if(spline_point!=null)
                {
                    Csv.addInt(spline_point.x);
                    Csv.addInt(spline_point.y);
                }
                else
                {
                    Csv.addString("");
                    Csv.addString("");
                }
            }
            for(ei=0;ei<emax;ei++)
            {
                switch(UiNetEdgeColTypes[ei])
                {
                    case IndexArray.INTEGER_TYPE:
                    Csv.addInt(UiNetEdgeArrays[ei].GetInt(edge.GetEdge()));
                    break;
                    
                    case IndexArray.DOUBLE_TYPE:
                    Csv.addDouble(UiNetEdgeArrays[ei].GetDouble(edge.GetEdge()));
                    break;
                    
                    case IndexArray.STRING_TYPE:
                    Csv.addString(UiNetEdgeArrays[ei].GetString(edge.GetEdge()));    
                    break;
                    
                }
            }
            Csv.writeLine();
        }
        //=======================================================
        // WRITE NAMED OBJECTS
        //=======================================================
        
        // Named Object Tag
        int obj_count = obj_arrays.length;
        Csv.addString(OBJECTS_TAG);
        Csv.addInt(obj_count);
        Csv.writeLine();
        
        int oi;
        NamedObject named_obj;
        
        for(oi=0;oi<obj_count;oi++)
        {
            named_obj = obj_arrays[oi];
            Csv.addString(named_obj.GetName());
            Csv.addString((String)named_obj.GetObject());
            Csv.writeLine();
        }
        
        close();
        return result;
    }
    boolean close()
    {
        Csv.close();
        return true;
    }
    
}