package  giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;
/*
 * WE MAKE NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WE SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY USER AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/**
 * *** ndex is a class used by its derived classes (for example,
 *
 * @see RowDialogCheckbox
 * @see RowDialogChoice
 * @see RowDialogEdge
 * @see RowDialogFilename
 * @see RowDialogMain
 * @see RowDialogNode
 * @see RowDialogText
 *
 * @version 	3.0a 26 Dec 2003
 * @author 	    D. S. Dilworth
 */


public class RowDialogController extends RowDialogEntry implements ActionListener
{
    RowEntryButton Run;
    RowEntryButton Results;
    String RunText; 
    SolverController Solver;
    
    public RowDialogController(String name, String text, RowDialogMain dialog, SolverController solver)
    {
        super(name,dialog);
        RunText="Run";
        Run = new RowEntryButton(RunText);
        Run.addActionListener(this);   
        Results = new RowEntryButton(text);
        Results.addActionListener(this);
        Solver=solver;
        
    }
    void Build()
    {
        add(Run);
        add(Name);
        add(Results);
        add(Help);
    }
    Dimension GetInfoSize()
    {
        return Run.getSize();
    }
    void PutSize(int height, int name, int info, int extra, int help)
    {
        Name.PutSize(new Dimension(name,height));
        Run.PutSize(new Dimension(info,height));
        Results.PutSize(new Dimension(extra,height));
    }
    
    Dimension GetExtraSize()
    {
        return Results.getSize();
    }
    
    public void PutResults(String results)
    {
        Results.setLabel(results);
    }
    public void PutResults(int value)
    {
        String results = new Integer(value).toString();
        PutResults(results);
    }
    
    
    public void actionPerformed(ActionEvent event)
    {
        String name = event.getActionCommand();
        if(name.equals(RunText))
        {
            Dialog.UserRunButton(name,this);
        }
        else
        {
            Dialog.UserResultsButton(name,this);
        }
    }
      
}
