package  giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.contrib.samples.*;
import giden.GRDS.*;
import giden.GUI.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.FileDialog;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 <p>
 RowDialogFilename is a row in a RowDialogMain dialog box.
 It allows the user to enter a filename by typing or selecting one by browsing.
 The host program then retrieves the filename string by calling GetFilename.
 See the example in DialogSolver.java and the documentation in RowDialogMain.java.
 * <p>
 * @see DialogSolver
 * @see RowDialogChoice
 * @see RowDialogEdge
 * @see RowDialogEntry
 * @see RowDialogMain
 * @see RowDialogNode
 * @see RowDialogText
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */


public class RowDialogFilename extends RowDialogText implements ActionListener
{
    RowDialogMain Dialog;
    RowEntryButton Extra;
    String Filename;
    String Directory;
    String FS; 
    String BrowseString="...";
    String Prompt;
    int FileMode;
        
    /** Constructs a filename row
     * @param name name for the row
     * @param nominal default filename
     * @param savemode true if the file is to opened for save
     * @param dialog the host RowDialogMain object
    */
    public RowDialogFilename(String name, String nominal, boolean savemode, RowDialogMain dialog)
    {
        super(name,nominal,dialog);
        Filename=nominal;
        Prompt=name;
        if(savemode==true)
            FileMode=FileDialog.SAVE;
        else
            FileMode=FileDialog.LOAD;
        
        String Directory = System.getProperty("user.dir");  // save this elsewhere
        String FS =  System.getProperty("file.separator");     
        
        Extra = new RowEntryButton(BrowseString);
        Extra.addMouseListener(dialog);
        Dialog=dialog;
        Extra.addActionListener(this);        
    }
    void Build()
    {
        add(Name);
        add(TextField);
        add(Extra);
        add(Help);
    }
    Dimension GetInfoSize()
    {
        return TextField.getSize();
    }
    void PutSize(int height, int name, int info, int extra, int help)
    {
        Name.PutSize(new Dimension(name,height));
        TextField.PutSize(new Dimension(info,height));
        Extra.PutSize(new Dimension(extra,height));
    }
    Dimension GetExtraSize()
    {
        return Extra.getSize();
    }
    /** Internal method */
    public void actionPerformed(ActionEvent event)
    {
        
        Object obj=event.getSource();
        String label=((Button)obj).getLabel();
        if(label.equals(BrowseString))
        {
                
            GUISolver gui = Dialog.GetGUI();
            FileDialog d = new FileDialog(gui,Prompt,FileMode);
            d.setFile(Filename);
            d.setDirectory(Directory);
            d.setVisible(true);
            // !! [Cancel] clears Filename and Directory, but not the entry in TextField
            // !! [OK]     updates all three
            // !! implementor needs to sift these three or this module does
            Filename = d.getFile();      
            Directory = d.getDirectory();
            if(Filename!=null && Directory!=null)
            {
                TextField.setText(Filename);
            }
        }
        else
            super.actionPerformed(event);
    }
    /** Returns the filename */
    public String GetFilename()
    {
        return Filename;
    }
    /** returns the filename's directory */
    public String GetDirectory()
    {
        return Directory;
    }
}
