package  giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

/*###############################################################
| 020210, DSD,
|   TerminateSolverThread()
|   //EventNotify("TerminateSolverThread"); 020210 -dsd exit, crash
|   Thread was living-on and crashing JavaVM, now OK
|   -> This method not called when window closed
|----------------------------------------------------------------
###############################################################*/

/*===============================================================
===============================================================*/
public class SolverThread extends Thread //Runnable
{
    boolean WaitingForEvent;
    boolean Terminate;
    public boolean SolverSetupExecute;
    int UserWantsExit;
    String EventString;
    String SolverName;
    public GUISolver GUI;
    public ExecBase Solver;
    boolean LastWasPcNext;
    GraphState GraphSnap;
    boolean GoToPauseEvent;
    
    
    //-----------------------------------------------------------
    //-----------------------------------------------------------    
    SolverThread(GUISolver gui)
    {
        GUI=gui;
        Clear();
        start();
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void Clear()
    {
        Terminate=false;
        Solver=null;
        SolverSetupExecute=false;
        UserWantsExit=0;
        LastWasPcNext=false;
        ClearEvent();
    }
    void ClearEvent()
    {
        WaitingForEvent=false;
        GoToPauseEvent=false;
        EventString=null;        
    }
    String GetTraceString()
    {
        return GUI.GetTraceString();
    }
    String GetFinalString()
    {
	    return GUI.GetFinalString();
    }
    String GetStepString()
    {
	    return GUI.GetStepString();
    }
    String GetNextString()
    {
	    return GUI.GetNextString();
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetContinuousAnimationPauseString()
    {
        return GUI.GetContinuousAnimationPauseString();
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetContinuousAnimationGoString()
    {
        return GUI.GetContinuousAnimationGoString();
    }
    void Message(String message)
    {
        GUI.Message("SolverThread."+message);
    }
    ExecBase GetSolver()
    {
        return Solver;
    }
    public void run()
    {
        String event;
        Message("run ==========");
        Message("run -> Thread Starts");
        Terminate=false;
        while(Terminate==false)
        {
            event=EventWait("run");
            ProcessEvent(event);
        }
        Message("run -> Thread Exits");
        Message("run ==========");
        
    }
    boolean UserWantsExit()
    {
        SolverServices services = (SolverServices)this;
        
        boolean result=false;
        Solver.Shutdown();
        Solver.PostShutdown();
        services.RestoreNetworks();
        services.DrawNetworks();
        UserWantsExit++;
        if(SolverSetupExecute)
            result=true;
        if(UserWantsExit>1)
            result=true;
        return result;
    }
    public void TerminateSolverThread()
    {
        Terminate=true;
        stop();
	    Solver.Shutdown();
	    Solver.PostShutdown();
	    ((SolverServices)this).RemoveUserBases();
        GUI.UiNet.UserInfo=null;         // wire GUI->solver
        //EventNotify("TerminateSolverThread"); 020210 -dsd exit, crash
    }
    public synchronized String EventWait(String who)
    {
        long delay=0;
        if (LastWasPcNext)
            delay = 0;
        else if (who.equals("WaitForActionButton") && SolverSetupExecute)
        {
            delay = GUI.animation_control.getAnimationTimeStep();
        }
        return EventWait(who,delay);
    }
    public synchronized String EventWait(String who, long maxwait)
    {
        String message="EventWait("+who+")";
        Message("EventWait -------------------");
        Message(message+" -> Enter");
        ClearEvent();
        WaitingForEvent=true;
        GoToPauseEvent=false;
        while(WaitingForEvent)
        {
            try
            {
                if(maxwait>0)
                    wait(maxwait);
                else
                    wait();
            }
            catch(InterruptedException ex)
            {
            }
            if(maxwait>0 && GoToPauseEvent==false)
            {
                EventString="ContAnim";
                break;
            }
        }
        Message(message+" -> Exit");
        return EventString;
    }
    public synchronized boolean EventNotify(String eventstring)
    {
        boolean result=false;
        String who="EventNotify("+eventstring+")";
        Message(who);
        if(WaitingForEvent)
        {
            EventString=eventstring;
            WaitingForEvent=false;
            notifyAll();
            result=true;
        }
        else
            Message(who+" !! Invalid state");
        return result;
    }
    public void ProcessEvent(String eventstring)
    {
        String who="ProcessEvent("+eventstring+")";
        Message(who+" -> Enter");
        UserBase user = new UserIO((SolverServices)this,GUI);
        ExecBase exec =null;
        
        if(eventstring.equals("Prim")) 
           exec=new Prim(user);
        if(eventstring.equals("Kruskal")) 
           exec=new Kruskal(user);
        if(eventstring.equals("Dijkstra")) 
           exec=new Dijkstra(user);
        if(eventstring.equals("FIFO Label Correcting")) 
           exec=new LabelCorrect(user);
        if(eventstring.equals("Generic Augmenting Path")) 
           exec=new GenAugPath(user);
        if(eventstring.equals("Shortest Augmenting Path")) 
           exec=new ShortAugPath(user);
        if(eventstring.equals("Pre-Flow Push")) 
           exec=new PreFlowPush(user);
        if(eventstring.equals("Capacity Scaling"))
           exec=new CapacityScaling(user);
        if(eventstring.equals("Successive Shortest Path")) 
           exec=new SuccShortPath(user);
        if(eventstring.equals("Cycle Canceling")) 
           exec=new CycleCanceling(user);
        if(eventstring.equals("Network Simplex")) 
           exec=new NetworkSimplex(user);
        if(eventstring.equals("Out-of-Kilter"))
           exec=new OutOfKilter(user);
           
        /*
        if(eventstring.equals("Cycle Canceling")) 
           solver=new CycleCanceling(userinfo);
           
        //if(eventstring.equals("Symmetric TSP Heuristics"))
        //   solver=new SymmetricTSP(userinfo);
        */
        
        if(exec!=null)
        {
            Message("SolverThread created "+eventstring);
        }
        if(exec==null)
        {
            exec = GUI.GetContribSolverMenu().CreateSolver(eventstring,(SolverServices)this,GUI);
            if(exec!=null)
            {
                Message("SolverMenu created "+eventstring);
            }
        }
        if(exec==null)
        {
            exec = GUI.GetSolverMenu().CreateSolver(eventstring,(SolverServices)this,GUI);
            if(exec!=null)
            {
                Message("SolverMenu created "+eventstring);
            }
        }
        
        if(exec!=null)
            ExecuteSolver(eventstring,exec);
        Message(who+" -> Exit");
    }
    public void ExecuteSolver(String who,ExecBase solver)
    {
        boolean state=false;
        SolverServices services = (SolverServices)this;
        Solver=solver;
        Message("ExecuteSolver."+who);
        GUI.setupSolverMode(who);

        // loop until user terminates
        UserWantsExit=0;
        while(UserWantsExit==0)
        {
            // remove remnants from a previous run
            services.RemoveUserBases();
            
            SolverSetupExecute=true;                    // start setup/exec
            Solver.PreSetup(GUI.UiNet.Net);             // low level setup
            services.AddUserBase(Solver.BaseUserInfo);  // add this solver
            GUI.UiNet.UserInfo=Solver.BaseUserInfo;     // wire GUI->solver
            state=Solver.Setup(GUI.UiNet.Net);          // solver setup
            if(state)
            {
                Solver.BaseUserInfo.CreateAnimationButtons();
                GUI.notifyOfSolverStart();
                services.DrawNetworks();
                //services.Repaint("SolverThread.ExecuteSolver-1");
                //Solver.User.DrawNetwork();
                WaitForActionButton();                  // wait for user OK
                // WE NEED TO MAKE SURE WE HAVEN'T BEEN KILLED BY [EXIT]
                //if(Terminate==true)
                //    state=state;
                if(Solver.Execute()==true)              // run solver
                {
                    Solver.BaseUserInfo.CreateFinalButtons();
                }
                SolverSetupExecute=false;               // end setup/exec
                GUI.notifyOfSolverFinish();             // end -> GUI
                services.DrawNetworks();                // final draw
                WaitForActionButton();                  // wait for user OK
                Solver.Shutdown();                      // solver clean-up
                Solver.PostShutdown();                  // low level end
                services.RestoreNetworks();             // restore networks
                services.DrawNetworks();                // redraw networks
            }
            else
                break;
        }
        Solver=null;
        GUI.clearStatusLine();
        GUI.setupNetworkMode();
        if(state)
            Message("ExecuteSolver Normal exit");
        else
            Message("ExecuteSolver Setup failed");
        GUI.UiNet.UserInfo=null;         // wire GUI->solver
            
    }
    public String UserTextInput(String question, String answer)
    {
        String who="UserTextInput("+question+","+answer+")";
        Message(who);
        GUI.UserTextInput(question,answer);
        String text=EventWait("UserTextInput");
        Message(who+" -> "+text);
        return text;
    }
    
    public void WaitForActionButton()
    {
        String who="WaitForActionButton";
        Message(who);
        GUI.WaitForActionButton();
        String text=EventWait("WaitForActionButton");
        Message(who+" -> "+text);
        if(text.equals(GetNextString()))
            LastWasPcNext=true;
        else
            LastWasPcNext=false;
    }
}
