package giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * InListIter is derived from EdgeListIter and provides all
 * its methods.  InListIter accesses the list of incoming
 * Edges incident to a particular Node.
 *
 * A newly created InListIter is initialized to null.
 * At some point prior to using a newly created InListIter to access the list,
 * GetFirstEdge() or GetLastEdge() must be called.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 *
 * @see Edge
 * @see EdgeListIter
 * @see OutListIter
 * @see Graph
 * @see GraphState
 * @see ListIter
 * @see LinkList
 * @see Network
 * @see Node
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */
 // 010502, dsd, fixed FirstEdge null pointer bug


/*===============================================================
===============================================================*/
public class InListIter extends EdgeListIter
{
    Node WorkingNode;

   //-----------------------------------------------------------
   /** Creates an InListIter for accessing the list of outgoing
     * Edges the given Node, initializes it to null.  In order
     * to use this InListIter to access Edges in the list,
     * GetFirstEdge() or GetLastEdge must initially be called. */
   //------------------------------------------------------------
    public InListIter(Node node, LinkList list)
    {
        super(list);
        WorkingNode=node;
    }

    //-----------------------------------------------------------
    /** Moves this InListIter to the ListEntry at the head of the
     * list and gets that ListEntry's Edge.
     * @return The first incoming edge from the Node's EdgeList*/
    //-----------------------------------------------------------
    public Edge GetFirstEdge()
    {
        Edge edge;

        edge = (Edge) GetFirstItem();
        if(edge==null)                  // check no edges
            return null;
        if(edge.IsTarget(WorkingNode))
            return edge;
        return GetNextEdge();
    }
    //-----------------------------------------------------------
    /** Moves this InListIter to the next ListEntry of the
     * listand gets that ListEntry's Edge.
     * @return The next incoming edge from the Node's EdgeList*/
    //-----------------------------------------------------------
    public Edge GetNextEdge()
    {
        Edge edge;

        while(true)
        {
            edge = (Edge) GetNextItem();
            if(edge==null)
                break;
            if(edge.IsTarget(WorkingNode))
                break;
        }
        return edge;
    }
}
