package giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * ListEntry manages links and list-items for the LinkList
 * (and its derived) classes.  The ListEntry class provides memory
 * to store a list-item (any Java Object) and links pointing
 * to the previous and next ListEntry objects in the link list.
 * ListEntry methods provide access to the links and the
 * list-item.  Users are discouraged from directly
 * accessing the ListEntry methods.  The ListIter,
 * NodeListIter, EdgeListIter, InListIter, OutListIter
 * provide simpler methods for iterating and casting list-items.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see DoubleLinkList
 * @see EdgeListIter
 * @see InListIter
 * @see LinkList
 * @see ListIter
 * @see Network
 * @see NodeListIter
 * @see OutListIter
 * @see SingleLinkList
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth

 */

/*===============================================================
===============================================================*/
public class ListEntry implements java.io.Serializable
{
    /*-----------------------------------------------------------
    -----------------------------------------------------------*/
    private Object Item;
    private ListEntry Next;
    private ListEntry Prev;

    //-----------------------------------------------------------
    /** Creates a ListEntry object containing the given list-item
     * @param item   The object to be stored in this ListEntry */
    //---------------------------------------------------------*/
    public ListEntry(Object item)
    {
        PutItem(item);
        PutNext(null);
        PutPrev(null);
    }

    //-----------------------------------------------------------
    /** Gets the ListEntry after this ListEntry
     * @return  The next ListEntry in the link list. */
    //-----------------------------------------------------------
    public ListEntry GetNext()
    {   return Next;    }

    //-----------------------------------------------------------
    /** Gets the ListEntry before this ListEntry
     * @return  The previous ListEntry in the link list. */
    //-----------------------------------------------------------
    public ListEntry GetPrev()
    {   return Prev;    }

    //-----------------------------------------------------------
    // saves the next link
    //-----------------------------------------------------------
    void PutNext(ListEntry entry)
    {   Next=entry;     }

    //-----------------------------------------------------------
    // saves the prev link
    //-----------------------------------------------------------
    void PutPrev(ListEntry entry)
    {   Prev=entry;     }

    //-----------------------------------------------------------
    /** Gets the list-item from this ListEntry
    * @return  The list item stored by this ListEntry. */
    //-----------------------------------------------------------
    public Object GetItem()
    {   return Item;    }

    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void PutItem(Object item)
    {   Item=item;      }
}

