package  giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * Queue is a first-in first-out data structure that is based on a
 * LinkList.  Objects are removed from the queue in the same
 * order that they were added to the queue.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see Network
 * @see PQList
 * @see BoundedQueue
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */



/*===============================================================
===============================================================*/
public class Queue
{
    private DoubleLinkList List;

    //-----------------------------------------------------------
    /** Creates a queue */
    //-----------------------------------------------------------
    public Queue()
    {
        List = new DoubleLinkList();
    }
    //-----------------------------------------------------------
    /** Gets the object at the top of this queue without delete
     * @return The top object.  Note this object probably needs
     *          to be cast into another type of data structure. */
    //-----------------------------------------------------------
    public Object GetTop()
    {
        Object object=null;

        ListEntry entry = List.GetFirstEntry();
        if(entry!=null)
            object = entry.GetItem();
        return object;
    }
    //-----------------------------------------------------------
    /** Gets the object at the top of this queue with delete
     * @return The top object.  Note this object probably needs
     *          to be cast into another type of data structure. */
    //-----------------------------------------------------------
    public Object Pop()
    {
        Object object=null;

        ListEntry entry = List.GetFirstEntry();
        if(entry!=null)
        {
            List.DeleteEntry(entry);
            object = entry.GetItem();
        }
        return object;
    }
    //-----------------------------------------------------------
    /** Appends the object to the end of this queue */
    //-----------------------------------------------------------
    public void Append(Object object)
    {
        List.AddItem(object);
    }

    //-----------------------------------------------------------
    /** Gets the number of elements in this queue
     * @return The size of this queue */
    //-----------------------------------------------------------
    public int GetSize()
    {
        return List.GetSize();
    }
    //-----------------------------------------------------------
    /** Tests if this queue is empty
     * @return True if the queue is empty, else false */
    //-----------------------------------------------------------
    public boolean IsEmpty()
    {
        return GetSize()==0;
    }
    //-----------------------------------------------------------
    /** Deletes the contents of this queue */
    //-----------------------------------------------------------
    public void DeleteContents()
    {
        List.DeleteContents();
    }

}
