package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.text.SimpleDateFormat;
import java.io.*;


public class GIDEN extends Applet {

    // set for expiration warning
    private boolean expires = false;
    private Date expiration_date
        = (new GregorianCalendar(1999, Calendar.JUNE, 28)).getTime(); 


    // GIDEN version and build date information
    private String version    = "3.0-alpha"; // giden version
    private Date build_date                   // build date for release
        = (new GregorianCalendar(2003, Calendar.FEBRUARY, 18)).getTime();
    private String build_host = "denali";     // build host for release

    // GIDEN file version (not necessarily tied to GIDEN version);
    // closely tied to the GUINetworkReader class
    private String fileversion  = "2.0a";     // current network file version


    // registration key variables
    public final static String defreg = "<unregistered>";


    // local flag to indicate run mode (not currently used)
    private boolean runningAsApplication;


    // GIDEN output and error streams
    public static PrintStream out = System.out;
    public static PrintStream err = System.err;


    /***********************************************************************/
    // constructor for GIDEN as an Applet
    /***********************************************************************/
    public GIDEN() {
        runningAsApplication = false;
    }

    /***********************************************************************/
    // "main" for GIDEN as an Application
    /***********************************************************************/
    public static void main (String args[]) {
        GIDEN giden = new GIDEN();
        giden.runningAsApplication = true;
        giden.init();
    }

    /***********************************************************************/
    // GIDEN initialization method
    //    - executed automatically when running as an Applet
    //    - executed from "main" when running as an Application
    /***********************************************************************/
    public void init() {
        //String regkey = initRegistrationKey();
        //checkPreferences();
        updateSystemProperties();

        GUIController controller = new GUIController();
        
        return;
        /* Forte starts and the wrong directory

        String notice = "";
        if (regkey.equals("none") || !isValidRegistrationCode(regkey)) {
            // the notice should match the situation:
            if (regkey.equals("none"))
                notice = "This copy of GIDEN has not been registered. "
                    + " An initial ";
            else
                notice = "This copy of GIDEN has an invalid registration key. "
                    + " A valid ";

            // this is the generic part of the notice:
            notice = notice.concat("registration key may be obtained through "
                + "the main GIDEN web site:\n\n\t"
                + "http://giden.nwu.edu/\n\n"
                + "An assigned registration key can be entered through the "
                + "\"System Information...\" dialog (under the \"Help\""
                + "menu).\n\nIf you are unable to complete the registration "
                + "process, send email to \"giden@iems.nwu.edu\" describing "
                + "the problem.  Be sure to include your assigned GIDEN "
                + "registration code.");

            new GUIModalMessageDialog(controller,
                                      "Registration Error...",
                                      notice,
                                      GUIModalMessageDialog.AREA_DISPLAY,
                                      GUIModalMessageDialog.CENTER_ON_WINDOW);
        }
        else {
            // save the valid registration key to the system properties
            Properties props = System.getProperties();
            props.put("giden.registration",regkey);
            System.setProperties(props);
        }

        if (expires && expiration_date.before(new Date())) {
            notice = "This version of GIDEN has expired.  "
                + "Contact \"giden@iems.nwu.edu\" for details.";

            new GUIModalMessageDialog(controller, 
                                      GUIModalMessageDialog.NOTICE,
                                      notice);
        }
         **/
    }

    /***********************************************************************/
    private void updateSystemProperties() {
        Properties props = System.getProperties();
        props.put("giden.version",version);
        props.put("giden.fileversion",fileversion);
        SimpleDateFormat df = new SimpleDateFormat("dd-MMM-yyyy",Locale.US);
        props.put("giden.build.date",df.format(build_date));
        props.put("giden.build.host",build_host);
        System.setProperties(props);
    }

    /***********************************************************************/
    private String initRegistrationKey() {
        Properties prefs = new Properties();

        try {
            FileInputStream is = new FileInputStream("./base/gdn-prefs.txt");
            if (is == null) {
                return defreg;
            }

            prefs.load(is);
            String regkey = prefs.getProperty("giden.registration","none");
            is.close();

            if (regkey.equals("none")) 
                return "none";
            else if (!isValidRegistrationCode(regkey))
                return defreg;
            else
                return regkey;
        } catch(IOException e) {
            return defreg;
        }
    }

    /***********************************************************************/
    private void checkPreferences() {
        Properties prefs = new Properties();

        try {
            FileInputStream is = new FileInputStream("./base/gdn-prefs.txt");
            if (is == null)
                return;

            prefs.load(is);

            // check for verbose stdout
            String verbose = prefs.getProperty("giden.stdout.verbose","false");
            if (verbose.equalsIgnoreCase("false"))
                out = new PrintStream(new NullOutputStream());
                // System.setOut(new PrintStream(new NullOutputStream()));

            // check for verbose stderr
            verbose = prefs.getProperty("giden.stderr.verbose","false");
            if (verbose.equalsIgnoreCase("false"))
                err = new PrintStream(new NullOutputStream());
                // System.setErr(new PrintStream(new NullOutputStream()));

            is.close();
        } catch(IOException e) {}

        return;
    }

    /***********************************************************************/
    public static boolean saveRegistrationKey(String key) {
        
        /* prefs.save is depracated
        Properties prefs = new Properties();

        try {
            // try to preload existing preferences (so we don't lose info)
            if ((new File("./base/gdn-prefs.txt")).exists()) {
                FileInputStream is = new FileInputStream("./base/gdn-prefs.txt");
                if (is != null) {
                    prefs.load(is);
                    is.close();
                }
            }

            // prepare to write preferences file
            FileOutputStream os = new FileOutputStream("./base/gdn-prefs.txt");
            if (os == null)
                return false;

            prefs.put("giden.registration",key);
            prefs.save(os,null);
            os.close();
        } catch(IOException e) {
            return false;
        }

        // update registration property
        Properties props = System.getProperties();
        props.put("giden.registration",key);
        System.setProperties(props);
        */

        return true;
    }

    /***********************************************************************/
    public static boolean isValidRegistrationCode(String code) {
        String tmp = "";
        int position = 0;

        // NOTE: The checks below depend on the GIDENreg registration
        // script at the GIDEN web site.  See that script for details
        // on the format of a valid registration code.


        // check minimal length requirements
        if (code.length() < 12) return false;        

        // check "initial code string"
        tmp = code.substring(position,++position);
        if (!tmp.equalsIgnoreCase("c") && 
            !tmp.equalsIgnoreCase("d") && 
            !tmp.equalsIgnoreCase("j"))
            return false;

        tmp = code.substring(position,++position);
        if (!tmp.equalsIgnoreCase("g") &&
            !tmp.equalsIgnoreCase("i") &&
            !tmp.equalsIgnoreCase("d") &&
            !tmp.equalsIgnoreCase("e") &&
            !tmp.equalsIgnoreCase("n"))
            return false;

        // check "num users"
        if (code.indexOf("-") == position) return false;
        tmp = code.substring(position,code.indexOf("-"));
        try {
            Integer.valueOf(tmp,16);
        } catch(NumberFormatException e) {return false;}
        position = code.indexOf("-")+1;


        // check "platform"
        if (position >= code.length()-1) return false;
        tmp = code.substring(position,++position);
        if (!tmp.equals("w") && !tmp.equals("s") &&
            !tmp.equals("u") && !tmp.equals("m") && !tmp.equals("g"))
            return false;

        // check "org type"
        if (position >= code.length()-1) return false;
        tmp = code.substring(position,++position);
        if (!tmp.equalsIgnoreCase("c") &&
            !tmp.equalsIgnoreCase("e") &&
            !tmp.equalsIgnoreCase("g") &&
            !tmp.equalsIgnoreCase("m") &&
            !tmp.equalsIgnoreCase("n") &&
            !tmp.equalsIgnoreCase("u"))
            return false;
        /*
        if (!tmp.equals("C") && !tmp.equals("E") && !tmp.equals("G") && 
            !tmp.equals("M") && !tmp.equals("N") && !tmp.equals("U"))
            return false;
        */

        // check "ip
        if (position >= code.length()-3) return false;
        tmp = code.substring(position, position+=3);
        try {
            int ival = (Integer.valueOf(tmp,10)).intValue();
            if (ival < 0 || ival > 255)
                return false; // not in valid range
        } catch(NumberFormatException e) {return false;}


        // check "planned usage" 
        if (position >= code.length()-2) return false;
        tmp = code.substring(position,position+=2);
        if (!tmp.equals("s-") && !tmp.equals("i-") && 
            !tmp.equals("r-") && !tmp.equals("t-") && !tmp.equals("o-"))
            return false; 

        // check "license number"
        if (code.length() <= position) return false;
        tmp = code.substring(position);
        if (!tmp.equalsIgnoreCase("x")) {
            try {
                Integer.valueOf(tmp,16);
            } catch(NumberFormatException e) {return false;}
        }

        return true;
    }

    /***********************************************************************/
    /***********************************************************************/
    class NullOutputStream extends OutputStream {
        public void write (int b) {}
        public void write (byte[] buf, int off, int len) {}
    }
}
