package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;

public class GUIAboutGIDEN extends Dialog implements ComponentListener,
                                              MouseListener,
                                              WindowListener
{
    private boolean about_active = false;
    public boolean isStillActive() {return about_active;}

    public void dispose() {
        about_active = false;
        super.dispose();
    }

    public GUIAboutGIDEN(Frame parent) {this(parent,true);}
    public GUIAboutGIDEN(Frame parent, boolean modal) {
        super(parent,"About GIDEN",modal);
        setResizable(false);        //990820 dsd vc3-debug-vm bug
        
        addWindowListener(this);
        setVisible(false);

        about_active = true;


        // This background change didn't work on Win95; changed main
        // image and commented out this line so that we are consistent on
        // more platforms.
        // 
        //    this.setBackground(Color.white);


        GridBagLayout gbl = new GridBagLayout();
        setLayout(gbl);

        String fontname = "Dialog";
        int    fontsize = 12;

        // initialize grid bag constraints and insets
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.insets.left = 5;
        gbc.insets.right = 5;
        gbc.insets.top = 5;
        gbc.insets.bottom = 5;

        gbc.fill = GridBagConstraints.NONE;
        gbc.anchor = GridBagConstraints.CENTER;
    




        /**************************************************
         * begin code for loading "about" image
         **************************************************/


        // media tracker for loading image
        MediaTracker tracker = new MediaTracker(this);

        // following (1) line loads image from local filesystem
        //Image logo = getToolkit().getImage("image/giden-graphic-and-title.jpg");

        // following (2) lines load image from jar file
        URL url = getClass().getResource("image/giden-graphic-and-title.jpg");
        Image logo = getToolkit().getImage(url);

        // now we just wait for the image to load before proceeding...
        tracker.addImage(logo,0);
        try{
            tracker.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }


        /**************************************************
         * end code for loading "about" image
         **************************************************/







        // place image on an "image canvas"
        GUIImageCanvas ic;
        buildGBConstraints(gbc,0,1,1,1,0,10);
        ic = new GUIImageCanvas(logo);
        gbl.setConstraints(ic,gbc);
        add(ic);
        
        
        // copyright labels
        buildGBConstraints(gbc,0,2,1,1,0,10);
        Label l = new Label("\u00A9 Copyright 1993-2003 by Coullard, Dilworth, and Owen.",Label.CENTER);
        l.setFont(new Font(fontname,Font.BOLD|Font.ITALIC,fontsize));
        if (modal) 
            l.addMouseListener(this);
        gbc.insets.bottom -= 5;
        gbl.setConstraints(l,gbc);
        gbc.insets.bottom += 5;
        add(l);
        
        buildGBConstraints(gbc,0,3,1,1,0,10);
        l = new Label("All rights reserved.",Label.CENTER);
        l.setFont(new Font(fontname,Font.BOLD|Font.ITALIC,fontsize));
        if (modal)
            l.addMouseListener(this);
        gbc.insets.top -= 5;
        gbl.setConstraints(l,gbc);
        gbc.insets.top += 5;
        add(l);


        buildGBConstraints(gbc,0,4,1,1,0,10);
//        String version = System.getProperty("giden.version","Unknown");
        l = new Label("Version 4.0 alpha",Label.CENTER);
        if (modal)
            l.addMouseListener(this);
        gbl.setConstraints(l,gbc);
        add(l);


        // pack window
        pack();
        
        // add the acknowledgement banner only after "packing" the window
        if (modal) {
            gbc.fill = GridBagConstraints.HORIZONTAL;
            buildGBConstraints(gbc,0,5,1,1,0,10);

            // acknowledgements can be shown in two ways:

            // 1. with a scrolling banner
            // GidenAcknowledgmentBanner thanks = null;
            // thanks = new GidenAcknowledgmentBanner(this);

            // or 2. with a text area
            TextArea thanks = new TextArea("",5,1,
                                           TextArea.SCROLLBARS_VERTICAL_ONLY);
            thanks.setEditable(false);
            thanks.setText("Support for the GIDEN project has been provided by the following organizations:  Office of Naval Research, Sun Microsystems, National Science Foundation, Committee on Institutional Cooperation, and Optimization Technology Center.  \n\nSeveral people have contributed to the testing of GIDEN.  We are particularly grateful to the following individuals for their helpful comments and suggestions:  Robert Fourer, Peh Ng, Susan Owen, and Donald Wagner.");
            

            gbl.setConstraints(thanks,gbc);
            add(thanks);

            // re-pack window
            pack();
        }

        // need to set location --- center on screen
        Dimension screen_size = Toolkit.getDefaultToolkit().getScreenSize(); 
        Dimension my_size = getSize();
        setLocation(new Point((screen_size.width - my_size.width)/2,
                              (screen_size.height - my_size.height)/2));

        // setResizable(false);  990820 dsd vc3-debug-vm bug


        // add listeners for window
        addComponentListener(this);
        if (modal)
            addMouseListener(this);

        // finally, make visible 
        //        setVisible(true);
        show();
    }
    
    public void close() {
        dispose();
    }

    private void buildGBConstraints(GridBagConstraints gbc, int gx, int gy,
                                    int gw, int gh, int wx, int wy) {
        gbc.gridx = gx;
        gbc.gridy = gy;
        gbc.gridwidth = gw;
        gbc.gridheight = gh;
        gbc.weightx = wx;
        gbc.weighty = wy;
    }
    
    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt) {dispose();}
    public void mousePressed(MouseEvent evt) {dispose();}
    public void mouseReleased(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt) {
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public void mouseExited(MouseEvent evt) {}

    /**********************************************************************/
    // component listener methods
    /**********************************************************************/
    public void componentResized(ComponentEvent evt) {
        if (isShowing()) {
            pack(); 
            UTILITIES.Repaint(this, "componentResized");
        }
    }
    public void componentMoved(ComponentEvent evt)   {
        //        if (isShowing()) {
        //            pack(); 
        //            UTILITIES.Repaint(this, "componentMoved");
        //        }
    }
    public void componentShown(ComponentEvent evt)   {
        //        pack(); 
        //        UTILITIES.Repaint(this, "componentShown");
    }
    public void componentHidden(ComponentEvent evt)  {
        //        pack(); 
        //        UTILITIES.Repaint(this, "componentHidden");
    }
    
    /**********************************************************************/
    // window listener methods
    /**********************************************************************/
    public void windowActivated(WindowEvent evt)   {}
    public void windowClosed(WindowEvent evt)      {}
    public void windowClosing(WindowEvent evt)     {dispose();}
    public void windowDeactivated(WindowEvent evt) {}
    public void windowDeiconified(WindowEvent evt) {}
    public void windowIconified(WindowEvent evt)   {}
    public void windowOpened(WindowEvent evt)      {}
}


/*public*/ class GidenAcknowledgmentBanner extends Component implements Runnable,
                                                             MouseListener,
                                                             MouseMotionListener {

    Image backBuffer = null;
    Graphics backG;

    String support = "Support for the GIDEN project has been provided by the following organizations:  Office of Naval Research, Sun Microsystems, National Science Foundation, Committee on Institutional Cooperation, and Optimization Technology Center.  ";

    String orgs[] = {"Office of Naval Research",
                     "Sun Microsystems",
                     "National Science Foundation",
                     "Committee on Institutional Cooperation",
                     "Optimization Technology Center"};

    String thanks = "Several people have contributed to the testing of GIDEN.  We are particularly grateful to the following individuals for their helpful comments and suggestions:  Robert Fourer, Peh Ng, Susan Owen, and Donald Wagner.  ";

    String people[] = {"Robert Fourer",
                       "Peh Ng",
                       "Susan Owen",
                       "Donald Wagner"};


    String str = new String(support+thanks);

    Font strFont;
    FontMetrics strFM;
    int width;
    int height;
    int xpos;

    int imagewidth;

    GUIAboutGIDEN parent;

    public Dimension getPreferredSize() {return new Dimension(width,height);}

    GidenAcknowledgmentBanner(GUIAboutGIDEN parent) {
        addMouseListener(this);
        addMouseMotionListener(this);

        this.parent = parent;

        strFont = new Font("Dialog", Font.BOLD, 10);
        strFM = getFontMetrics(strFont);

        this.width = parent.getBounds().width;
        this.height = strFM.getHeight();
        this.xpos = 0;

        setupBannerImage();
        (new Thread(this)).start();
    }

    private void setupBannerImage() {
        int w = width + strFM.stringWidth(str);
        int h = height;

        imagewidth = w;

        backBuffer = createImage(w,h);
        if (backBuffer != null) {
            backG = backBuffer.getGraphics();
            backG.setFont(strFont);

            backG.clearRect(0,0,w,h);
            int x = width;
            int y = strFM.getAscent()+strFM.getLeading();

            //            backG.setColor(new Color(16,16,248)); // blue
            backG.setColor(Color.blue);
            backG.drawString(str, x, y);
            x += strFM.stringWidth(str);


            /*
            // color organizations and individual names
            int idx;
            // backG.setColor(new Color(248,16,16)); // red
            backG.setColor(new Color(16,100,16)); // green
            for (int i=0 ; i < orgs.length ; i++) {
                idx = str.indexOf(orgs[i]);
                if (idx >= 0) {
                    x = width+strFM.stringWidth(str.substring(0,idx));
                    backG.drawString(orgs[i],x,y);
                }
            }
            for (int i=0 ; i < people.length ; i++) {
                idx = str.indexOf(people[i]);
                if (idx >= 0) {
                    x = width+strFM.stringWidth(str.substring(0,idx));
                    backG.drawString(people[i],x,y);
                }
            }
            */
        }
    }

    public void paint(Graphics g) {update(g);}
    public void update(Graphics g) {
        if (backBuffer == null)
            setupBannerImage();

        if (backBuffer != null)
            g.drawImage(backBuffer,0,0,width,height,
                        xpos,0,xpos+width,height,null);
    }

    private boolean paused=false;
    private int pause_xpos, pauseX;
    public void run() {
        while (parent.isStillActive()) {
            if (!paused && parent.isShowing()) {
                if (++xpos >= imagewidth)
                    xpos = 0;

                //                UTILITIES.Repaint(this,"run");
                repaint();
            }
            try {Thread.sleep(20); } catch(Exception e) {};
        }
    }

    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt) {}
    public void mousePressed(MouseEvent evt) {
        paused=true; 
        pause_xpos = xpos;
        pauseX = evt.getX();
        evt.consume();
    }
    public void mouseReleased(MouseEvent evt) {
        paused=false;
    }
    public void mouseEntered(MouseEvent evt) {
        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    }
    public void mouseExited(MouseEvent evt) {}

    /**********************************************************************/
    // mouse motion listener methods
    /**********************************************************************/
    public void mouseMoved(MouseEvent evt) {}
    public void mouseDragged(MouseEvent evt) {
        xpos = pause_xpos + (pauseX-evt.getX());
        if (xpos >= imagewidth || xpos < 0)
            xpos = 0;
        UTILITIES.Repaint(this,"mouseDragged");
    }
}
