package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;

public class GUICanvasGrid extends Component {
    
    private GUIDrawCanvas canvas = null;
    private Color gridcolor = new Color(20,191,241); // light Carolina blue!  
    private int gridskip = 20;
    private int dashskip = 3;
    
    GUICanvasGrid(GUIDrawCanvas canvas) {
        this.canvas = canvas;
    }
    
    public Point getNearestGridPoint(Point p) {
        return getNearestGridPoint(p.x,p.y);
    }
    public Point getNearestGridPoint(int x, int y) {
        int offsetX = x%gridskip;
        int offsetY = y%gridskip;
        
        int numgridX = (offsetX <= gridskip/2) ? (x/gridskip) : (x/gridskip)+1;
        int numgridY = (offsetY <= gridskip/2) ? (y/gridskip) : (y/gridskip)+1;
        
        /*
          offsetX = (offsetX <= gridskip/2) ? 0 : gridskip;
          offsetY = (offsetY <= gridskip/2) ? 0 : gridskip;
        */
        
        return new Point(gridskip*numgridX, gridskip*numgridY);
    }
    
    public void draw(Graphics g) {
        if (isVisible()) {
            int canvas_width = canvas.getBounds().width;
            int canvas_height = canvas.getBounds().height;
            
            g.setColor(gridcolor);
            for (int i=0 ; i < canvas_width ; i+= gridskip)
                for (int j=0 ; j < canvas_height ; j+=(2*dashskip))
                    //    g.drawLine(i,0,i,canvas_height);
                    g.drawLine(i,j,i,j+dashskip);
            
            for (int i=0 ; i < canvas_height ; i+= gridskip)
                for (int j=0 ; j < canvas_width ; j+=(2*dashskip))
                    //      g.drawLine(0,i,canvas_width,i);
                    g.drawLine(j,i,j+dashskip,i);
        }
    }
}
