package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.image.*;


public class GUIColorFilter extends ImageFilter implements java.io.Serializable {
    ColorModel transColorModel;
    
    Color base = new Color(255,0,0);
    float[] HSB = Color.RGBtoHSB(255,0,0,null);
    
    float sel_H = HSB[0];
    float sel_S = HSB[1];
    float sel_B = HSB[2];
    
    Color getBaseColor() {
        return base;
    }
    
    void setBaseColor(Color c) {
        Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), HSB);
        sel_H = HSB[0];
        sel_S = HSB[1];
        sel_B = HSB[2];
        base = c;
    }
    
    public void setColorModel(ColorModel model) {
        float[] hsb = new float[3];
        Color c;
        
        if (model instanceof IndexColorModel) {
            IndexColorModel icm = (IndexColorModel)model;
            byte[] alphas = new byte[icm.getMapSize()];
            byte[] cmap = new byte[icm.getMapSize() * 4];
            float[] brightness = new float[icm.getMapSize()];
            
            icm.getAlphas(alphas);
            
            float z = (float) 0.01;
            for (int i=0 ; i < icm.getMapSize() ; i++) {
                if (i != icm.getTransparentPixel()) {
                    Color.RGBtoHSB(icm.getRed(i),icm.getGreen(i),icm.getBlue(i),hsb);
                    brightness[i] = hsb[2];
                    if (brightness[i] > z)
                        z = brightness[i];
                }
            }
            
            int j = 0;
            for (int i=0; i<icm.getMapSize(); i++) {
                c = Color.getHSBColor(sel_H, sel_S, (brightness[i]*sel_B/z));
                cmap[j++] = (byte) c.getRed();
                cmap[j++] = (byte) c.getGreen();
                cmap[j++] = (byte) c.getBlue();
                cmap[j++] = alphas[i];
            }
            transColorModel = new IndexColorModel(icm.getPixelSize(),
                                                  icm.getMapSize(), cmap, 0, true, icm.getTransparentPixel());
        } 
        else {
            transColorModel = model;
        }
        consumer.setColorModel(transColorModel);
    }
    
    public void setPixels(int x, int y, int w, int h, ColorModel model, 
                          byte pixels[], int off, int scansize) {
        consumer.setPixels(x, y, w, h, transColorModel, pixels, off, scansize);
    }
    
    public void setPixels(int x, int y, int w, int h, ColorModel model, 
                          int pixels[], int off, int scansize) {
        consumer.setPixels(x, y, w, h, transColorModel, pixels, off, scansize);
    }
}
