package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;

public class GUIEdge extends Component implements UiEdge,
                                           ActionListener,
                                           //      KeyListener,
                                           MouseListener,
                                           MouseMotionListener {

    private static final int THRESHOLD_FOR_SPLINE = 3;
    private static final int spline_width = 6;
    private static final int spline_height = 6;
    private static final int label_offset_from_spline = 10;
    
    /*private*/ GUIEdgeInfo gui_edge_info;  // dropped "private", dsd 000705
    
    /***********************************************************************/
    // Constructor methods
    /***********************************************************************/
    GUIEdge() {
        //    addKeyListener(this);
        addMouseListener(this);
        addMouseMotionListener(this);
        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    }
    
    GUIEdge(GUIEdgeInfo info) {
        this();
        PutInfo(info);
    }

    public final static int DEFAULT_EDGE_STYLE = 0;
    public final static int THIN_EDGE_STYLE    = 1;

    GUIEdge(GUIController gui_controller,
            GUIDrawCanvas canvas,
            boolean       directed,
            boolean       visible,
            Font          font,
            String        label,
            Color         color,
            int           thickness) {
        this();
        
        PutInfo(new GUIEdgeInfo(gui_controller, canvas, directed, visible, 
                                font, label, color, thickness));
    }
    /***********************************************************************/
    // Info management methods
    /***********************************************************************/
    synchronized public void PutInfo(GUIEdgeInfo info) {
        GUIEdgeInfo temp = info.Clone();
        if (temp != null)
            this.gui_edge_info = temp;
    }
    
    synchronized public GUIEdgeInfo GetInfo() {
        return gui_edge_info.Clone();
    }
    
    synchronized public void PutUiInfo(UiEdgeInfo info)
    {
        GUIEdgeInfo gui = GetInfo();
        //        gui.directed=info.directed;
        gui.color=info.color;
        gui.label=info.label;
        gui.visible=info.visible;
        gui.splineX=info.splineX;
        gui.splineY=info.splineY;
        gui.spline_positioned=info.spline_positioned;
        gui.label_position = info.label_position;
        
        PutInfo(gui);
    }
    
    synchronized public UiEdgeInfo GetUiInfo() // dsd 990314
    {
        return ((UiEdgeInfo)gui_edge_info).UiClone();
    }
    
    
    /***********************************************************************/
    /***********************************************************************/
    synchronized public void updateTool(int tool) {
        GUIEdgeInfo info = GetInfo();    
        info.current_tool = tool;
        PutInfo(info);
    }
    
    
    /***********************************************************************/
    synchronized public Edge GetEdge() {return GetEdge(gui_edge_info);}
    synchronized private Edge GetEdge(GUIEdgeInfo info) {   // 990314 dsd, was getEdge()
        return info.edge;
    }
    
    synchronized public void PutEdge(Edge e) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;

        // set edge
        info.edge = e;
        PutInfo(info);      // must update edge before calling CoreNet;

        // position edge spline point
        //        GUINetwork uinet = info.canvas.UiNet;
        //        Point p1 = uinet.GetSource(this).getCenterPoint();
        //        Point p2 = uinet.GetTarget(this).getCenterPoint();
        //        info.setSplinePoint(new Point((p1.x+p2.x)/2, (p1.y+p2.y)/2));
        //        PutInfo(info);
    }
    
    
    /***********************************************************************/
    synchronized public boolean isDirected() {return isDirected(gui_edge_info);}
    synchronized private boolean isDirected(GUIEdgeInfo info) {
        return info.directed;
    }
    
    synchronized public void setDirected(boolean directed) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setDirected(directed,info);
        PutInfo(info);
    }
    synchronized private void setDirected(boolean directed, GUIEdgeInfo info) {
        info.directed = directed;
    }
    
    
    /***********************************************************************/
    synchronized public boolean isVisible() {return isVisible(gui_edge_info);}
    synchronized private boolean isVisible(GUIEdgeInfo info) {
        return info.visible;
    }
    
    synchronized public void setVisible(boolean visible) {    
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setVisible(visible,info);
        PutInfo(info);
    }
    synchronized private void setVisible(boolean visible, GUIEdgeInfo info) {
        info.visible = visible;
    }
    
    
    /***********************************************************************/
    synchronized public Font getFont() {return getFont(gui_edge_info);}
    synchronized private Font getFont(GUIEdgeInfo info) {
        return info.font;
    }
    
    synchronized public void setFont(Font font) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setFont(font,info);
        PutInfo(info);
    }
    synchronized private void setFont(Font font, GUIEdgeInfo info) {
        info.font = font;
    }
    
    
    /***********************************************************************/
    synchronized public String getLabel() {return getLabel(gui_edge_info);}
    synchronized private String getLabel(GUIEdgeInfo info) {
        return new String(info.label);
    }
    
    synchronized public void setLabel(String label) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setLabel(label,info);
        PutInfo(info);
    }
    synchronized private void setLabel(String label, GUIEdgeInfo info) {
        info.label = new String(label);
    }
    
    
    /***********************************************************************/
    synchronized public Color getColor() {return getColor(gui_edge_info);}
    synchronized private Color getColor(GUIEdgeInfo info) {
        return info.color;
    }
    
    synchronized public void setColor(Color color) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setColor(color,info);
        PutInfo(info);
    }
    synchronized private void setColor(Color color, GUIEdgeInfo info) {
        info.color = color;
    }
    
    
    /***********************************************************************/
    synchronized public int getThickness() {return getThickness(gui_edge_info);}
    synchronized private int getThickness(GUIEdgeInfo info) {
        return info.thickness;
    }
    
    synchronized public void setThickness(int thickness) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        setThickness(thickness,info);
        PutInfo(info);
    }
    synchronized private void setThickness(int thickness, GUIEdgeInfo info) {
        info.thickness = thickness;
    }
    
    
    /***********************************************************************/
    /***********************************************************************/
    synchronized public void draw(Graphics g) {
        GUIEdgeInfo info = GetInfo();
        if (info == null || info.edge == null || !info.visible) return;
        
        GUINetwork uinet = info.canvas.UiNet;
        if (uinet.GetSource(this) == null)
            GIDEN.out.println("uinet.GetSource(this) returns null");
        if (uinet.GetTarget(this) == null)
            GIDEN.out.println("uinet.GetTarget(this) returns null");
        
        Point c1 = uinet.GetSource(this).getCenterPoint();
        Point c2 = uinet.GetTarget(this).getCenterPoint();
        
        Point sp = getSplinePoint();
        
        drawInterpolatedSpline(g, c1, sp, c2, info);
        
        if (info.directed)
            drawArrow(g);
        
        if (info.current_tool == GUIController.EDIT_VALUES_TOOL ||
            info.current_tool == GUIController.DELETE_ITEM_TOOL ||
            info.current_tool == GUIController.MOVE_SELECTED_TOOL ||
            // obsolete; from when we had a "move edge label tool..."
            //        info.current_tool == GUIController.MOVE_EDGE_LABEL_TOOL ||
            info.current_tool == GUIController.REVERSE_EDGE_TOOL ||
            info.current_tool == GUIController.SELECT_ITEM_TOOL)
            drawSplinePoint(g,info);
        
        if (info.textfield_panel != null)
            drawLabelEditPanel(g,info);
        else
            drawLabel(g,info);
    }
    
    /***********************************************************************/
    /***********************************************************************/
    public boolean contains(Point pt) {return contains(pt.x,pt.y);}
    public boolean contains(int x, int y) {
        return isNearSplinePoint(x,y) || isNearLabel(x,y);
    }
    
    private boolean isNearSplinePoint(Point pt) {
        return isNearSplinePoint(pt.x,pt.y);
    }
    synchronized private boolean isNearSplinePoint(int x, int y) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return false;
        
        if (info.current_tool == GUIController.UNKNOWN_TOOL) return false;
        
        if (info.current_tool == GUIController.REVERSE_EDGE_TOOL ||
            info.current_tool == GUIController.DELETE_ITEM_TOOL ||
            info.current_tool == GUIController.MOVE_SELECTED_TOOL ||
            info.current_tool == GUIController.EDIT_VALUES_TOOL ||
            info.current_tool == GUIController.SELECT_ITEM_TOOL) {

            Point sp = getSplinePoint();
            return (sp.x-spline_width <= x && 
                    x <= sp.x+spline_width &&
                    sp.y-spline_height <= y &&
                    y <= sp.y+spline_height);
        }
        else
            return false;
    }
    
    private boolean isNearLabel(Point pt) {return isNearLabel(pt.x,pt.y);}
    synchronized private boolean isNearLabel(int x, int y) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return false;
        
        Graphics g = info.canvas.getGraphics();
        if (g == null) return false;
        FontMetrics fm = g.getFontMetrics(info.font);
        
        int label_width = fm.stringWidth(info.label);
        int label_height = (label_width > 0) ? fm.getAscent() : 0;
        
        Point sp = getSplinePoint();

        switch (info.label_position) {
        case GUIEdgeInfo.LABEL_NORTH:
            return (sp.y-label_offset_from_spline-label_height <= y &&
                    y <= sp.y-label_offset_from_spline &&
                    sp.x-(label_width/2) <= x &&
                    x <= sp.x+(label_width/2));
            
        case GUIEdgeInfo.LABEL_SOUTH:
            return (sp.y+label_offset_from_spline <= y &&
                    y <= sp.y+label_offset_from_spline+label_height &&
                    sp.x-(label_width/2) <= x &&
                    x <= sp.x+(label_width/2));
            
        case GUIEdgeInfo.LABEL_EAST:
            return (sp.x+label_offset_from_spline <= x &&
                    x <= sp.x+label_offset_from_spline+label_width &&
                    sp.y-(label_height/2) <=y &&
                    y <= sp.y+(label_height/2));
            
        case GUIEdgeInfo.LABEL_WEST:
            return (sp.x-label_offset_from_spline-label_width <= x &&
                    x <= sp.x-label_offset_from_spline &&
                    sp.y-(label_height/2) <=y &&
                    y <= sp.y+(label_height/2));
            
        default:
            GIDEN.out.println("Error!  Undefinied label position for GUIEdge.");
            return false;
        }
    }
    
    /***********************************************************************/
    /***********************************************************************/
    public void shiftSpline(int dx, int dy) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;

        Point sp = getSplinePoint();
        info.setSplinePoint(new Point(sp.x+dx, sp.y+dy));
        PutInfo(info);
    }
    
    synchronized public Point getSplinePoint() {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return null;

        if (info.spline_positioned)
            return info.getSplinePoint();
        else {
            // return straight edge center point
            GUINetwork uinet = info.canvas.UiNet;
            if(uinet.GetSource(this)==null) // trap null
                info=info;                  // nonsense breakpoint
            Point p1 = uinet.GetSource(this).getCenterPoint();
            Point p2 = uinet.GetTarget(this).getCenterPoint();
            return new Point((p1.x+p2.x)/2, (p1.y+p2.y)/2);
        }
    }
    //    synchronized public Point getSplinePoint() {
    //        GUIEdgeInfo info = GetInfo();
    //        if (info == null) return null;
    //
    //        return getSplinePoint();
    //    }


    synchronized private void setSplinePoint(int x, int y) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;

        info.setSplinePoint(new Point(x,y));
        PutInfo(info);
    }
    
    
    
    /***********************************************************************/
    /***********************************************************************/
    private void processLabelEditPanel() {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;

        // save text value
        String value = info.textfield.getText();

        // tidy up textfield first (to avoid problems from synchronization)
        info.canvas.remove(info.textfield_panel);
        info.textfield = null;
        info.textfield_panel = null;
        PutInfo(info);
        
        // update data and (subsequently) the info
        info.canvas.setEdgeDataField(this, value, info);
        PutInfo(info);

        //        info.canvas.repaint();
        UTILITIES.Repaint(info.canvas, " -- GUIEdge:processLabelEditPanel");
    }
    synchronized private void buildLabelEditPanel(GUIEdgeInfo info) {
        if (info == null) return;
        
        info.textfield_panel = new Panel();
        info.textfield_panel.setLayout(new GridLayout(1,1));
        info.textfield = new TextField(info.label,
                                       (info.label.length() > 0)?info.label.length():2);
        info.textfield.addActionListener(this);
        info.textfield_panel.add(info.textfield);
        info.canvas.add(info.textfield_panel);

        PutInfo(info);
        
        //        info.canvas.repaint();
        UTILITIES.Repaint(info.canvas, " -- GUIEdge:buildLabelEditPanel");
    }
    
    
    /***********************************************************************/
    /***********************************************************************/
    private synchronized void drawLabelEditPanel(Graphics g,
                                                 GUIEdgeInfo info) {
        int label_offset_X;
        int label_offset_Y;
        
        g.setFont(info.font); // don't save the original font... this may be bad
        FontMetrics fm = g.getFontMetrics();
        
        int label_height = fm.getAscent();
        int label_width = fm.stringWidth(info.label);
        
        // calculate offset for center of label
        switch (info.label_position) {
        case GUIEdgeInfo.LABEL_NORTH:
            label_offset_X = 0;
            label_offset_Y = -(label_offset_from_spline+(label_height/2));
            break;
            
        case GUIEdgeInfo.LABEL_SOUTH:
            label_offset_X = 0;
            label_offset_Y = label_offset_from_spline+(label_height/2);
            break;
            
        case GUIEdgeInfo.LABEL_EAST:
            label_offset_X = label_offset_from_spline+(label_width/2);
            label_offset_Y = 0;
            break;
            
        case GUIEdgeInfo.LABEL_WEST:
            label_offset_X = -(label_offset_from_spline+(label_width/2));
            label_offset_Y = 0;
            break;
            
        default:
            GIDEN.out.println("Error!  Undefinied label position for GUIEdge.");
            return;
        }
        
        
        Color def_color = g.getColor();
        g.setColor(Color.black);
        info.textfield_panel.setFont(info.font);
        info.textfield_panel.doLayout();
        
        Point sp = getSplinePoint();
        Dimension tfp_size = info.textfield_panel.getPreferredSize();
        info.textfield_panel.setSize(tfp_size);
        info.textfield_panel.setLocation(sp.x+label_offset_X-(tfp_size.width/2),
                                         sp.y+label_offset_Y-(tfp_size.height/2));
        info.textfield.setCaretPosition(0);
        info.textfield.selectAll();
        info.textfield.requestFocus();
        g.setColor(def_color);
    }
    
    
    private synchronized void drawSplinePoint(Graphics g, GUIEdgeInfo info) {
        // don't draw spline point in solver mode
        if (info.canvas.inSolverMode()) return;

        Point sp = getSplinePoint();

        if (info.spline_positioned) {
            g.setColor(new Color(0,92,144)); // blue from controller buttons
            g.fillRect(sp.x-(spline_width/2), sp.y-(spline_height/2),
                       spline_width, spline_height);
        }

        g.setColor(info.color);
        g.drawRect(sp.x-(spline_width/2), sp.y-(spline_height/2),
                   spline_width, spline_height);
    }
    
    
    private void drawInterpolatedSpline(Graphics g, Point p1, Point p2, 
                                        Point p3, GUIEdgeInfo info) {
        drawInterpolatedSpline(g, p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, info);
    }
    private void drawInterpolatedSpline(Graphics g,
                                        int x1, int y1,
                                        int xb, int yb,
                                        int x3, int y3,
                                        GUIEdgeInfo info) {
        
        int xa, ya, x2, y2, xc, yc;
        int xp, yp;
        
        x2 = (int) (2.0*(xb-((x1+x3)/4.0)));
        y2 = (int) (2.0*(yb-((y1+y3)/4.0)));
        
        xa = (x1+x2)/2;
        ya = (y1+y2)/2;
        xc = (x2+x3)/2;
        yc = (y2+y3)/2;
        
        xp = (x1+xb)/2;
        yp = (y1+yb)/2;
        if (Math.abs(xa-xp)+Math.abs(ya-yp) > THRESHOLD_FOR_SPLINE)
            drawSpline(g,x1,y1,xa,ya,xb,yb,info);
        else
            modifyAndDrawLine(g,x1,y1,xb,yb,info);
        
        xp = (x3+xb)/2;
        yp = (y3+yb)/2;
        if (Math.abs(xc-xp)+Math.abs(yc-yp) > THRESHOLD_FOR_SPLINE)
            drawSpline(g,xb,yb,xc,yc,x3,y3,info);
        else
            modifyAndDrawLine(g,xb,yb,x3,y3,info);
    }
    
    private void drawSpline(Graphics g, Point p1, Point p2, Point p3, 
                            GUIEdgeInfo info) {
        drawSpline(g, p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, info);
    }
    private void drawSpline(Graphics g,
                            int x1, int y1,
                            int x2, int y2,
                            int x3, int y3,
                            GUIEdgeInfo info) {
        
        int xa, ya, xb, yb, xc, yc;
        int xp, yp;
        
        xa = (x1+x2)/2;
        ya = (y1+y2)/2;
        xc = (x2+x3)/2;
        yc = (y2+y3)/2;
        xb = (xa+xc)/2;
        yb = (ya+yc)/2;
        
        xp = (x1+xb)/2;
        yp = (y1+yb)/2;
        if (Math.abs(xa-xp)+Math.abs(ya-yp) > THRESHOLD_FOR_SPLINE)
            drawSpline(g,x1,y1,xa,ya,xb,yb,info);
        else
            modifyAndDrawLine(g,x1,y1,xb,yb,info);
        
        xp = (x3+xb)/2;
        yp = (y3+yb)/2;
        if (Math.abs(xc-xp)+Math.abs(yc-yp) > THRESHOLD_FOR_SPLINE)
            drawSpline(g,xb,yb,xc,yc,x3,y3,info);
        else
            modifyAndDrawLine(g,xb,yb,x3,y3,info);
    }
    
    protected void drawArrow(Graphics g) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        Polygon p = new Polygon();
        
        double sine = Math.sin(-info.arrow_rotation_angle);
        double cosine = Math.cos(-info.arrow_rotation_angle);
        
        int numpoints = 4;
        int scale = 2;
        int ptX[] = {0, -10, -7, -10};
        int ptY[] = {0,  -5,  0,   5};
        
        for (int i=0 ; i < numpoints ; i++) {
            ptX[i] *= scale;
            ptY[i] *= scale;
            
            p.addPoint((int) (ptX[i]*cosine - ptY[i]*sine),
                       (int) (ptX[i]*sine + ptY[i]*cosine));
        }
        
        p.translate(info.arrowX, info.arrowY);
        
        g.setColor(info.color);
        g.fillPolygon(p);
    }
    
    
    protected void modifyAndDrawLine(Graphics g, Point p1, 
                                     Point p2, GUIEdgeInfo info) {
        modifyAndDrawLine(g, p1.x, p1.y, p2.x, p2.y, info);
    }
    protected void modifyAndDrawLine(Graphics g,
                                     int x1, int y1,
                                     int x2,int y2,
                                     GUIEdgeInfo info) {
        
        GUINetwork uinet = info.canvas.UiNet;
        GUINode e1 = uinet.GetSource(this);
        GUINode e2 = uinet.GetTarget(this);
        
        if ((e1.contains(x1,y1) && e1.contains(x2,y2)) ||
            (e2.contains(x1,y1) && e2.contains(x2,y2))) {
            return; // don't draw the line segment
        }
        
        if (e1.contains(x1,y1)) {
            Point p = relocatePointFromGUINode(e1,x1,y1,x2,y2);
            x1 = p.x; y1 = p.y;
        }
        
        if (e2.contains(x2,y2)) {
            
            if (info.directed) {
                // Calculate rotation angle for arrow
                //    -  calculate angle in right triangle corresponding to
                //         (x1,y1), (x2,y1), (x2,y2)
                double dy = (double) (y2-y1);
                double dx = (double) (x2-x1);
                double theta = Math.asin(dy/(Math.sqrt(dy*dy + dx*dx)));
                
                //    - calculate rotation angle based on quadrant
                if (x2 >= x1)
                    info.arrow_rotation_angle = -theta;
                else
                    info.arrow_rotation_angle = Math.PI + theta;
            }
            
            // Relocate and update (x2,y2), and draw arrow
            Point p = relocatePointFromGUINode(e2,x2,y2,x1,y1);
            x2 = p.x; y2 = p.y;
            
            if (info.directed) {
                info.arrowX = p.x;
                info.arrowY = p.y;
                PutInfo(info);
            }
        }
        
        //    g.drawLine(x1,y1,x2,y2);
        GraphicsUtil.drawLine(g,x1,y1,x2,y2,info.thickness,info.color);
    }
    
    
    
    private Point relocatePointFromGUINode(GUINode p,
                                           int xa, int ya,
                                           int xb, int yb) {
        double dx = ((double) (xb-xa));
        double dy = ((double) (yb-ya));
        
        double scale = Math.abs(dx);
        if (scale < Math.abs(dy))
            scale = Math.abs(dy);
        dx /= scale;
        dy /= scale;
        
        
        double tx = (double) xa;
        double ty = (double) ya;
        
        do {
            tx += dx;
            ty += dy;
        } while (p.contains((int) tx, (int) ty));
        
        return new Point((int) tx, (int) ty);
    }
    
    
    protected void drawLabel(Graphics g, GUIEdgeInfo info) { 
        int label_offset_X;
        int label_offset_Y;
        FontMetrics fm = g.getFontMetrics();
        
        Color def_color = g.getColor();
        g.setColor(Color.black);
        switch (info.label_position) {
        case GUIEdgeInfo.LABEL_NORTH:
            label_offset_X = -fm.stringWidth(info.label)/2;
            label_offset_Y = -label_offset_from_spline;
            break;
            
        case GUIEdgeInfo.LABEL_SOUTH:
            label_offset_X = -fm.stringWidth(info.label)/2;
            label_offset_Y = label_offset_from_spline+fm.getAscent();
            break;
            
        case GUIEdgeInfo.LABEL_EAST:
            label_offset_X = label_offset_from_spline;
            label_offset_Y = fm.getAscent()/2;
            break;
            
        case GUIEdgeInfo.LABEL_WEST:
            label_offset_X = -(label_offset_from_spline+fm.stringWidth(info.label));
            label_offset_Y = fm.getAscent()/2;
            break;
            
        default:
            GIDEN.out.println("Error!  Undefinied label position for GUIEdge.");
            return;
        }
        
        Point sp = getSplinePoint();
        g.setFont(info.font); // don;t save default font ... this may be bad
        g.drawString(info.label, sp.x+label_offset_X, sp.y+label_offset_Y);
        g.setColor(def_color);
    }
    
    
    /***********************************************************************/
    /***********************************************************************/
    
    
    /***********************************************************************/
    /***********************************************************************/
    public boolean isFocusTraversable() {return false;}

    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource().equals(gui_edge_info.textfield) && 
            gui_edge_info.textfield_panel != null)
            processLabelEditPanel();
    }
    
    public void mouseClicked(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt) {} 
    public void mouseExited(MouseEvent evt) {
        if (!(this.contains(evt.getX(),evt.getY())) && 
            gui_edge_info.textfield_panel != null)
            processLabelEditPanel();
    }
    public void mousePressed(MouseEvent evt) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        if (info.canvas.inSolverMode()) {
            info.canvas.registerSolverModeMouseSelection(this,evt.getModifiers());
            //      info.canvas.registerSolverEdgeSelection(this,evt.getModifiers());
            return;
        }
        
        if (info.current_tool == GUIController.UNKNOWN_TOOL) return;
        
        int selX = evt.getX();
        int selY = evt.getY();
        
        if (info.current_tool == GUIController.MOVE_SELECTED_TOOL) {
            if ((evt.getModifiers() & InputEvent.SHIFT_MASK) != 0) {
                if (info.spline_positioned) {
                    // straighten out GUIEdge
                    info.spline_positioned = false;
                    PutInfo(info);
                    UTILITIES.Repaint(info.canvas," -- GUIEdge:mousePressed (1)");
                    // info.canvas.repaint();
                }
                return;
            }
            
            if (isNearSplinePoint(selX,selY)) {
                // get the existing spline point (possibly calculated
                // rather than positioned)
                Point sp = getSplinePoint();

                // make sure that spline is really positioned
                info.setSplinePoint(sp);
                info.spline_selected = true;
                info.sel_offset_X = selX-sp.x;
                info.sel_offset_Y = selY-sp.y;
                PutInfo(info);
                UTILITIES.Repaint(info.canvas," -- GUIEdge:mousePressed (2)");
                //info.canvas.repaint(); // repaint to show anchored spline point
            }
            else if (isNearLabel(selX,selY)) {
                info.label_selected = true;
                PutInfo(info);
            }
        }
        else if (info.current_tool == GUIController.EDIT_VALUES_TOOL) {
            if (info.canvas.displayedEdgeDataIsEditable())
                buildLabelEditPanel(info);
            else
                GIDEN.out.println("Displayed edge data is not editable!");
        }
        // obsolete; from when we had a "move edge label tool..."
        //    else if (info.current_tool == GUIController.MOVE_EDGE_LABEL_TOOL) {
        //      if (isNearLabel(selX,selY)) {
        //        info.label_selected = true;
        //        PutInfo(info);
        //      }
        //    }
        else if (info.current_tool == GUIController.DELETE_ITEM_TOOL ||
                 info.current_tool == GUIController.REVERSE_EDGE_TOOL) {
            info.canvas.registerEdgeSelection(this,evt.getModifiers());
        }
        else if (info.current_tool == GUIController.SELECT_ITEM_TOOL) {
            Point sp = getSplinePoint();

            info.sel_offset_X = selX-sp.x;
            info.sel_offset_Y = selY-sp.y;
            PutInfo(info);
            
            if ((evt.getModifiers() & InputEvent.BUTTON2_MASK) == 0 &&
                (evt.getModifiers() & InputEvent.CTRL_MASK) == 0)
                info.canvas.registerEdgeSelection(this,evt.getModifiers());
        }
    }
    
    
    public void mouseReleased(MouseEvent evt) {
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        if (info.current_tool == GUIController.UNKNOWN_TOOL) return;
        
        if (info.current_tool == GUIController.MOVE_SELECTED_TOOL) {
            info.spline_selected = false;
            info.label_selected = false;
        }
        // obsolete; from when we had a "move edge label tool..."
        //    else if (info.current_tool == GUIController.MOVE_EDGE_LABEL_TOOL) {
        //      info.label_selected = false;
        //    }
        
        PutInfo(info);
    }
    
    public void mouseMoved(MouseEvent evt) {}
    public void mouseDragged(MouseEvent evt) {
        
        GUIEdgeInfo info = GetInfo();
        if (info == null) return;
        
        int selX = evt.getX();
        int selY = evt.getY();
        
        // obsolete; from when we had a "move edge label tool..."
        //    if (info.current_tool == GUIController.MOVE_SELECTED_TOOL ||
        //  info.current_tool == GUIController.MOVE_EDGE_LABEL_TOOL) {
        if (info.current_tool == GUIController.MOVE_SELECTED_TOOL) {
            if (info.spline_selected) {
                setSplinePoint(selX-info.sel_offset_X, selY-info.sel_offset_Y);
                UTILITIES.Repaint(info.canvas," -- GUIEdge:mouseDragged (1)");
                // info.canvas.repaint();
            }
            else if (info.label_selected) {
                Point sp = getSplinePoint();

                int dx = selX - sp.x;
                int dy = selY - sp.y;
                
                if (Math.abs(dx) > Math.abs(dy)) {
                    if (selX < sp.x)
                        info.label_position = GUIEdgeInfo.LABEL_WEST;
                    else
                        info.label_position = GUIEdgeInfo.LABEL_EAST;
                }
                else {
                    if (selY < sp.y)
                        info.label_position = GUIEdgeInfo.LABEL_NORTH;
                    else
                        info.label_position = GUIEdgeInfo.LABEL_SOUTH;
                }
                UTILITIES.Repaint(info.canvas," -- GUIEdge:mouseDragged (1)");
                // info.canvas.repaint();
                PutInfo(info);
            }
        }
        else if (info.current_tool == GUIController.SELECT_ITEM_TOOL &&
                 info.in_group_selection &&
                 ((evt.getModifiers() & InputEvent.BUTTON2_MASK) != 0 ||
                  (evt.getModifiers() & InputEvent.CTRL_MASK) != 0)) {
            Point sp = getSplinePoint();
            int dx = (evt.getX()-info.sel_offset_X) - sp.x;
            int dy = (evt.getY()-info.sel_offset_Y) - sp.y;
            info.canvas.moveSelectedItems(dx,dy);
        }
    }
}
