package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;

public class GUINodeInfo extends UiNodeInfo implements Cloneable, java.io.Serializable {
    
    public static final int UNDEFINED_SHAPE = -1;
    public static final int CIRCLE_SHAPE    =  0;
    public static final int POLYGON_SHAPE   =  1;
    public static final int IMAGE_SHAPE     =  2;
    
    
    transient public GUIController gui_controller;
    transient public GUIDrawCanvas canvas;
    
    public Node    node = null;
    //-public boolean visible;    // dsd 000720
    
    public int     shape;
    //-public int     radius;    // dsd 000720
    public Polygon p;
    public GUIImageComponent image_component;
    
    public Font    font;
   // public String  label; dsd 990314
    
    //-public int x;
    //-public int y;    // dsd 000720
    
    // public Color   color; dsd 990314
    
    // private (?) info
    public TextField textfield = null;
    public Panel     textfield_panel = null;
    public boolean   show_textfield = false;
    
    public int current_tool = GUIController.UNKNOWN_TOOL;
    
    public boolean selected = false;
    public int sel_offset_X = 0;
    public int sel_offset_Y = 0;
    
    public boolean in_group_selection = false;
    
    GUINodeInfo() {
        super("",GUIDrawCanvas.defaultItemColor);
    }

    GUINodeInfo(GUIController gui_controller,
                GUIDrawCanvas canvas,
                int           radius,
                boolean       visible,
                Font          font,
                String        label,
                Color         color,
                int           x,
                int           y) {
                    
        super(label,color); // dsd 990314
        
        this.shape  = CIRCLE_SHAPE;
        this.p      = null;
        this.radius = radius;
        this.image_component    = null;
        
        this.gui_controller = gui_controller;
        this.canvas         = canvas;
        this.visible        = visible;
        this.font           = font;
        this.label          = label;
        this.color          = color;
        this.x              = x;
        this.y              = y;
    }
    
    GUINodeInfo(GUIController gui_controller,
                GUIDrawCanvas canvas,
                GUIImageComponent image_component,
                boolean       visible,
                Font          font,
                String        label,
                Color         color,
                int           x,
                int           y) {
        super(label,color); // dsd 990314
        
        this.shape  = IMAGE_SHAPE;
        this.p      = null;
        this.radius = 0;
        this.image_component    = image_component;
        
        this.gui_controller = gui_controller;
        this.canvas         = canvas;
        this.visible        = visible;
        this.font           = font;
        this.label          = label;
        this.color          = color;
        this.x              = x;
        this.y              = y;
    }
    
    GUINodeInfo(GUIController gui_controller,
                GUIDrawCanvas canvas,
                Polygon       p,
                boolean       visible,
                Font          font,
                String        label,
                Color         color,
                int           x,
                int           y) {
        super(label,color); // dsd 990314
                    
        
        this.shape  = POLYGON_SHAPE;
        this.radius = 0;
        this.p      = p;
        this.image_component = null;
        
        this.gui_controller = gui_controller;
        this.canvas         = canvas;
        this.visible        = visible;
        this.font           = font;
        this.label          = label;
        this.color          = color;
        this.x              = x;
        this.y              = y;
    }
    
    synchronized GUINodeInfo Clone() {
        GUINodeInfo clone = null;
        
        try {
            clone = (GUINodeInfo)this.clone();
        } catch(CloneNotSupportedException ex) {
            GIDEN.out.println("GUINodeInfo.Clone() failed");
            System.exit(1);
        }
        
        return clone;
    }
}
