package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;

public class GUIPolygonUtil {
    GUIPolygonUtil() {}
    
    public static Polygon getSymmetricPolygon(int numsides, int radius) {
        
        if (numsides <= 3) {
            GIDEN.out.println("Error:  Symmetric polygon requires at least 3 sides.");
            System.exit(0);
        }
        else if (radius <= 1) {
            GIDEN.out.println("Error:  Symmetric polygon requires radius > 1.");
            System.exit(0);
        }
        
        double skip = (2*Math.PI)/numsides;
        Polygon p = new Polygon();
        
        // rotate polygon by 90 degrees
        double rotation_angle = -Math.PI/2.0;
        
        // if an even number of sides, rotate polygon an additional amount
        if (numsides%2 == 0)
            rotation_angle -= skip/2.0;
        
        // set points in relative position
        for (int i=0 ; i < numsides ; i++, rotation_angle+=skip)
            p.addPoint((int) (((double) radius)*Math.cos(rotation_angle)),
                       (int) (((double) radius)*Math.sin(rotation_angle)));
        
        // translate polygon to final position
        //    p.translate(x,y);
        return p;
    }
    
    public static Polygon getHousePolygon(int radius) {
        if (radius <= 1) {
            GIDEN.out.println("Error:  House polygon requires radius > 1.");
            System.exit(0);
        }
        
        Polygon p = new Polygon();
        /*
          p.addPoint(               0,          -radius);
          p.addPoint(            radius, (int) (-.2*radius));
          p.addPoint((int)  (.8*radius), (int) (-.2*radius));
          p.addPoint((int)  (.8*radius),             radius);
          p.addPoint((int) (-.8*radius),             radius);
          p.addPoint((int) (-.8*radius), (int) (-.2*radius));
          p.addPoint(           -radius, (int) (-.2*radius));
          p.addPoint(                 0,            -radius);
        */
        
        p.addPoint(               0,   (int) (-1.2*radius));
        p.addPoint(            radius, (int) (-.4*radius));
        p.addPoint((int)  (.8*radius), (int) (-.4*radius));
        p.addPoint((int)  (.8*radius), (int)  (.8*radius));
        p.addPoint((int) (-.8*radius), (int)  (.8*radius));
        p.addPoint((int) (-.8*radius), (int) (-.4*radius));
        p.addPoint(           -radius, (int) (-.4*radius));
        p.addPoint(                 0, (int) (-1.2*radius));
        
        return p;
    }
    
    public static Polygon getStarPolygon(int radius) {
        if (radius < 10) {
            GIDEN.out.println("Error:  Star polygon requires radius >= 10.");
            System.exit(0);
        }
        
        Polygon p = new Polygon();
        
        double skip = (2*Math.PI)/10;
        double rotation_angle = -Math.PI/2.0;
        
        for (int i=0 ; i < 5 ; i++) {
            p.addPoint((int) (((double) radius)*Math.cos(rotation_angle)),
                       (int) (((double) radius)*Math.sin(rotation_angle)));
            rotation_angle+=skip;
            
            p.addPoint((int) (((double) radius/2)*Math.cos(rotation_angle)),
                       (int) (((double) radius/2)*Math.sin(rotation_angle)));
            rotation_angle+=skip;
        }
        
        return p;
    }   
}
