package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;


public class GUIPseudoCodeScrollPane extends ScrollPane {
    GUIPseudoCodePanel pc = null;

    public GUIPseudoCodePanel getPCText() {return pc;}

    public Dimension getPreferredSize() {
    if (pc != null)
      return pc.getPreferredSize();
    else
      return super.getPreferredSize();
    }

    GUIPseudoCodeScrollPane(InputStreamReader reader) {
        super();
        pc = new GUIPseudoCodePanel(this,reader);
        this.add(pc);
    }
    GUIPseudoCodeScrollPane(int mode, InputStreamReader reader) {
        super(mode);
        pc = new GUIPseudoCodePanel(this,reader);
        this.add(pc);
    }

    public void makeVisible(int y, int fontheight) {
        Point current_pos = getScrollPosition();
        Dimension viewport_size = getViewportSize();

        if (y - fontheight/2 < current_pos.y ||
            y + fontheight/2 > current_pos.y + viewport_size.height)
            setScrollPosition(0,Math.max(0,y-viewport_size.height/3));

        /*
        if (y < current_pos.y + (viewport_size.height/3) ||
            y > current_pos.y + (2*viewport_size.height/3)) {
            setScrollPosition(x, y-viewport_size.height/3);
        }
        */
    }
}




/*public*/ class GUIPseudoCodePanel extends Panel
{
    //    private final int[] arrow_xp = {0,15,15,25,15,15,0};
    //    private final int[] arrow_yp = {3, 3, 0, 5,10, 7,7};
    private final int[] arrow_xp = { 2,15,15,25,15,15, 2};
    private final int[] arrow_yp = {-2,-2,-5, 0, 5, 2, 2};
    private Polygon arrow = new Polygon(arrow_xp, arrow_yp, 7);

    private Image backBuffer;
    Graphics backGraphics;


    private GUIPseudoCodeScrollPane pc_pane;

    private int width = 0;
    private int height = 0;

    private int numlines = 0;
    private Vector pc_text = new Vector();
    private Hashtable pc_tokens;

    private Font pc_font = new Font("Monospaced",Font.PLAIN,14);
    private FontMetrics pc_fontmetrics = getFontMetrics(pc_font);


    public void setFontSize(int size) {
        pc_font = new Font(pc_font.getName(), Font.PLAIN, size);
        pc_fontmetrics = getFontMetrics(pc_font);

        calculatePreferredDimensions();
        showPCTextLine(current_line); // reset window position, etc.

        invalidate(); 
        pc_pane.validate(); 
        if (isShowing())
            UTILITIES.Repaint(this,"setFontSize");
    }

    GUIPseudoCodePanel(GUIPseudoCodeScrollPane pc_pane, 
                       InputStreamReader       reader) {
        super();

        this.pc_pane = pc_pane;

        String input = getInputString(reader);
        parseInputString(input);

        calculatePreferredDimensions();
    }

    public Dimension getPreferredSize() {
        return new Dimension(width,height);
    }

    int current_line = -1;
    int current_line_ypos_center = 0;
    public void resetPCTextLine() {
        current_line = -1;
        current_line_ypos_center = 0;
        pc_pane.makeVisible(current_line_ypos_center,
                            pc_fontmetrics.getHeight());
        UTILITIES.Repaint(this,"resetPCTextLine");
    }
    public boolean showPCTextLine(int line) {
        if (line > numlines || line <= 0) return false;

        current_line = line;

        current_line_ypos_center = line*pc_fontmetrics.getHeight()
            - pc_fontmetrics.getHeight()/2;

        pc_pane.makeVisible(current_line_ypos_center,
                            pc_fontmetrics.getHeight());
        UTILITIES.Repaint(this,"showPCTextLine");
        return true;
    }
    public boolean showPCTextLine(String token) {
        if (!pc_tokens.containsKey(filterToken(token)))
            return false;

        return showPCTextLine(((Integer) pc_tokens.get(filterToken(token))).intValue());
    }

    int x_offset = 30;    // determines x-coordinate offset



    private Color defaultColor = Color.black;
    private Color highlightColor = Color.blue;
    private Color backgroundColor = Color.white;
    public void print(Graphics g) {
        String java_version = System.getProperty("java.version").toLowerCase();
        if (java_version.indexOf("1.1") == 0)
            direct_draw(g,getBounds().width,getBounds().height); // jdk-1.1
        else
            update(g); // all other versions
    }
    private void direct_draw(Graphics g, int width, int height) {
        g.setColor(backgroundColor);
        g.fillRect(0,0,width,height);

        g.setFont(pc_font);

        if (current_line > 0)
            drawCurrentLineArrow(g);

        if (pc_text.size() > 0)
            paintPCText(g, x_offset);
    }

    public void paint(Graphics g) {update(g);}
    public void update(Graphics g) {
        int width = Math.max(getBounds().width,1);
        int height = Math.max(getBounds().height,1);

        if (backBuffer == null ||
            backBuffer.getWidth(null) != width ||
            backBuffer.getHeight(null) != height) {
            backBuffer = createImage(width,height);
            if (backBuffer != null) {
                if (backGraphics != null)
                    backGraphics.dispose();
                backGraphics = backBuffer.getGraphics();
            }
        }
        if (backBuffer != null) {

            // use "direct_draw" to draw on backGraphics
            direct_draw(backGraphics, width, height);

            // draw buffered image to canvas
            g.drawImage(backBuffer,0,0,null);
        }
    }


    private void paintPCText(Graphics g, int xpos) {
        int ypos = 0;
        int base = pc_fontmetrics.getAscent() + pc_fontmetrics.getLeading();

        g.setColor(defaultColor);

        for (int i=0 ; i < pc_text.size() ; i++) {
            if (current_line == i+1) {
                g.setColor(highlightColor);
                g.drawString((String)pc_text.elementAt(i), xpos, ypos+base);
                g.setColor(defaultColor);
            }
            else
                g.drawString((String)pc_text.elementAt(i), xpos, ypos+base);
            ypos += pc_fontmetrics.getHeight();
        }
    }


    private void drawCurrentLineArrow(Graphics g) {
        g.setColor(highlightColor);

        /*
        g.fillRect(0,current_line_ypos_center-(pc_fontmetrics.getHeight()/2),
                   width,pc_fontmetrics.getHeight());
        */
        arrow.translate(0,current_line_ypos_center);
        g.fillPolygon(arrow);
        arrow.translate(0,-current_line_ypos_center);
    }

    private void calculatePreferredDimensions() {
        // calculate height
        height = pc_fontmetrics.getHeight() * pc_text.size();

        // calculate width
        width = 0;
        for (int i=0 ; i < pc_text.size() ; i++)
            width = Math.max(width,pc_fontmetrics.stringWidth((String)pc_text.elementAt(i)));
        width += x_offset;
    }


    public void savePCTextToFile() {
        Component c = this;
        do {
            c = c.getParent();
        } while (c != null && !(c instanceof Frame));
        if (c == null) return;

        FileDialog d = new FileDialog((Frame) c, "Save PseudoCode Text...",
                                      FileDialog.SAVE);
        d.setFilenameFilter(new EndsWithFilter(".txt"));
        d.setDirectory(".");
        d.setVisible(true);

        String dirname = d.getDirectory();
        String filename = d.getFile();

        if (d.getFile() != null && !(d.getFile()).equals("")) {
            if ((new File(dirname+filename)).exists()) {
                if ((new File(dirname+filename)).isFile()) {
                    // prompt to overwrite
                    GUIOkayCancelQuery query = new GUIOkayCancelQuery((Frame)c,"About to overwrite existing file:  \n\""+dirname+filename+"\"");

                    if (!query.isOkay()) return;
                }
                else {
                    // notify that is directory name and cannot overwrite
                    new GUIModalMessageDialog((Frame) c,
                                              GUIModalMessageDialog.NOTICE,
                                              "Cannot overwrite directory: \""
                                              +dirname+filename+"\"");
                    return;
                }
            }

            try {
                FileWriter out = new FileWriter(dirname+filename);
                for (int i=0 ; i < pc_text.size() ; i++)
                    out.write((String)pc_text.elementAt(i)+"\n");
                out.flush();
                out.close();
            } catch(IOException e) {GIDEN.err.println(e);}
        }
    }



    private void addPCToken(String s, int line) { 
        pc_tokens.put(s, new Integer(line));
    }

    private String filterToken(String token) {
        // here we eliminate leading/trailing white space, and we ensure
        // that any consecutive spaces are reduced to a single space

        // replace tabs with spaces
        token = token.replace('\t',' ');

        int o_pos;
        char[] o_chars = (token.trim()).toCharArray();

        int n_pos;
        char[] n_chars = new char[o_chars.length];

        char curr_char;
        char last_char = '-';   // any char will do here

        for (o_pos = 0, n_pos=0 ; o_pos < o_chars.length ; o_pos++) {
            curr_char = o_chars[o_pos];

            if (curr_char != ' ') {
                n_chars[n_pos++] = curr_char;
                last_char = curr_char;
            }
            else if (last_char != ' ') {
                n_chars[n_pos++] = curr_char;
                last_char = curr_char;
            }
        }

        return new String(n_chars,0,n_pos);
    }

    private void addPCText(String s) {
        pc_text.addElement(new String(s));
    }

    private void parseInputString(String file_input) {
        String item;
        StringTokenizer file_parser, line_parser;

        file_parser = new StringTokenizer(file_input,"\r\n");

        // prepare for adding line numbers
        int digits = 1;
        String line_number;
        String zeros = new String();
        for (int i=file_parser.countTokens() ; i/10.0 >= 1.0 ; i /= 10.0, digits++)
            zeros = zeros.concat("0");


        pc_tokens = new Hashtable();
        pc_text = new Vector(file_parser.countTokens());

        try {
            while (file_parser.hasMoreTokens()) {
                line_parser = new StringTokenizer(file_parser.nextToken(),":",true);
                numlines++;

                // look for a pseudocode token
                item = line_parser.nextToken();
                if (!item.equals(":")) {
                    // item contains a pseudocode token
                    addPCToken(filterToken(item), numlines);
                    if (!(line_parser.nextToken()).equals(":"))
                        GIDEN.out.println("Error parsing pseudocode!");
                }

                // add line number and save the rest of the line
                line_number = new String(zeros+numlines);
                addPCText(line_number.substring(line_number.length()-digits)
                          + ":   " + line_parser.nextToken("\n\r"));
            }
        } catch (NoSuchElementException e) {e.printStackTrace();}
    }

    private String getInputString(InputStreamReader reader) {
        int count;
        char[] buf = new char[512];
        String pseudocodetext = new String();

        try {
            while ((count = reader.read(buf)) >= 0)
                pseudocodetext = pseudocodetext.concat(new String(buf,0,count));
            reader.close();
        } catch (IOException e) {GIDEN.out.println(e);}

        return pseudocodetext;
    }
}
