package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.util.Enumeration;
import java.util.Vector;

public class GidenSolverInput {

    private Vector items;
    private boolean validated;

    public GidenSolverInput() {
        items = new Vector();
        setValidState(false);
    }

    public synchronized void setValidState(boolean b) {validated=b;}
    public synchronized boolean isValidated() {return validated;}

    public void addItem(int type, String desc) {
        addItem(type, desc, "");
    }
    public synchronized void addItem(int type, String desc, String name) {
        items.addElement(new SolverInputItem(type,desc,name));
    }

    public synchronized void setItemData(String desc,String name,Object obj) {
        SolverInputItem i;

        Enumeration myenum = items.elements();
        while (myenum.hasMoreElements()) {
            i = (SolverInputItem) myenum.nextElement();
            if (desc.equals(i.getDescription())) {
                i.setInputItem(name,obj);
                break;
            }
        }
    }


    public synchronized void removeItem(String desc) {
        SolverInputItem i;

        Enumeration myenum = items.elements();
        while (myenum.hasMoreElements()) {
            i = (SolverInputItem) myenum.nextElement();
            if (desc.equals(i.getDescription())) {
                items.removeElement(i);
                break;
            }
        }
    }

    public synchronized int size() {return items.size();}
    public synchronized Enumeration getItems() {return items.elements();}
    public synchronized SolverInputItem getItem(int i) {
        return (SolverInputItem) items.elementAt(i);
    }

    public Object getItemData(String desc) {
        SolverInputItem i;

        Enumeration myenum = items.elements();
        while (myenum.hasMoreElements()) {
            i = (SolverInputItem) myenum.nextElement();
            if (desc.equals(i.getDescription()))
                return i.getData();
        }

        return null;
    }
    

    public int getItemType(String desc) {
        SolverInputItem i;

        Enumeration myenum = items.elements();
        while (myenum.hasMoreElements()) {
            i = (SolverInputItem) myenum.nextElement();
            if (desc.equals(i.getDescription()))
                return i.getType();
        }

        return -1;
    }
}
