package giden.gidenSOLVERS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
import giden.userSOLVERS.*;


public class Dijkstra2 extends Dijkstra {
    private GUISolverInputDialog input_dialog;
    private GidenSolverInput     input;
    private Network net = null;

    Dijkstra2(UserBase userinfo) {
        super(userinfo);

        input = new GidenSolverInput();
        input.addItem(SolverInputItem.INTEGER_EDGE_ARRAY,"Length","Weight");
        input.addItem(SolverInputItem.INTEGER_NODE_ARRAY,"Supply","Supply");
    }

    public boolean ValidateInput() {

        // extract length array
        Object length = input.getItemData("Length");
        if (!(length instanceof EdgeArray))
            return false;

        // check length data 
        if (NegLengthValuesExist(net, (EdgeArray) length)) {
            ///net.UiNet.GUI.notifyOfSolverError("Negative values exist in selected \"Length\" array.");
            UI.NotifyOfSolverError("Negative values exist in selected \"Length\" array.");
            
            return false;
        }

        return true;
    }

    public boolean Setup(Network net) {
        if (net == null)
            return false;
        this.net = net;

        ///input_dialog = new GUISolverInputDialog(net.UiNet.GUI, "Dijkstra-2",
        ///                                        this, net, input);
        UI.CreateSolverInputDialog("Dijkstra-2",this, net, input);
        

        if (!input.isValidated()) 
            return false;

        // extract input info
        Object length = input.getItemData("Length");
        if (length instanceof EdgeArray)
            Length = (EdgeArray) length;

        return super.Setup(net);
    }
}
