package giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
import giden.contrib.*;
import giden.userSOLVERS.*;

import java.io.*;
import java.awt.MenuItem;
import java.awt.TextField;
import java.awt.Button;
import java.awt.FileDialog;
import java.awt.event.*;

/*===============================================================
===============================================================*/
public class GUISolver extends GUINetworkWindow
{
    public SolverThread SolverControl;
    boolean WaitingForTextField;
    boolean WaitingForNodeClick;
    boolean WaitingForEdgeClick;
    boolean WaitingForActionButton;
    UiNode  ClickedNode;
    UiEdge  ClickedEdge;
    ContribSolverMenu ContribMenu;
    SolverMenu UserMenu; // filled in GetSolverMenu
    
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public GUISolver(GUIController parent,
              File          file,
              String        dirname,
              String        filename,
              String        netname,
              String        windowname,
              MenuItem      parent_mi,
              GUINetwork    net)
    {
        super(parent,file,dirname,filename,netname,windowname,parent_mi,net);
        UiNet.PutGuiSolver(this);
        SolverControl = new SolverServices(this);
        Clear();
    }
    
    public ExecBase GetSolver()
    {
        return SolverControl.GetSolver();
    }
    
    void AddSolverMenuInfo(String filename)
    {
        setupSolverInfo(filename);
    }
    void AddSolverMenuInfo()
    {
        String dotname;
        GUISolver gs = (GUISolver)this;
        dotname = gs.GetSolver().getClass().getName();
        String slashname = dotname.replace('.','/');     
        setupSolverInfo(slashname+"html");
    }
    
    UiNetwork GetUiNet()
    {
        return UiNet;
    }
    UiNodeInfo GetDefaultUiNodeInfo()
    {
        return draw_canvas.getDefaultUiNodeInfo();
    }
    UiEdgeInfo GetDefaultUiEdgeInfo()
    {
        return draw_canvas.getDefaultUiEdgeInfo();
    }

    /*
    GUISolver(GUIController parent,
	      String dirname,
	      String filename,
	      long   modtime,
	      String netname,
	      String windowname,
	      MenuItem parent_mi,
	      GUINetwork net)
	{
	    super(parent,dirname,filename,modtime,
	    netname,windowname,parent_mi,net);
	    UiNet.PutGuiSolver(this);
	    SolverControl = new SolverServices(this);
	    Clear();
    }
    */
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    protected SolverMenu GetSolverMenu()
    {
        if(UserMenu==null)
        {
	        UserMenu = new SolverMenu();
	    }
        return UserMenu;
    }
    
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    protected ContribSolverMenu GetContribSolverMenu()
    {
        if(ContribMenu==null)
        {
            ContribMenu = new ContribSolverMenu();
	    }
        return ContribMenu;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void Clear()
    {
        ClearWaits();
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
	void ClearWaits()
	{
	    WaitingForActionButton=false;
	    WaitingForTextField=false;
	    WaitingForNodeClick=false;
	    WaitingForEdgeClick=false;
	    ClickedNode=null;
	    ClickedEdge=null;
	}
	
	/*-----------------------------------------------------------
	| DIRECT GUI<=>SOLVER ACCESS
	-----------------------------------------------------------*/
	
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void Message(String message)
	{
        //TX.Show(message);
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
	void Repaint(String who)
	{
	    Message("GUISolver.Repaint("+who+")");
        //invalidate(); validate() ; repaint();
	    draw_canvas.repaint();
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public boolean UserWantsExit()
    {
        boolean result=false;
        if(SolverControl.UserWantsExit())
        {
            result=true;
            TerminateSolverThread();
        }
        return result;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void TerminateSolverThread()
    {
        SolverControl.TerminateSolverThread();
	    SolverControl = new SolverServices(this);
        clearStatusLine();
        setupNetworkMode();
    }
   
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetContinuousAnimationPauseString()
    {
        return PAUSE_CONTINUOUS;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetContinuousAnimationGoString()
    {
        return GO_CONTINUOUS;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetSolverResetString()
    {
        return RESET_SOLVER;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetTraceString()
    {
        return TRACE;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetFinalString()
    {
        return FINAL;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetStepString()
    {
        return STEP;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetExitString()
    {
        return EXIT;
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    String GetNextString()
    {
        return GUIPseudoCodeWindow.PC_NEXT;
    }
    
        
    /*-----------------------------------------------------------
    | SOLVER CALLS FOR GUI ACCESS
    -----------------------------------------------------------*/
    
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void UserTextInput(String question, String answer)
    {
        ClearWaits();
        WaitingForTextField=true;
        getStatusLineTextInput(question,answer);
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void WaitForActionButton()
    {
        ClearWaits();
        WaitingForActionButton=true;

        // OWENJ 05-Aug-1999
        if (!getAnimationMode().equals(GetSolverResetString())
            && SolverControl.LastWasPcNext) {
            animation_control.setEnabled(true);
            if (PCwindow != null)
                PCwindow.setEnabled(true);
        }
        else if(!getAnimationMode().equals(GetContinuousAnimationPauseString())
                && !getAnimationMode().equals(GetContinuousAnimationGoString())
                && !getAnimationMode().equals(GetSolverResetString()))
            {
                animation_control.setEnabled(true);
                if (PCwindow != null) {
                    PCwindow.setEnabled(true);
                }
            }

        /*
        if(!getAnimationMode().equals(GetContinuousAnimationPauseString()) &&
           !getAnimationMode().equals(GetContinuousAnimationGoString()) &&
           !getAnimationMode().equals(GetSolverResetString()))
        {
            animation_control.setEnabled(true);
	    if (PCwindow != null) {
	        PCwindow.setEnabled(true);
	    }
        }
        */
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void UserMouseNodeInput(String prompt)
    {
        ClearWaits();
        WaitingForNodeClick=true;
        getNodeSelection(prompt);
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void UserMouseEdgeInput(String prompt)
    {
        ClearWaits();
        WaitingForEdgeClick=true;
        getEdgeSelection(prompt);
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void registerSolverModeMouseSelection(Object obj, int t)
    {
        if(WaitingForNodeClick==false && WaitingForEdgeClick==false)
        {
            Message("GUISolver -> Stray Node/Edge Click");
            return;
        }
        if(obj==null)
        {
            if(WaitingForNodeClick)
                SolverControl.EventNotify("Null NodeClick");
            else if(WaitingForEdgeClick)
                SolverControl.EventNotify("Null EdgeClick");
            else
                Message("GUISolver -> Stray Click");
        }
        else if(obj instanceof UiNode)
        {
            if(WaitingForNodeClick)
                NodeClicked((UiNode)obj);
            else
               SolverControl.EventNotify("WrongClick");
            
        }
        else if(obj instanceof UiEdge)
        {
            if(WaitingForEdgeClick)
                EdgeClicked((UiEdge)obj);
            else
                SolverControl.EventNotify("WrongClick");
            
        }
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void NodeClicked(UiNode node)
    {
        if(WaitingForNodeClick)
        {
            WaitingForNodeClick=false;
            ClickedNode=node;
            SolverControl.EventNotify("NodeClick");
            clearStatusLine();
        }
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void EdgeClicked(UiEdge edge)
    {
        if(WaitingForEdgeClick)
        {
            WaitingForEdgeClick=false;
            ClickedEdge=edge;
            SolverControl.EventNotify("EdgeClick");
            clearStatusLine();
        }
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void ShowPseudoCodeText(int line)
    {
        showPCTextLine(line);
        Message("ShowPseudoCodeText("+line+")");
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void ShowPseudoCodeText(String token)
    {
        showPCTextLine(token);
        Message("ShowPseudoCodeText("+token+")");
        
    }
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    void ResetPcTextLine()
    {
        resetPCTextLine();
    }
    
    
   
    
    /*-----------------------------------------------------------
    | JAVA EVENTS
    -----------------------------------------------------------*/
    
    //-----------------------------------------------------------
    //-----------------------------------------------------------
    public void actionPerformed(ActionEvent evt)
    {
        super.actionPerformed(evt);

        boolean actionbutton;
        String text;
        Object src = evt.getSource();
        
        if (src instanceof TextField)
        {
            if(WaitingForTextField)
            {
                WaitingForTextField=false;
                text = evt.getActionCommand();
                SolverControl.EventNotify(text);
            }
        }
        if (src instanceof Button)
        {
            actionbutton=false;
            text = evt.getActionCommand();
            if(text.equals(GetExitString()))
            {
                if(UserWantsExit()==false)
                    actionbutton=true;
            }
            if(WaitingForActionButton)
            {
                if(text.equals(GetTraceString()))
                    actionbutton=true;
                if(text.equals(GetFinalString()))
                    actionbutton=true;
                if(text.equals(GetStepString()))
                    actionbutton=true;
                if(text.equals(GetNextString()))
                    actionbutton=true;

                // Dave: uncomment the following lines to catch the
                // continuous animation button presses ("go" and
                // "pause")
                
                if(text.equals(GetContinuousAnimationPauseString()))
                    SolverControl.GoToPauseEvent=true;
                    //actionbutton=true;
                if(text.equals(GetContinuousAnimationGoString()))
                    actionbutton=true;
                if(text.equals(GetSolverResetString()))
                   actionbutton=true;
            }
            if(actionbutton)
            {                
                WaitingForActionButton=false;
                SolverControl.EventNotify(text);
            }
        }
        String what = evt.getActionCommand();
        
        if ("Save CSV...".equals(what))// && netfile != null && !netfile.exists())
        {
            FileDialog d = new FileDialog(this,"Save GIDEN Network...",FileDialog.SAVE);
            d.setFilenameFilter(new EndsWithFilter(".gdn"));
            d.setDirectory("./networks");
            d.setVisible(true);
            
            if (d.getFile() != null && !(d.getFile()).equals("")) {
                
                String oldfilename = new String(filename);
                filename = new String(d.getFile());
                // make sure that filename ends with ".gdn"
                if (!filename.toLowerCase().endsWith(".csv"))
                    filename = new String(filename+".csv");

                String olddirname = new String(dirname);
                dirname = new String(d.getDirectory());
                if (dirname.equals("./")) {
                    dirname = System.getProperty("user.dir");
                    if (dirname == null)
                        dirname = new String("./networks/");
                    else
                        dirname = new String(dirname+"/networks/");
                }

                File newnetfile = new File(dirname+filename);
                if (newnetfile.exists()) {
                    
                    if (newnetfile.isFile()) {
                        // prompt to overwrite
                        GUIOkayCancelQuery query = new GUIOkayCancelQuery(this,"About to overwrite existing file:  \n\""+dirname+filename+"\"");
                        
                        if (!query.isOkay()) {
                            filename = oldfilename;
                            dirname = olddirname;
                            return;
                        }
                    }
                    else {
                        // notify that is directory name and cannot overwrite
                        new GUIModalMessageDialog(this,GUIModalMessageDialog.NOTICE,
                                                  "Cannot overwrite directory: \""
                                                  +dirname+filename+"\"");
                        filename = oldfilename;
                        dirname = olddirname;
                        return;
                    }
                }
                
                /* write text based files */
                GdnNetworkWriterV3 writer = new GdnNetworkWriterV3(dirname,filename);
                if(true)
                {
                    writer.writeFile(UiNet);
                    writer.close();
                }

                if (!filename.equals(oldfilename))
                    parent.registerFileameChange(this,parent_mi,oldfilename,filename);

                netfile = newnetfile;
                modtime = netfile.lastModified();
                save_mi.setEnabled(true);
            }
        }
        
    }  
    
    int GetNodeArrayCount()
    {
        return node_array_count;
    }
    
    String GetNodeArrayName(int i)
    {
        return node_arrays[i].getLabel();
    }
    
    int GetEdgeArrayCount()
    {
        return edge_array_count;
    }
    
    String GetEdgeArrayName(int i)
    {
        return edge_arrays[i].getLabel();
    }
    
    /********************************************************************/
    // OWENJ: this method executed when a solver is selected if the
    // listener was a GUISolverMenuListener (see GUINetworkWindow.java)
    /********************************************************************/
    protected void solverSelected(String text)
    {
        SolverControl.EventNotify(text);
    }
}
