package giden.CORE;
//import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.FileNotFoundException;
import java.net.MalformedURLException;
import java.io.IOException;
import java.net.URL;
import java.io.*;
import java.util.Properties;


public class GdnCsvOutput
{
    double test;
    String FilePath;
    FileWriter Writer;
    /** last line read and available for processing */
    public String LastLine;
    /** true if the last file open was true */
    boolean ValidFile;
    /** true if the last write was valid */
    boolean ValidWrite;
    
    
    public GdnCsvOutput(String path, String filename)
    {
        if(path==null)
        {
            Properties prop = System.getProperties();
            String user_dir = prop.getProperty("user.dir");
            FilePath = user_dir+"/"+filename;
        }
        else
        {
            FilePath = path+filename;
        }
  	    OpenFile();
    }   
    
  
    
    void OpenFile()
    {
        Writer=null;
        LastLine=null;
        ValidFile=false;
        ValidWrite=false;
        
        try
        {
            Writer = new FileWriter(FilePath);
    	    ValidFile=true;
        }
        catch(IOException error)
        {
            error.printStackTrace();            
        }
    }
    
    /** Gets the current string */
    public String toString()
    {
        return LastLine;
    }
    public boolean writeLine(String line)
    {
        LastLine=line;
        return writeLine();
    }
    /** Reads a line from the file */
    public boolean writeLine()
    {
        ValidWrite=false;
        if(LastLine!=null)
        {
            try
            {
                if(Writer!=null)
                {
                    Writer.write(LastLine+"\n");
                    LastLine=null;
                    ValidWrite=true;
                }
            }
            catch(IOException error)
            {
                error.printStackTrace();            
            }
        }
        return ValidWrite;
    }
    boolean addString(String text)
    {
        if(LastLine==null)
            LastLine=text;
        else
            LastLine=LastLine.concat(","+text);
        return true;
    }
    boolean addInt(int value)
    {
        return addString(new Integer(value).toString());
    }
    boolean addDouble(double value)
    {
        return addString(new Double(value).toString());
    }
    
    /** Closes the file */    
    public void close()
    {
        try
        {
            if(Writer!=null)
            {
                Writer.close();
                Writer=null;
            }
        }
        catch(IOException error)
        {
            error.printStackTrace();            
            
        }
    }
}
