
package  giden.CORE;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import javax.swing.*;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;
import java.io.IOException;

/**
 * GdnTextWindow is a general purpose Frame for displaying
 * the contents of text files for various GIDEN subsytems.
 * 
 * @author Dilworth
 * @version 1.02
 */

public class GdnHtmlWindow extends JFrame implements ActionListener, WindowListener,HyperlinkListener
{
    JEditorPane Pane;
    
    /**
     * Text area holding the displayed text
     */
    TextArea Text;
    /**
     * Button user pushes to dismiss this frame.
     */
    Button OK_BUTTON;
    /**
     * Creates the popup frame with the given title, location,
     * and size.  The a TextArea is added with a vertical
     * scrollbar.  The text is currently hardcoded and set
     * to fit in frame area without needing the horizontal scroll
     * 
     * @param title text title for the frame
     * @param x frame x location
     * @param y frame y location
     * @param width frame width
     * @param height frame height
     */
    public GdnHtmlWindow(String file, String title, int x, int y, int width, int height)
    {
        Create(file,title,x,y,width,height);
    }
    
    public GdnHtmlWindow(String file, String title, Point point, int width, int height)
    {
        Create(file,title,point.x,point.y,width,height);
    }
    
    
    protected void Create(String file, String title, int x, int y, int width, int height)
    {
        Pane = new JEditorPane();
        
        String s;
        
            //Properties prop = System.getProperties();
            //String user_dir = prop.getProperty("user.dir");
            //filepath = "file:///"+user_dir+"/"+filename;
            
        /*
        
        s = "file:"
          + System.getProperty("user.dir")
          + System.getProperty("file.separator")
          + file;
          
        s = "file:" + file;
          
          

        int error=0;
        
        try
        {
            URL url = new URL(s);
            Pane.setPage(url);
        }
        catch(IOException e)
        {
            error=1;
        }
        */
        
        s = file;
        
        int error=0;
        
        
        
        try
        {
            URL url = getClass().getResource(s);
            Pane.setPage(url);
        }
        catch(IOException e)
        {
            error=1;
        }
        
        
        Pane.setEditable(false);
        Pane.addHyperlinkListener(this);
        JScrollPane editorScrollPane = new JScrollPane(Pane);
        editorScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                        
        setTitle(title);
        setBounds(x,y,width,height);
                        
        getContentPane().setLayout(new BorderLayout());
        OK_BUTTON = new Button("Dismiss");
        OK_BUTTON.addActionListener(this);
        addWindowListener(this);
        FlowLayout button_layout = new FlowLayout();
        button_layout.setVgap(1);
        Panel buttons = new Panel(button_layout);
        buttons.add(OK_BUTTON);

        getContentPane().add(BorderLayout.CENTER,editorScrollPane);
        getContentPane().add(BorderLayout.SOUTH,buttons);  // add button
    }
    
    /**
     * Responds the user pushing the OK button.
     * Hides the frame
     */
    public void actionPerformed(ActionEvent event)
    {
        makeVisible(false);
    }
    /**
     * Creates help text.  Currently this text is hard coded.
     */
    void readHelpText(String path, String filename)
    {
        String line;
        GdnCsvInput file = new GdnCsvInput(path,filename);
        while(true)
        {
            line = file.readLine();
            if(line==null)
                break;
            Text.append(line);
            Text.append("\n");
        }
    }
    /** Makes the frame visible */
    public void makeVisible(boolean visible)
    {
        if(visible)
        {
            setVisible(false);
            setVisible(true);
            toFront();
        }
        else
        {
            setVisible(false);
        }
    }
    public void windowActivated(WindowEvent event)
    {
        println("windowActivated "+event.toString());
        
    }
    public void windowClosed(WindowEvent event)
    {
        println("windowClosed "+event.toString());
    }
    public void windowClosing(WindowEvent event)
    {
        setVisible(false);
        //println("windowClosing "+event.toString());
    }
    public void windowDeactivated(WindowEvent event)
    {
        //setVisible(false);
        println("windowDeactivated "+event.toString());
    }
    public void windowDeiconified(WindowEvent event)
    {
    }
    public void windowIconified(WindowEvent event)
    {
        println("windowIconified "+event.toString());
        
    }
    public void windowOpened(WindowEvent event)
    {
        println("windowOpened "+event.toString());
        
    }   
    public void hyperlinkUpdate(HyperlinkEvent event)
    {     
        
        int error=0;
        if(event.getEventType()==HyperlinkEvent.EventType.ACTIVATED)
        {
            try
            {
                URL url = event.getURL();
                Pane.setPage(url);
            }
            catch(IOException e)
            {
                error=1;
            }
        }
    }

    /** print diagnostic messages */
    private void println(String message)
    {
        //System.out.println(message);
    }
}
