package  giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.contrib.samples.*;
import giden.GRDS.*;
import giden.GUI.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 RowDialogChoice is a row in a RowDialogMain dialog box.  It allows the user
 to select a test string from  pulldown list.
 The host program then retrieves the selected string by calling GetChoice. 
 See the example in DialogSolver.java and the documentation in RowDialogMain.java.
 * <p>
 * @see DialogSolver
 * @see RowDialogEdge
 * @see RowDialogFilename
 * @see RowDialogMain
 * @see RowDialogNode
 * @see RowDialogText
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */


public class RowDialogChoice extends RowDialogEntry
{
    RowEntryChoice Options;
    RowEntryLabel Extra;
    
    /** Constructs the row from a name and linklist of choices */
    public RowDialogChoice(String name, LinkList choices ,RowDialogMain dialog)
    {
        super(name,dialog);
        CreateObject(name,dialog);
        AddList(choices,null);
    }
    /** Constructs the row from a name, a linklist of choices, and a nominal value */
    public RowDialogChoice(String name, LinkList choices ,String nominal, RowDialogMain dialog)
    {
        super(name,dialog);
        CreateObject(name,dialog);
        AddList(choices,null);
    }
    /** Constructs the row from a name, an array of choices */
    public RowDialogChoice(String name, String choices[], RowDialogMain dialog)
    {
        super(name,dialog);
        CreateObject(name,dialog);
        AddArray(choices,null);
    }
    /** Constructs the row from a name, an array of choices, and a nominal value */
    public RowDialogChoice(String name, String choices[], String nominal, RowDialogMain dialog)
    {
        super(name,dialog);
        CreateObject(name,dialog);
        AddArray(choices,nominal);
    }
    
    
    void CreateObject(String name, RowDialogMain dialog)
    {
        Extra = new RowEntryLabel(" ");
        Extra.addMouseListener(dialog);
        Options = new RowEntryChoice();
        Options.addMouseListener(dialog);
    }
    
    void AddList(LinkList choices,String nominal)
    {
        ListIter lit = new ListIter(choices);
        Object item;
        for(item=lit.GetFirstItem();item!=null;item=lit.GetNextItem())
        {
            Options.add((String)item);
        }
        if(nominal!=null)
            Options.select(nominal);
    }
    
    void AddArray(String choices[],String nominal)
    {
        for(int i=0;i<choices.length;i++)
        {
            Options.add(choices[i]);
        }
        if(nominal!=null)
            Options.select(nominal);
        
    } 
    
    void Build()
    {
        add(Name);
        add(Options);
        add(Extra);
        add(Help);
    }
    Dimension GetInfoSize()
    {
        return Options.getSize();
    }
    void PutSize(int height, int name, int info, int extra, int help)
    {
        Name.PutSize(new Dimension(name,height));
        Options.PutSize(new Dimension(info,height));
        Extra.PutSize(new Dimension(extra,height));
    }
    /** Retrieves the selected string */
    public String GetChoice()
    {
        return Options.getSelectedItem();
    }
    Dimension GetExtraSize()
    {
        return Extra.getSize();
    }
    
}
