package  giden.CORE;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.contrib.samples.*;
import giden.GRDS.*;
import giden.GUI.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 <p>
 RowDialogEdge is a row in a RowDialogMain dialog box.  It allows the user
 to select an edge from a pulldown list or by clicking on the edge.
 The host program then retrieves the selected string by calling GetEdge.
 See the example in DialogSolver.java and the documentation in RowDialogMain.java.
 * <p>
 * @see DialogSolver
 * @see RowDialogChoice
 * @see RowDialogEntry
 * @see RowDialogFilename
 * @see RowDialogMain
 * @see RowDialogNode
 * @see RowDialogText
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */

public class RowDialogEdge extends RowDialogChoice implements ActionListener
{
    UserBase UserInfo;
    RowDialogMain Dialog;
    RowEntryButton Extra;
    String BrowseString="...";
    
    /** Constructs the row from a name and linklist of edge strings */    
    public RowDialogEdge(String name, LinkList options, RowDialogMain dialog)
    {
        super(name,options,dialog);
        Extra = new RowEntryButton(BrowseString);
        Extra.addMouseListener(dialog);
        Dialog=dialog;
        Extra.addActionListener(this);
    }
    void Build()
    {
        add(Name);
        add(Options);
        add(Extra);
        add(Help);
    }
    void PutEdgeClick(Edge edge)
    {
        if(edge!=null)
            Options.select("E"+edge.GetIndex());
    }
    Dimension GetInfoSize()
    {
        return Options.getSize();
    }
    void PutSize(int height, int name, int info, int extra, int help)
    {
        Name.PutSize(new Dimension(name,height));
        Options.PutSize(new Dimension(info,height));
        Extra.PutSize(new Dimension(extra,height));
    }
    public void actionPerformed(ActionEvent event)
    {
        Object obj=event.getSource();
        String label=((Button)obj).getLabel();
        if(label.equals(BrowseString))
            Dialog.UserMouseEdgeInput("Click Edge",this);
        else
            super.actionPerformed(event);
        
    }
    Dimension GetExtraSize()
    {
        return Extra.getSize();
    }
    /** Returns the selected edge or null if no edge was selected */
    public Edge GetEdge()
    {
        String name = GetChoice();
        Edge result =  Dialog.GetNet().GetEdge(name);
        return result;  
    }
}
