package  giden.CORE;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
import java.awt.*;

/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * UiEdgeInfo provides data members that define how a node
 * is drawn by the GUI.  
 * <p>
 * Copyright (c) 1993-2001 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
  * 
 * @see UserIO
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */


public class UiEdgeInfo implements java.io.Serializable
{
    public static final int LABEL_NORTH = 1;
    public static final int LABEL_SOUTH = 2;
    public static final int LABEL_EAST  = 3;
    public static final int LABEL_WEST  = 4;
    
    public static final int label_position_default = LABEL_NORTH;
    
        
    public int     label_position = LABEL_NORTH;

    public int splineX;
    public int splineY;
    public boolean spline_positioned = false;


    /** The color to draw this edge */
    public Color color;
    /** The text label printed near the edge */
    public String label;
    /** true if the edge should be drawn */
    public boolean visible;
    
    /** Internal method */
    public UiEdgeInfo()
    {
        color=null;
        label=null;
        label_position = label_position_default;
        
    }
    
    /** Internal method */
    public UiEdgeInfo(String label, Color color)
    {
        this.label=label;
        this.color=color;
        label_position = label_position_default;
    }
    
    // public method for getting spline point; we don't allow direct access
    public Point getSplinePoint()
    {
        if (spline_positioned)
            return new Point(splineX,splineY);
        else
            return (Point) null;
    }
       
    public void setSplinePoint(Point p)
    {
        splineX = p.x;
        splineY = p.y;
        spline_positioned = true;
    }
 
    
    /** Internal method */
    synchronized public UiEdgeInfo UiClone()
    {
        UiEdgeInfo clone = null;
        
        try
        {
            clone = (UiEdgeInfo)this.clone();
        }
        catch(CloneNotSupportedException ex)
        {
            System.out.println("UiEdgeInfo.Clone() failed");
            System.exit(1);
        }
        return clone;
    }
}
