package giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;


/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * EdgeListIter is derived from ListIter and provides
 * all of its methods.  In addition EdgeListIter provides
 * methods to iterate with Edge objects.
 *
 * A newly created EdgeListIter is initialized to null.
 * At some point prior to using a newly created ListIter to access the list,
 * GetFirstEdge() or GetLastEdge() must be called.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see Edge
 * @see Graph
 * @see InListIter
 * @see LinkList
 * @see Network
 * @see OutListIter
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */

/*===============================================================
===============================================================*/
public class EdgeListIter extends ListIter
{
   //-----------------------------------------------------------
   /** Creates an EdgeListIter for the given LinkList and initializes
     * it to null.  In order to use this EdgeListIter to access Edges in
     * the list, GetFirstEdge() or GetLastEdge must initially be called.*/
   //------------------------------------------------------------
    public EdgeListIter(LinkList list)
    {
        super(list);
    }
    //-----------------------------------------------------------
    /** Moves this EdgeListIter to the ListEntry at the head of the
     * list and gets that ListEntry's Edge.
     * @return The first edge in the list*/
    //-----------------------------------------------------------
    public Edge GetFirstEdge()
    {
        return (Edge) GetFirstItem();
    }
    //-----------------------------------------------------------
    /** Moves this EdgeListIter to the next ListEntry of the
     * list and gets that ListEntry's Edge.
     * @return The next edge in the list */
    //-----------------------------------------------------------
    public Edge GetNextEdge()
    {
        return (Edge) GetNextItem();
    }
}
