package  giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * NodeArray is derived from IndexArray and provides
 * identical methods.  The primary purpose of using
 * this class is to clarify the intended data type
 * for the array.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see IndexArray
 * @see Network
 * @see Node
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */



/*===============================================================
===============================================================*/
public class NodeArray extends IndexArray
{
    //-----------------------------------------------------------
    /** Creates a node array with the given initial size and name
     * and initializes the array components to null.  If the given
     * size is less than 100, then a size of 100 is used.  Each array
     * access is checked to determine whether it is beyond the bounds
     * of the array.  To accommodate array accesses beyond its bounds,
     * the array is automatically resized, and the new components are
     * initialized to the most recent Object used to Fill this array
     * (default is null).
     * NodeArrays created in this way are not stored in the
     * Network object and can not be later retrieved through the name.
     * @see Network#CreateNodeArray
     * @param size   Initial size of the array.
     * @param name   Name of the array */
    //-----------------------------------------------------------
    public NodeArray(int size, String name)
    {
        super(size,name);
    }
    //-----------------------------------------------------------
    /** Puts the Object using the given Index object
     * @param indexobject  The Index object for this array
     * @param obj        The Object to store in the array */
    //-----------------------------------------------------------
    public void Put(Node indexobject, Object obj)
    {
        PutObj(indexobject,obj);
    }
    //-----------------------------------------------------------
    /** Puts the integer using the given Index object
     * @param indexobject  The object containing an array index
     * @param value  The integer value to store in this array */
    //-----------------------------------------------------------
    public void Put(Node indexobject, int value)
    {
        PutObj(indexobject,new Integer(value));
    }
     //-----------------------------------------------------------
    /** Puts the double using the given Index object
     * @param indexobject  The object containing an array index
     * @param value  The double value to store in this array */
    //-----------------------------------------------------------
    public void Put(Node indexobject, double value)
    {
        PutObj(indexobject,new Double(value));
    }
    
}

