package giden.GRDS;

/*
 * WE MAKE NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WE SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY USER AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/**
 * NodeArray2dEdge provides a 2D NodeArray that gets and puts edges.
 * Note: return values haven't been qualified with bounds checking.
 * <p>
 * Copyright (c) 2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see NodeArray2d
 * @see NodeArray2dInt
 *
 * @version 	1.0a 2004 Feb 01
 * @author 	    D. S. Dilworth
 */
 public class NodeArray2dEdge extends NodeArray2d
 {
    Edge Array2d[];
    
    /** Contructs the 2D Node array */
    public NodeArray2dEdge(Network net)
    {
        super(net);
        Array2d = new Edge[NodeCount2d];      
       
    }
    /** Puts an edge into the array */
    public boolean PutEdge(Node node1, Node node2, Edge edge)
    {
        int index = GetIndex(node1,node2);
        Array2d[index] = edge;
        return true;
    }  
    /** Gets an edge from the array */
    public Edge GetEdge(Node node1, Node node2)
    {
        int index = GetIndex(node1,node2);
        Edge edge = Array2d[index];
        return edge;
    }
 };
 
