package  giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * NodeListIter is derived from ListIter and provides
 * all of its methods.  In addition NodeListIter provides
 * methods to iterate with Node objects.
 *
 * A newly created NodeListIter is initialized to null.
 * At some point prior to using a newly created ListIter to access the list,
 * GetFirstNode() or GetLastNode() must be called.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 * @see Graph
 * @see ListIter
 * @see LinkList
 * @see Network
 * @see Node
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */


/*===============================================================
===============================================================*/
public class NodeListIter extends ListIter
{
   //-----------------------------------------------------------
   /** Creates a NodeListIter for the given LinkList and initializes
     * it to null.  In order to use this NodeListIter to access Nodes in
     * the list, GetFirstNode() or GetNodeEdge must initially be called.*/
   //------------------------------------------------------------
    public NodeListIter(LinkList list)
    {
        super(list);
    }
    //-----------------------------------------------------------
    /** Moves this NodeListIter to the ListEntry at the head of the
     * list and gets that ListEntry's Node.
     * @return The first node in the list*/
    //-----------------------------------------------------------
    public Node GetFirstNode()
    {
        return (Node) GetFirstItem();
    }
    //-----------------------------------------------------------
    /** Moves this NodeListIter to the next ListEntry of the
     * list and gets that ListEntry's Node.
     * @return The next node in the list */
    //-----------------------------------------------------------
    public Node GetNextNode()
    {
        return (Node) GetNextItem();
    }
}

