package  giden.GRDS;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
/**
 * Copyright (c) 1993-2004 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 * <BR>
 * We make no representations or warranties about the suitability of
 * the software, either express or implied, including but not limited
 * to the implied warranties of merchantability, fitness for a
 * particular purpose, or non-infringement. We shall not be liable for
 * any damages suffered by user as a result of using, modifying or
 * distributing this software or its derivatives.
 * <p>
 * OutListIter is derived from EdgeListIter and provides all
 * its methods.  OutListIter accesses the list of outgoing
 * Edges incident to a particular Node.
 *
 * A newly created OutListIter is initialized to null.
 * At some point prior to using a newly created OutListIter to access the list,
 * GetFirstEdge() or GetLastEdge() must be called.
 * <p>
 * Copyright (c) 1993-2003 C. R. Coullard, D. S. Dilworth, J. H. Owen,
 * All Rights Reserved.
 *
 *
 * @see Edge
 * @see EdgeListIter
 * @see InListIter
 * @see Graph
 * @see GraphState
 * @see ListIter
 * @see LinkList
 * @see Network
 * @see Node
 *
 * @version 	4.0a 2004 08 27
 * @author 	    D. S. Dilworth
 */
 
 // 010502, dsd, fixed FirstEdge null pointer bug


/*===============================================================
===============================================================*/
public class OutListIter extends EdgeListIter
{
    Node WorkingNode;

   //-----------------------------------------------------------
   /** Creates an OutListIter for accessing the list of outgoing
     * Edges for the given Node, and initializes it to null.  In
     * order to use this OutListIter to access Edges in the list,
     * GetFirstEdge() or GetLastEdge must initially be called. */
   //------------------------------------------------------------
    public OutListIter(Node node, LinkList list)
    {
        super(list);
        WorkingNode=node;
    }

    //-----------------------------------------------------------
    /** Moves this OutListIter to the ListEntry at the head of the
     * list and gets that ListEntry's Edge.
     * @return The first outgoing edge from the Node's EdgeList*/
    //-----------------------------------------------------------
    public Edge GetFirstEdge()
    {
        Edge edge;

        edge = (Edge) GetFirstItem();
        if(edge==null)                  // check no edges
            return null;
        if(edge.IsSource(WorkingNode))
            return edge;
        return GetNextEdge();
    }
    //-----------------------------------------------------------
    /** Moves this OutListIter to the next ListEntry of the
     * listand gets that ListEntry's Edge.
     * @return The next outgoing edge from the Node's EdgeList*/
    //-----------------------------------------------------------
    public Edge GetNextEdge()
    {
        Edge edge;

        while(true)
        {
            edge = (Edge) GetNextItem();
            if(edge==null)
                break;
            if(edge.IsSource(WorkingNode))
                break;
        }
        return edge;
    }
}
