package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;

// WARNING!!!: This assumes that the layout of this panel is
//             "FlowLayout" (the default)

public class GUIFlowPanel extends Panel {
    
    int hgap;
    int vgap;

    GUIFlowPanel() {this(FlowLayout.LEFT,2,2);}
    GUIFlowPanel(int align) {this(align,2,2);}
    GUIFlowPanel(int align, int hgap, int vgap) {
        super(new FlowLayout(align,hgap,vgap));
        this.hgap = hgap;
        this.vgap = vgap;
    }
    
    int width_pad = 0;
    public void setWidthReduction(int delta) {
        width_pad = delta;
    }


    // override getMinimumSize() method used to determine how much space
    // to allocate for our panel in another container (e.g., a frame
    // with border layout)
    public Dimension getMinimumSize() {return getPreferredSize();}

    // override getPreferredSize() method used to determine how much
    // space to allocate for our panel in another container (e.g., a
    // frame with border layout)
    public Dimension getPreferredSize() {
        
        Insets parent_insets = getParent().getInsets();
        Insets local_insets = getInsets();

        int parent_width = getParent().getSize().width;
        int max_rowwidth = parent_width - width_pad
                           - (parent_insets.left + parent_insets.right)
                           - (local_insets.left + local_insets.right);


        // calculate number of rows and needed height
        int numrows = 0;
        int neededheight = local_insets.top + local_insets.bottom + 2*(vgap);
        int rowheight = 0;
        int rowwidth = max_rowwidth; // 0-th row is considered full

        Component comp;
        Dimension compSize;

        for (int i=0 ; i < getComponentCount() ; i++) {
            comp = getComponent(i);
            compSize = comp.getPreferredSize();

            if (rowwidth + compSize.width + hgap >= max_rowwidth) {
                // need to start a new row
                neededheight += rowheight;
                numrows++;

                rowheight = compSize.height + vgap;
                rowwidth = compSize.width + 2*(hgap);
            }
            else {
                // current component will fit in current row
                rowwidth += compSize.width + hgap;
                rowheight = Math.max(rowheight,compSize.height+vgap);
            }
        }
        neededheight += rowheight; // add height of last row

        return (new Dimension(parent_width, neededheight));
    }
}
