package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;


public class GUIHelpInfoDialog extends Dialog implements ActionListener, 
                                                  ItemListener,
                                                  WindowListener {
    Frame parent;
    
    ScrollPane sp = null;
    GUIViewerGHTML viewer = null;
    
    int numtopics;
    String topicnames[];
    String topicfilestrings[];
    
    List topics;
    int current_topic_index;
    Label current_topic_name;
    TextArea current_topic_text;
    
    Button next, prev, dismiss;
    
    public GUIHelpInfoDialog(Frame parent) {
        super(parent,"GIDEN Help",false);
        addWindowListener(this);
        //    setLocation(parent.getLocation());
        
        this.parent = parent;
        
        // initialize help topics
        numtopics = 20;
        topicnames = new String[numtopics];
        topicnames[0] = new String("Introduction");
        for (int i=1 ; i < numtopics ; i++)
            topicnames[i] = new String("Topic "+i);
        buildTopicFileStrings();
        
        
        
        GridBagLayout gbl = new GridBagLayout();
        setLayout(gbl);
        
        GridBagConstraints gbc = new GridBagConstraints();
        
        
        // setup constraints for "scrollpane"
        gbc.anchor     = GridBagConstraints.NORTHWEST;
        gbc.fill       = GridBagConstraints.BOTH;
        gbc.gridx      = 2;
        gbc.gridy      = 1;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(5,15,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 1;
        gbc.weighty    = 1;
        
        
        sp = new ScrollPane();
        viewer = new GUIViewerGHTML();
        sp.add(viewer);
        gbl.setConstraints(sp,gbc);
        add(sp);
        
        
        current_topic_text = new TextArea("",15,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
        current_topic_text.setEditable(false);

        
        
        // setup constraints for "list title" label
        gbc.anchor     = GridBagConstraints.WEST;
        gbc.fill       = GridBagConstraints.NONE;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.gridwidth  = 2;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(10,5,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        // add "list title" label
        Label l = new Label("Help Topics", Label.LEFT);
        l.setFont(new Font(getFont().getName(),Font.BOLD,getFont().getSize()+2));
        gbl.setConstraints(l,gbc);
        add(l);
        
        
        // setup constraints for "current topic" label
        gbc.anchor     = GridBagConstraints.WEST;
        gbc.fill       = GridBagConstraints.NONE;
        gbc.gridx      = 2;
        gbc.gridy      = 0;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(10,15,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        // add "current topic" label
        current_topic_name = new Label("<selected topic name>", Label.LEFT);
        current_topic_name.setFont(new Font(getFont().getName(),
                                            Font.BOLD|Font.ITALIC,
                                            getFont().getSize()+2));
        gbl.setConstraints(current_topic_name,gbc);
        add(current_topic_name);
        
        
        // setup constraints for "topics list"
        gbc.anchor     = GridBagConstraints.NORTHWEST;
        gbc.fill       = GridBagConstraints.BOTH;
        gbc.gridx      = 0;
        gbc.gridy      = 1;
        gbc.gridwidth  = 2;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(5,5,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        // setup and add "topics list"
        topics = new List(15,false);
        topics.addItemListener(this);
        for (int i=0 ; i < numtopics ; i++)
            topics.add(topicnames[i]);
        gbl.setConstraints(topics,gbc);
        add(topics);
        
        
        // setup constraints for "prev" button
        gbc.anchor     = GridBagConstraints.CENTER;
        gbc.fill       = GridBagConstraints.NONE;
        gbc.gridx      = 0;
        gbc.gridy      = 2;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(5,5,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        prev = new Button(" Prev "); prev.setEnabled(false);
        prev.addActionListener(this);
        gbl.setConstraints(prev,gbc);
        add(prev);
        
        // setup constraints for "next" panel
        gbc.anchor     = GridBagConstraints.CENTER;
        gbc.fill       = GridBagConstraints.NONE;
        gbc.gridx      = 1;
        gbc.gridy      = 2;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(5,5,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        next = new Button(" Next "); next.setEnabled(false);
        next.addActionListener(this);
        gbl.setConstraints(next,gbc);
        add(next);
        
        
        // setup constraints for "dismiss" panel
        gbc.anchor     = GridBagConstraints.EAST;
        gbc.fill       = GridBagConstraints.NONE;
        gbc.gridx      = 2;
        gbc.gridy      = 2;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(5,5,5,5);    // (top,left,bottom,right)
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        
        dismiss = new Button("  Dismiss  "); 
        dismiss.addActionListener(this);
        gbl.setConstraints(dismiss,gbc);
        add(dismiss);
        
        // could set up initial topic display here
        //    if (numtopics > 0) {
        //      topics.select(0);
        //      updateTopicSelection();
        //    }
        pack();
        this.setSize(500,350);
        //    this.setResizable(false);
        
        // need to set location --- center on screen
        Dimension screen_size = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension my_size = getSize();
        setLocation(new Point((screen_size.width - my_size.width)/2,
                              (screen_size.height - my_size.height)/2));
        
        // finally, make visible
        setVisible(true);
    }
    
    
    private void buildTopicFileStrings() {
        topicfilestrings = new String[numtopics];
        
        int count;
        char[] buf = new char[512];
        //        FileReader topic_file;
        InputStream is;
        InputStreamReader reader;
        String current;
        for (int i=0 ; i < numtopics ; i++) {

            // read from jar archive
            is = getClass().getResourceAsStream("help/"+topicnames[i]);
            if (is == null)
                GIDEN.out.println("Error reading help ("+topicnames[i]+").");
            else try {
                reader = new InputStreamReader(is);
                current = new String();
                while ((count = reader.read(buf)) >= 0)
                    current = current.concat(new String(buf,0,count));
                topicfilestrings[i] = new String(current);
                reader.close();
            } catch (IOException e) {GIDEN.out.println(e);}

            /*
            // read from files
            try {
                topic_file = new FileReader("help/"+topicnames[i]);
                current = new String();
                while ((count = topic_file.read(buf)) >= 0)
                    current = current.concat(new String(buf,0,count));
                topicfilestrings[i] = new String(current);
                topic_file.close();
            } catch(FileNotFoundException e) {
                GIDEN.out.println(e);
            } catch (IOException e) {
                GIDEN.out.println(e);
            }
            */
        }
    }
    
    
    synchronized private void updateTopicSelection() {
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        
        int i=topics.getSelectedIndex();
        
        topics.makeVisible(i);
        
        //    current_topic_text.setText(topicfilestrings[i]);
        
        
        viewer.setInputString(topicfilestrings[i]);
        //    repaint();
        
        
        current_topic_name.setText(topics.getSelectedItem());
        if (i == 0)
            prev.setEnabled(false);
        else
            prev.setEnabled(true);
        if (i == topics.getItemCount()-1)
            next.setEnabled(false);
        else
            next.setEnabled(true);

        UTILITIES.Repaint(sp, " -- GUIHelpInfoDialog:updateTopicSelection");
        //        sp.repaint();
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    
    
    /**********************************************************************/
    // action listener methods
    /**********************************************************************/
    public void actionPerformed(ActionEvent evt) {
        Object source = evt.getSource();
        
        if (source.equals(dismiss)) {
            if (parent instanceof GUIController)
                ((GUIController) parent).disposeGUIHelpInfoDialog();
            else 
                dispose();
        }
        else if (source.equals(prev)) {
            // make sure in bounds (can get out of bounds if click "prev"
            // button too fast in succession
            if (topics.getSelectedIndex() > 0) {
                topics.select(topics.getSelectedIndex()-1);
                updateTopicSelection();
            }
        }
        else if (source.equals(next)) {
            // make sure in bounds (can get out of bounds if click "next"
            // button too fast in succession
            if (topics.getSelectedIndex() < numtopics) {
                topics.select(topics.getSelectedIndex()+1);
                updateTopicSelection();
            }
        }
    }
    
    
    /**********************************************************************/
    // item listener methods
    /**********************************************************************/
    public void itemStateChanged(ItemEvent evt) {
        Object source = evt.getSource();
        
        if (source.equals(topics))
            updateTopicSelection();
    }
    
    
    /**********************************************************************/
    // window listener methods
    /**********************************************************************/
    public void windowActivated(WindowEvent evt)   {}
    public void windowClosed(WindowEvent evt)      {}
    public void windowClosing(WindowEvent evt)     {dispose();}
    public void windowDeactivated(WindowEvent evt) {}
    public void windowDeiconified(WindowEvent evt) {}
    public void windowIconified(WindowEvent evt)   {}
    public void windowOpened(WindowEvent evt)      {}
}
