package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;


public class GUIIconButton extends Component implements MouseListener {
    boolean selected = false;
    
    Image selected_icon;
    Image deselected_icon;
    int width;
    int height;
    
    
    GUIIconButton(Image img, Image img2) {
        selected_icon = img;
        deselected_icon = img2;
        
        // both icons assumed to have same height and width
        width = img.getWidth(this);
        height = img.getHeight(this);
        
        addMouseListener(this);
    }
    
    public void paint(Graphics g) {
        if (selected) {
            g.drawImage(selected_icon,0,0,this);
        }
        else {
            g.drawImage(deselected_icon,0,0,this);
        }
    }
    
    public boolean isSelected() {return selected;}
    
    public void select() {
        selected = true;
        if (isShowing()) 
            UTILITIES.Repaint(this,"select");
    }
    
    public void deselect() {
        selected = false;
        if (isShowing())
            UTILITIES.Repaint(this,"deselect");
    }
    
    
    
    public Dimension getMinimumSize() {
        return new Dimension(width, height);
    }
    public Dimension getPreferredSize() {
        return new Dimension(width, height);
    }
    
    
    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt)  {}
    public void mousePressed(MouseEvent evt)  {
        if (!selected)
            ((GUIController)getParent()).selectGUIIconButton(this);
        //        UTILITIES.Repaint(this,"mousePressed");
    }
    public void mouseReleased(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt)  {}
    public void mouseExited(MouseEvent evt)   {}
    
}
