package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.image.*;


public class GUIImageComponent extends Component implements java.io.Serializable {
    
    private String filename = "";
    protected Dimension imageDim;
    transient protected Image image = null;
    protected int transparentPixel = -1;
    protected byte[] pixels = null;
    
    GUIImageComponent(String filename) {
        this.filename = new String(filename);
        initialize();
    }
    
    protected void initialize() {
        initializeImage(filename);
        setupInfo(image);
    }
    
    protected void checkInitialization() {
        // if reading from a file, we need to reload "image" using
        // "filename"; this is necessary since "image" is transient
        if (image == null)
            initialize();
    }
    
    protected void initializeImage(String filename) {
        MediaTracker tracker = new MediaTracker(this);
        // owenj-jar(1)        image = getToolkit().getImage(filename);
        image = getToolkit().getImage(getClass().getResource(filename));
        tracker.addImage(image,1);
        try {
            tracker.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
    
    protected void setupInfo(Image img) {
        PixelGrabber pg = new PixelGrabber(img,0,0,-1,-1,false);
        pg.startGrabbing();
        try {
            pg.grabPixels();
        } catch (Exception e) {
            e.printStackTrace();
        }
        imageDim = new Dimension(pg.getWidth(),pg.getHeight());
        if (pg.getColorModel() instanceof IndexColorModel) {
            pixels = (byte[])pg.getPixels();
            transparentPixel = ((IndexColorModel)pg.getColorModel()).getTransparentPixel();
        }
    }
    
    
    public boolean contains(int x, int y, int centerX, int centerY) {
        checkInitialization();
        
        int ulcX = centerX - imageDim.width/2;
        int ulcY = centerY - imageDim.height/2;
        
        if (x >= ulcX && x < ulcX+imageDim.width
            && y >= ulcY && y < ulcY+imageDim.height)
            return pixels == null ||
                pixels[(x-ulcX)+(y-ulcY)*imageDim.width] != transparentPixel;
        else
            return false;
    }
    
    public int getHeight() {
        checkInitialization();
        return imageDim.height;
    }
    public int getWidth()  {
        checkInitialization();
        return imageDim.width;
    }
    public Image getImage() {
        checkInitialization();
        return image;
    }
}
