package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
import giden.contrib.*;
import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import java.util.Properties;    // dsd 040626 local pc file test

public class GUINetworkWindow extends Frame implements ActionListener, 
                                                ItemListener,
                                                WindowListener {
    GdnHtmlWindow GidenHelpWindow;                                      // dsd 020302
    GdnHtmlWindow SolverInfoWindow;                                   // dsd 020303
    
    String GidenHelpFile;                                               // dsd 020302
    String SolverInfoFile;                                               // dsd 020302
    
    static final String GIDEN_NETWORK_HELP_FILE = "GidenNetworkHelp.html"; // dsd 020302
    static final String GIDEN_SOLVER_HELP_FILE="GidenSolverHelp.html";     // dsd 020302
    public GUINetwork UiNet;

    String netmode_title = "";

    GUIStatusLineInfo status_line_info;
    TextField status_line_input;
    //    Panel status_line_panel = new Panel (new FlowLayout(FlowLayout.LEFT,5,0));
    Panel status_line_panel = new GUIStatusLinePanel();
    
    public /*protected*/ GUIAnimationControl animation_control;

    public GUIController parent;
    public File   netfile;
    protected String dirname;
    protected String filename;
    public long   modtime = 0;
    String netname;
    public MenuItem save_mi;
    public MenuItem parent_mi;
    MenuItem grid_mi;
    boolean hiddenByParent;
    
    public static final String EXIT = " Exit ";

    // animation control "action button" states
    public static final String TRACE            = " Trace ";
    public static final String FINAL            = " Final ";
    public static final String STEP             = " Step ";
    public static final String GO_CONTINUOUS    = "  Go  ";
    public static final String PAUSE_CONTINUOUS = " Pause ";
    public static final String RESET_SOLVER     = " Reset ";
    // pseudocode "control button" state
    static final String PC_NEXT          = " Next ";

    private final String MST_KRUSKAL   = "Kruskal";
    private final String MST_PRIM      = "Prim";
    private final String SP_DIJKSTRA   = "Dijkstra";
    private final String SP_LABCO      = "FIFO Label Correcting";
    private final String MF_GAP        = "Generic Augmenting Path";
    private final String MF_SAP        = "Shortest Augmenting Path";
    private final String MF_PREFLOW    = "Pre-Flow Push";
    private final String MCF_CAP_SCALE = "Capacity Scaling";
    private final String MCF_CYCLE     = "Cycle Canceling";
    private final String MCF_SIMPLEX   = "Network Simplex";
    private final String MCF_KILTER    = "Out-of-Kilter";
    private final String MCF_SSP       = "Successive Shortest Path";
    private final String TSP_SYMMETRIC = "Symmetric TSP Heuristics";
        

    protected final String solvernames[] = {MST_KRUSKAL, MST_PRIM,
                                            SP_DIJKSTRA, SP_LABCO,
                                            MF_GAP, MF_SAP, MF_PREFLOW,
                                            MCF_CAP_SCALE, MCF_CYCLE,
                                            MCF_KILTER, MCF_SIMPLEX, MCF_SSP,
                                            TSP_SYMMETRIC };
    
    public /*protected*/ GUIDrawCanvas draw_canvas = null;
    private int current_tool = GUIController.UNKNOWN_TOOL;
    
    Panel bottom_panel = new Panel(new BorderLayout());
    
    Panel version_info = new Panel(new BorderLayout());
    GUIImageCanvas mini_icon_canvas;
    Image mini_icon;
    Label version_label;
    
    public MenuBar mb = new MenuBar();
    Menu file_n, file_s;
    Menu edit_n, edit_s;
    
    Menu node_data_n; 
    Menu delete_node_data_n;
    protected CheckboxMenuItem node_arrays[];
    protected int node_array_count;
    
    Menu edge_data_n; 
    Menu delete_edge_data_n;
    protected CheckboxMenuItem edge_arrays[];
    protected int edge_array_count;
    
    Menu solvers_n;
    Menu options_s;
    Menu help_n,help_s;                                       // dsd 020302
    MenuItem SolverInfo;
    
    // allocated here to avoid unll pointer exception in setDirected
    CheckboxMenuItem drawDirectedNetwork = new CheckboxMenuItem("Directed Edges");

    CheckboxMenuItem showPCwindow;
    CheckboxMenuItem animationDetail;
    protected GUIPseudoCodeWindow PCwindow;
    
    GUIFlowPanel algorithm_animation_sets = new GUIFlowPanel(FlowLayout.LEFT);
    GUIFlowPanel final_animation_sets = new GUIFlowPanel(FlowLayout.LEFT);
    
    GUISetSwatch traceset_buttons[] = null;
    GUISetSwatch final_traceset_buttons[] = null;
    
    
    protected boolean solver_mode;
    public boolean inSolverMode() {
        return solver_mode;
    }
    public void registerSolverModeMouseSelection(Object obj, int modifiers) {
        if (obj == null) {
            GIDEN.out.println("Empty user click (neither a node nor an edge)");
        }
        else if (obj instanceof UiNode) {
            GIDEN.out.println("User clicked on a node");
        }
        else if (obj instanceof UiEdge) {
            GIDEN.out.println("User clicked on an edge");
        }
    }
    
    public void resetPCTextLine() {
        if (PCwindow != null)
            PCwindow.resetPCTextLine();
    }
    public boolean showPCTextLine(int line) {
        if (PCwindow != null)
            return PCwindow.showPCTextLine(line);
        else
            return false;
    }
    public boolean showPCTextLine(String token) {
        if (PCwindow != null)
            return PCwindow.showPCTextLine(token);
        else
            return false;
    }

    
    
    //------------------------------------
    // DSD call to terminate the solver thread
    // - implemented in the derived class
    //------------------------------------
    public void TerminateSolverThread() {}
    
    void updateTool(int tool) {
GIDEN.out.println("Tool update:  old="+current_tool+", new="+tool);        
        this.current_tool = tool;
        draw_canvas.updateTool(tool);
    }
    
    // temp kludge to get paste to work.  will fix for more general
    // use later on.
    public void enableEditModeMenu(String name) {
        for (int i=0 ; i < edit_n.getItemCount() ; i++) {
            MenuItem mi = (MenuItem)edit_n.getItem(i);
            if (mi.getLabel().equals(name)) {
                mi.setEnabled(true);
                break;
            }
        }
    }
    public void disableEditModeMenu(String name) {
        for (int i=0 ; i < edit_n.getItemCount() ; i++) {
            MenuItem mi = (MenuItem)edit_n.getItem(i);
            if (mi.getLabel().equals(name)) {
                mi.setEnabled(false);
                break;
            }
        }
    }
    

    public void notifyOfSolverWarning(String msg) {
        new GUIModalMessageDialog(this,GUIModalMessageDialog.WARNING,msg);
    }
    public void notifyOfSolverError(String msg) {
        new GUIModalMessageDialog(this,GUIModalMessageDialog.ERROR,msg);
    }
    public void notifyOfSolverNotice(String msg) {
        new GUIModalMessageDialog(this,GUIModalMessageDialog.NOTICE,msg);
    }
    public void notifyOfSolverStart() {
        // make sure that the buttons (GUISetSwatch items) that are
        // displayed are in sync with the go_button; recall that the
        // buttons may get out of sync in the method
        // "notifyOfSolverFinish()"

        // should be called after the methods "setupSolverMode()",
        // "createAlgorithmAnimationSetButtons()", and
        // "createFinalAnimationSetButtons()".

        // owenj 27-May-1999
        // clear out final animation sets before running (rely on
        // Dave's policy to set this after the return from the
        // solver's Execute() method)
        final_animation_sets.removeAll();
        
        bottom_panel.remove(1);       // remove the sets displayed

        if (current_anim_mode.equals(FINAL))
            bottom_panel.add(final_animation_sets,BorderLayout.CENTER);
        else
            bottom_panel.add(algorithm_animation_sets,BorderLayout.CENTER);

        invalidate(); 
        validate(); 
        UTILITIES.Repaint(this,"notifyOfSolverStart");
    }
    public void notifyOfSolverFinish() {
        // set "reset mode" and disable pseudocode "next"
        animation_control.enableReset();
        if (PCwindow != null)
            PCwindow.setEnabled(false);

        // display the final animation sets, since the sovler is
        // finished running
        bottom_panel.remove(1);       // remove the sets displayed
        bottom_panel.add(final_animation_sets,BorderLayout.CENTER);

        invalidate(); 
        validate(); 
        UTILITIES.Repaint(this,"notifyOfSolverFinish");
    }

    public GUISetSwatch[] createAlgorithmAnimationSetButtons(Color[] colors, 
                                                             String[] names,
                                                             int size) {
        if (size < 0) {
            GIDEN.out.println("Error! Length of colors and names arrays should be positive");
            return null;
        }
        
        algorithm_animation_sets.removeAll();
        traceset_buttons = new GUISetSwatch[size];
        for (int i=0 ; i < size ; i++) {
            traceset_buttons[i] = new GUISetSwatch(colors[i],names[i],this);
            traceset_buttons[i].addActionListener(this);

            // owenj kludge:  sets button as "selected" by default
            traceset_buttons[i].toggle(); 
            if (!"".equals(names[i]))
                algorithm_animation_sets.add(traceset_buttons[i]);
        }
        return traceset_buttons;
    }
    
    public GUISetSwatch[] createFinalAnimationSetButtons(Color[] colors,
                                                         String[] names,
                                                         int size) {
        if (size < 0) {
            GIDEN.out.println("Error! Length of colors and names arrays should be positive");
            return null;
        }
        
        final_animation_sets.removeAll();
        final_traceset_buttons = new GUISetSwatch[size];
        for (int i=0 ; i < size ; i++) {
            final_traceset_buttons[i] = new GUISetSwatch(colors[i],names[i],this);
            final_traceset_buttons[i].setEnabled(false);
            final_traceset_buttons[i].addActionListener(this);
            if (!"".equals(names[i]))
                final_animation_sets.add(final_traceset_buttons[i]);
        }
        return final_traceset_buttons;
    }
    
    
    
    private String current_action_mode = "";
    public String getActionMode() {
        return current_action_mode;
    }
    public void setActionMode(String mode) {
        current_action_mode = new String(mode);
    }
    
    
    public void clearStatusLine() {
        putStatusLineInfo("");
    }
    
    public void putStatusLineInfo(String message) {
        status_line_input.setVisible(false);
        status_line_info.setText(message);
        status_line_info.invalidate();
        status_line_panel.validate();
        
        invalidate(); 
        validate(); 
        UTILITIES.Repaint(this,"putStatusLineInfo");
    }
    
    public TextField getStatusLineTextInput(String question, String default_answer) {
        status_line_input.setText(default_answer);
        status_line_input.setColumns(default_answer.length());
        status_line_input.setVisible(true);
        status_line_input.invalidate();
        
        status_line_info.setText(question);
        status_line_info.invalidate();
        status_line_panel.validate();
        
        invalidate(); 
        validate(); 
        UTILITIES.Repaint(this,"getStatusLineTextInput");
        
        status_line_input.selectAll();
        status_line_input.requestFocus();
        return status_line_input;
    }
    
    public void getNodeSelection(String prompt) {
        putStatusLineInfo(prompt);
        // to DSD: when you override registerSolverNodeSelection(), make
        // sure to clear the status line...
    }
    public void getEdgeSelection(String prompt) {
        putStatusLineInfo(prompt);
        // to DSD: when you override registerSolverEdgeSelection(), make
        // sure to clear the status line...
    }
    
    public void setupAuxMode() {
        // set window title to reflect selected solver
        //setTitle(netmode_title+"  ["+solvername+"]");

        // disable updates until we are finished setting up solver mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = false;

        // set solver_mode boolean
        solver_mode = true;
        if (draw_canvas != null)
            draw_canvas.resetState();

        
        invalidate(); 

        // re-enable updates now that we are finished setting up solver mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = true;
        
        UTILITIES.Repaint(draw_canvas,"setupAuxMode(dc)");
        UTILITIES.Repaint(this,"setupAuxMode");
    }

        
    
    // dsd private void setupSolverMode() {
    /*
    public void setupSolverMode() {
        setupSolverMode("default");
    }
    */
    
    public void setupSolverInfo(String filename)
    {
        GIDEN.out.println("SolverInfo: "+filename);
        SolverInfo.setEnabled(true);
        SolverInfoFile=filename;
    }
    
    public void setupSolverMode(String solvername) {
        // set window title to reflect selected solver
        
        String dotname;
        GUISolver gs = (GUISolver)this;
        dotname = gs.GetSolver().getClass().getName();
        String slashname = dotname.replace('.','/');
        
        setTitle(netmode_title+"  ["+solvername+"]");

        // disable updates until we are finished setting up solver mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = false;

        // set solver_mode boolean
        solver_mode = true;
        if (draw_canvas != null)
            draw_canvas.resetState();

        // turn off grid (if visible)
        if (draw_canvas.canvas_grid.isVisible()) {
                draw_canvas.canvas_grid.setVisible(false);
                draw_canvas.canvas_grid.setEnabled(false);
                grid_mi.setLabel("Enable Grid");
        }
//        GIDEN.out.println("setupSolverMode: Above manage pc window");


        // manage pc window

        // TEMPORARY CODE to make sure that file for solver exists; if
        // not, then open a de fault (dummy) file:
        
        ///* dsd dec2001 workaround
        InputStream instream = getClass().getResourceAsStream("gidenPC/"+solvername+".txt");
        
        if (instream == null)   // may need to work from CORE
            instream = getClass().getResourceAsStream("/giden/userPC/"+solvername+".txt");
        if (instream == null)
        {
            GIDEN.out.println("PC file = "+slashname);
            instream = getClass().getResourceAsStream("/"+slashname+".txt");
        }
        /* dsd commented out 2004 06 27, using resource now
        if(instream==null) {
            // pseudocode does not exist or is not for a "standard" solver

            // check to see if the pseudocode exists in the local filesystem
            
            File pcfile;
            pcfile = new File("./giden/userPC/"+solvername+".txt"); // implementor
            if (!pcfile.exists()) 
                pcfile = new File(slashname+".txt"); // developer
            if (pcfile.exists())  {      
                
                showPCwindow.setEnabled(true);
                showPCwindow.setState(false);
                
                try {
                    
                    FileReader reader = new FileReader(pcfile);
                    
                    PCwindow = new GUIPseudoCodeWindow(this,solvername,reader);
                    
                } catch(FileNotFoundException e) {
                    GIDEN.out.println(e);
                    showPCwindow.setEnabled(false);
                    showPCwindow.setState(false);
                }
            }
            else {
            
                
                // pseudocode does not exist --- should disable menu, etc.
                GIDEN.out.println("Error reading pseudocode \""+solvername+"\"");
                showPCwindow.setEnabled(false);
                showPCwindow.setState(false);
                PCwindow = null;
            }
        }
        */
        if(instream==null)
        {
                // pseudocode does not exist --- should disable menu, etc.
                GIDEN.out.println("Couldn't find pseudocode \""+solvername+"\"");
                showPCwindow.setEnabled(false);
                showPCwindow.setState(false);
                PCwindow = null;
            
        }
        else {
            
            showPCwindow.setEnabled(true);
            showPCwindow.setState(false);
            InputStreamReader reader = new InputStreamReader(instream);
            PCwindow = new GUIPseudoCodeWindow(this,solvername,reader);
        }
        
        
        /*
            // pseudocode does not exist or is not for a "standard" solver

            // check to see if the pseudocode exists in the local filesystem
            File pcfile;
            
            pcfile = new File("giden/userPC/"+solvername+".txt");
            if (pcfile.exists())
            {
                showPCwindow.setEnabled(true);
                showPCwindow.setState(false);
                try {
                    FileReader reader = new FileReader(pcfile);
                    PCwindow = new GUIPseudoCodeWindow(this,solvername,reader);
                } catch(FileNotFoundException e) {
                    GIDEN.out.println(e);
                    showPCwindow.setEnabled(false);
                    showPCwindow.setState(false);
                }
            }
            else
            {
                pcfile = new File("giden/gidenPC/"+solvername);
                if (pcfile.exists())
                {
                    showPCwindow.setEnabled(true);
                    showPCwindow.setState(false);
                    try
                    {
                        FileReader reader = new FileReader(pcfile);
                        PCwindow = new GUIPseudoCodeWindow(this,solvername,reader);
                    }
                    catch(FileNotFoundException e)
                    {
                        GIDEN.out.println(e);
                        showPCwindow.setEnabled(false);
                        showPCwindow.setState(false);
                }                
            }
            else
            {
                // pseudocode does not exist --- should disable menu, etc.
                GIDEN.out.println("Error reading pseudocode \""+solvername+"\"");
                showPCwindow.setEnabled(false);
                showPCwindow.setState(false);
                PCwindow = null;
            }
            
        }
        */
//        GIDEN.out.println("setupSolverMode: Above GidenHelpWindow");

        if(GidenHelpWindow!=null)
        {
            GidenHelpWindow.dispose();
            GidenHelpWindow=null;
        }
        if(SolverInfoWindow!=null)
        {
            SolverInfoWindow.dispose();
            SolverInfoWindow=null;
        }

        GidenHelpFile=GIDEN_SOLVER_HELP_FILE;
        
        setSolverMenuBar();


        // set to "trace" mode
        current_anim_mode = new String(TRACE);
        setAnimationDetail(false);
        animation_control.setEnabled(true);
        animation_control.setMode(GUIAnimationControl.STOP_MODE);
        
        bottom_panel.setVisible(false);
        bottom_panel.removeAll();
        bottom_panel.add(animation_control,BorderLayout.WEST);
        bottom_panel.add(algorithm_animation_sets,BorderLayout.CENTER);
        
//        GIDEN.out.println("setupSolverMode: Above invalidate");
        
        
        invalidate(); 
        algorithm_animation_sets.setWidthReduction(animation_control.getPreferredSize().width);
        final_animation_sets.setWidthReduction(animation_control.getPreferredSize().width);
        bottom_panel.setVisible(true);
        validate(); 

        // re-enable updates now that we are finished setting up solver mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = true;
        
        UTILITIES.Repaint(draw_canvas,"setupSolverMode(dc)");
        UTILITIES.Repaint(this,"setupSolverMode");
    }
    
    // dsd  private void setupNetworkMode() {
    public void setupNetworkMode() {
        // set window title to reflect network mode
        setTitle(netmode_title);

        // disable updates until we are finished setting up network edit mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = false;

        // set solver_mode boolean
        solver_mode = false;
        

        // make sure to sync "directed" edge state
        // owenj 18-May-1999        setDirected(drawDirectedNetwork.getState());
        setDirected(UiNet.GetDirected());


        // the nodes and edges forget the current tool when Dave restores
        // the GUINode/EdgeInfo at solver exit; this is a fix
        draw_canvas.updateTool(current_tool);


        setNetworkMenuBar();
        traceset_buttons = null;
        final_traceset_buttons = null;
        algorithm_animation_sets.removeAll();
        final_animation_sets.removeAll();
        
        if (PCwindow != null) {
            PCwindow.dispose();
            PCwindow = null;
        }
        
        bottom_panel.removeAll();
        bottom_panel.add(version_info,BorderLayout.WEST);
        
        invalidate(); 
        validate(); 

        // re-enable updates now that we are finished setting up network mode
        if (draw_canvas != null)
            draw_canvas.repaint_enabled = true;

        UTILITIES.Repaint(draw_canvas,"setupNetworkMode(dc)");
        UTILITIES.Repaint(this,"setupNetworkMode");
        if(GidenHelpWindow!=null)
        {
            GidenHelpWindow.dispose();
            GidenHelpWindow=null;
        }
        if(SolverInfoWindow!=null)
        {
            SolverInfoWindow.dispose();
            SolverInfoWindow=null;
        }
        
        GidenHelpFile=GIDEN_NETWORK_HELP_FILE;
    }
    
    //-----------------------------------------------------------
    // dummy call, value is filled in GUISolver.java
    //-----------------------------------------------------------
    protected SolverMenu GetSolverMenu() {return null;} // dsd, 05-May-1999
    protected ContribSolverMenu GetContribSolverMenu() {return null;} // dsd, 05-May-1999
    
    
    private void setupMenus() {
        MenuItem mi;
        
        file_s = new Menu("File");
        //        mi = new MenuItem("Write tracable status for sets..."); mi.setEnabled(true); file_s.add(mi);
        mi = new MenuItem("Open Results..."); mi.setEnabled(false); file_s.add(mi);
        mi = new MenuItem("Save Results..."); mi.setEnabled(false); file_s.add(mi);
        file_s.add("-");
        mi = new MenuItem("Print Network..."); mi.setEnabled(true); file_s.add(mi);
        mi = new MenuItem("Print Window..."); mi.setEnabled(true); file_s.add(mi);
        file_s.add("-");
        mi = new MenuItem("Hide"); mi.setEnabled(true); file_s.add(mi);
        mi = new MenuItem("Close"); mi.setEnabled(true); file_s.add(mi);
        file_s.addActionListener(this);
        
        file_n = new Menu("File");
        //        mi = new MenuItem("Clear"); mi.setEnabled(false); file_n.add(mi);

        save_mi = new MenuItem("Save"); 
        if (netfile != null && netfile.exists()) 
            save_mi.setEnabled(true); 
        else 
            save_mi.setEnabled(false);
        file_n.add(save_mi);

        mi = new MenuItem("Save As..."); mi.setEnabled(true); file_n.add(mi);
        mi = new MenuItem("Save CSV..."); mi.setEnabled(true); file_n.add(mi);

        file_n.add("-");
        mi = new MenuItem("Print Network..."); mi.setEnabled(true); file_n.add(mi);
        mi = new MenuItem("Print Window..."); mi.setEnabled(true); file_n.add(mi);
        file_n.add("-");
        mi = new MenuItem("Hide"); mi.setEnabled(true); file_n.add(mi);
        mi = new MenuItem("Close"); mi.setEnabled(true); file_n.add(mi);
        file_n.addActionListener(this);
        
        edit_n = new Menu("Edit");
        mi = new MenuItem("Cut", new MenuShortcut(KeyEvent.VK_X));
        mi.setActionCommand("Cut"); mi.setEnabled(false); edit_n.add(mi);
        
        // We are not including these menu picks for now, b/c they
        // just don't work!
        /*
        mi = new MenuItem("Copy", new MenuShortcut(KeyEvent.VK_C));
        mi.setActionCommand("Copy"); mi.setEnabled(false); edit_n.add(mi);
        
        mi = new MenuItem("Paste", new MenuShortcut(KeyEvent.VK_V)); 
        mi.setActionCommand("Paste"); mi.setEnabled(false); edit_n.add(mi);
        */
        
        mi = new MenuItem("Clear", new MenuShortcut(KeyEvent.VK_X,true)); 
        mi.setActionCommand("Clear"); edit_n.add(mi);
        
        edit_n.add("-");
        mi = new MenuItem("Select All"); mi.setEnabled(false); edit_n.add(mi);
        mi = new MenuItem("Select All Nodes", new MenuShortcut(KeyEvent.VK_A)); 
        mi.setActionCommand("Select All Nodes"); mi.setEnabled(false); edit_n.add(mi);
        Menu nudge = new Menu("Nudge Selected");  nudge.setEnabled(false);
        mi = new MenuItem("Up", new MenuShortcut(KeyEvent.VK_UP));
        mi.setActionCommand("Nudge Up"); nudge.add(mi);
        mi.addActionListener(this);
        mi = new MenuItem("Down", new MenuShortcut(KeyEvent.VK_DOWN));
        mi.setActionCommand("Nudge Down"); nudge.add(mi);
        mi.addActionListener(this);
        mi = new MenuItem("Left", new MenuShortcut(KeyEvent.VK_LEFT));
        mi.setActionCommand("Nudge Left"); nudge.add(mi);
        mi.addActionListener(this);
        mi = new MenuItem("Right", new MenuShortcut(KeyEvent.VK_RIGHT));
        mi.setActionCommand("Nudge Right"); nudge.add(mi);
        mi.addActionListener(this);
        edit_n.add(nudge);
        
        edit_n.add("-");
        grid_mi = new MenuItem("Enable Grid", new MenuShortcut(KeyEvent.VK_G)); 
        grid_mi.setActionCommand("Toggle Grid"); edit_n.add(grid_mi);

        edit_n.add("-");
        //        drawDirectedNetwork = new CheckboxMenuItem("Directed Edges");
        //        setDirected(UiNet.GetDirected());
        drawDirectedNetwork.addItemListener(this);
        edit_n.add(drawDirectedNetwork);
        grid_mi.addActionListener(this);
        edit_n.addActionListener(this);
        
        edit_s = new Menu("Edit");
        mi = new MenuItem("Cut"); mi.setEnabled(false); edit_s.add(mi);
        mi = new MenuItem("Copy"); mi.setEnabled(false); edit_s.add(mi);
        mi = new MenuItem("Paste"); mi.setEnabled(false); edit_s.add(mi);
        mi = new MenuItem("Clear"); mi.setEnabled(false); edit_s.add(mi);
        edit_s.addActionListener(this);
        
        
        String name = "";
        
        node_data_n = new Menu("Node Data");
        delete_node_data_n = new Menu("Delete Data Field");
        node_arrays = new CheckboxMenuItem[UiNet.GetNodeArrayCount()];
        node_array_count = 0;
        for (name = UiNet.GetFirstNodeArrayName() ;
             name != null ; name = UiNet.GetNextNodeArrayName()) {
            if (!name.equals(UiNetwork.NodeIdString))
                delete_node_data_n.add(new MenuItem(name));
            node_arrays[node_array_count] = new CheckboxMenuItem(name);
            if (node_array_count == 0) 
                node_arrays[node_array_count].setState(true);
            else
                node_arrays[node_array_count].setState(false);
            node_arrays[node_array_count].addItemListener(this);
            node_data_n.add(node_arrays[node_array_count]);
            node_array_count++;
        }
        if (delete_node_data_n.getItemCount() == 0)
            delete_node_data_n.setEnabled(false);
        node_data_n.add("-");
        node_data_n.add(new MenuItem("Add Data Field..."));
        node_data_n.add(delete_node_data_n);
        delete_node_data_n.addActionListener(this);
        node_data_n.addActionListener(this);
        
        edge_data_n = new Menu("Edge Data");
        delete_edge_data_n = new Menu("Delete Data Field");
        edge_arrays = new CheckboxMenuItem[UiNet.GetEdgeArrayCount()];
        edge_array_count = 0;
        for (name = UiNet.GetFirstEdgeArrayName() ;
             name != null ; name = UiNet.GetNextEdgeArrayName()) {
            if (!name.equals(UiNetwork.EdgeIdString) && 
                !name.equals(UiNetwork.EuclideanLengthString))
                delete_edge_data_n.add(new MenuItem(name));
            edge_arrays[edge_array_count] = new CheckboxMenuItem(name);
            if (edge_array_count == 0)
                edge_arrays[edge_array_count].setState(true);
            else
                edge_arrays[edge_array_count].setState(false);
            edge_arrays[edge_array_count].addItemListener(this);
            edge_data_n.add(edge_arrays[edge_array_count]);
            edge_array_count++;
        }
        if (delete_edge_data_n.getItemCount() == 0)
            delete_edge_data_n.setEnabled(false);
        edge_data_n.add("-");
        edge_data_n.add(new MenuItem("Add Data Field..."));
        edge_data_n.add(delete_edge_data_n);
        delete_edge_data_n.addActionListener(this);
        edge_data_n.addActionListener(this);
        
        
        GUISolverMenuListener solver_listener = new GUISolverMenuListener();
        solvers_n = new Menu("Solvers");
        Menu spanning = new Menu("Minimum Spanning Tree");
        spanning.addActionListener(solver_listener);
        mi = new MenuItem(MST_KRUSKAL); spanning.add(mi);
        mi = new MenuItem(MST_PRIM); spanning.add(mi);
        solvers_n.add(spanning);
        Menu shortpath = new Menu("Shortest Path");
        shortpath.addActionListener(solver_listener);
        mi = new MenuItem(SP_DIJKSTRA); shortpath.add(mi);
        mi = new MenuItem(SP_LABCO); shortpath.add(mi);
        solvers_n.add(shortpath);
        Menu maxflow = new Menu("Maximum Flow");
        maxflow.addActionListener(solver_listener);
        mi = new MenuItem(MF_GAP); maxflow.add(mi);
        mi = new MenuItem(MF_SAP); maxflow.add(mi);
        mi = new MenuItem(MF_PREFLOW); maxflow.add(mi);
        solvers_n.add(maxflow);
        Menu mincostflow = new Menu("Minimum-Cost Flow");
        mincostflow.addActionListener(solver_listener);
        mi = new MenuItem(MCF_CAP_SCALE); mincostflow.add(mi);
        mi = new MenuItem(MCF_CYCLE); mincostflow.add(mi);
        mi = new MenuItem(MCF_KILTER); mincostflow.add(mi);
        mi = new MenuItem(MCF_SIMPLEX); mincostflow.add(mi);
        mi = new MenuItem(MCF_SSP); mincostflow.add(mi);
        solvers_n.add(mincostflow);

        Menu tsp = new Menu("Traveling Salesman Problem");
        tsp.setEnabled(false);
        /* disable TSP in beta version
           //        tsp.addActionListener(solver_listener);
           //        mi = new MenuItem(TSP_SYMMETRIC); tsp.add(mi);
        */
        solvers_n.add(tsp);

        // create menu picks for user-implemented solvers
        solvers_n.add("-");
        ContribSolverMenu contrib=GetContribSolverMenu();        
        SolverMenu solvermenu=GetSolverMenu();        
        
        String problem_name, solver_name;
        
        problem_name=contrib.FirstProblem();
        while(problem_name!=null) {
            Menu user_menu = new Menu(problem_name);
            user_menu.addActionListener(solver_listener);
            solver_name=contrib.FirstSolver();
            while(solver_name!=null) {
                mi = new MenuItem(solver_name); user_menu.add(mi);
                solver_name=contrib.NextSolver();
            }
            solvers_n.add(user_menu);
            problem_name=contrib.NextProblem();
        }
              
        problem_name=solvermenu.FirstProblem();
        while(problem_name!=null) {
            Menu user_menu = new Menu(problem_name);
            user_menu.addActionListener(solver_listener);
            solver_name=solvermenu.FirstSolver();
            while(solver_name!=null) {
                mi = new MenuItem(solver_name); user_menu.add(mi);
                solver_name=solvermenu.NextSolver();
            }
            solvers_n.add(user_menu);
            problem_name=solvermenu.NextProblem();
        }
        
        solvers_n.addActionListener(solver_listener);
        
        options_s = new Menu("Options");
        showPCwindow = new CheckboxMenuItem("Show Pseudo-Code Window");
        showPCwindow.setState(false);
        showPCwindow.addItemListener(this);
        options_s.add(showPCwindow);
        animationDetail = new CheckboxMenuItem("Detail Animation");
        animationDetail.setState(false);
        animationDetail.addItemListener(this);
        options_s.add(animationDetail);
        options_s.addActionListener(this);
        
        help_n = new Menu("Help");
        mi = new MenuItem("Help"); mi.setEnabled(true); help_n.add(mi);
        help_n.addActionListener(this);
                
        help_s = new Menu("Help");
        mi = new MenuItem("Help"); mi.setEnabled(true); help_s.add(mi);
        SolverInfo = new MenuItem("Info"); SolverInfo.setEnabled(false); help_s.add(SolverInfo);
        help_s.addActionListener(this);
    }
    
    
    private void setNetworkMenuBar() {
        SolverInfo.setEnabled(false);
        mb.remove(edit_s);
        mb.remove(options_s);
        mb.remove(help_s);
        
        mb.add(file_n);
        mb.add(edit_n);
        mb.add(node_data_n);
        mb.add(edge_data_n);
        mb.add(solvers_n);
        mb.add(help_n);
        
        mb.remove(file_s);
    }
    
    private void setSolverMenuBar() {
        mb.remove(edit_n);
        mb.remove(node_data_n);
        mb.remove(edge_data_n);
        mb.remove(solvers_n);
        mb.remove(help_n);
        
        mb.add(file_s);
        mb.add(edit_s);
        mb.add(options_s);
        mb.add(help_s);
        
        mb.remove(file_n);
    }
    
    public void updateNameRelatedInfo(String netname,
                                      String windowname,
                                      MenuItem parent_mi) {
        this.netname = new String(netname);
        this.netmode_title = new String("GIDEN   "+windowname);
        setTitle(this.netmode_title);
        this.parent_mi = parent_mi;
    }


    /*
    // In an effort to kill some of the flicker, we use a boolean flag
    private boolean repaint_enabled = true;
    public void update(Graphics g) {
        GIDEN.out.println("++ update ; "+repaint_enabled);
        if (!repaint_enabled) return;
        super.update(g);
    }
    public void paint(Graphics g) {
        GIDEN.out.println("++ paint ; "+repaint_enabled);
        if (!repaint_enabled) return;
        super.paint(g);
    }
    public void paintComponents(Graphics g) {
        GIDEN.out.println("++ paintComponents ; "+repaint_enabled);
        if (!repaint_enabled) return;
        super.paintComponents(g);
    }
    */


    public GUINetworkWindow(GUIController parent,
                     File          netfile,
                     String        dirname,
                     String        filename,
                     String        netname,
                     String        windowname,
                     MenuItem      parent_mi,
                     GUINetwork    net) {
        super();
        
        GidenHelpWindow=null;
        SolverInfoWindow=null;
        GidenHelpFile=GIDEN_NETWORK_HELP_FILE;
        SolverInfoFile=null;
        
        UiNet = net;

        current_tool = parent.getCurrentTool();
        addWindowListener(this);

        this.dirname = dirname;
        this.filename = filename;
        this.netfile = netfile;
        if (netfile != null && netfile.exists())
            modtime = netfile.lastModified();
        else
            modtime = (long) 0;

        this.netname = new String(netname);
        this.netmode_title = new String("GIDEN   "+windowname);
        setTitle(this.netmode_title);
        
        //        setSize(600,400);
        setLocation(parent.getLocation().x+20, parent.getLocation().y+20);
        //        setLocation(parent.getLocation().x+parent.getSize().width,
        //                    parent.getLocation().y);
        setIconImage(parent.getIconImage());
        
        this.parent = parent;
        this.parent_mi = parent_mi;
        
        setupMenus();
        setNetworkMenuBar();
        //    setSolverMenuBar();
        this.setMenuBar(mb);
        
        // set solver_mode boolean
        solver_mode = false;
        
        BorderLayout bl = new BorderLayout();
        setLayout(bl);
        
        status_line_info = new GUIStatusLineInfo("");
        status_line_panel.add(status_line_info);
        status_line_input = new TextField("");
        status_line_input.addActionListener(this);
        
        status_line_input.setVisible(true);
        status_line_panel.add(status_line_input);
        status_line_panel.setBackground(Color.lightGray);
        add(status_line_panel,BorderLayout.NORTH);
        
        current_anim_mode = new String(TRACE);
        animation_control = new GUIAnimationControl(this);


        MediaTracker tracker = new MediaTracker(this);
        /* owenj-jar(1)*/   // dsd dec2001
        mini_icon = getToolkit().getImage("image/giden-mini-icon.gif");
        //mini_icon = getToolkit().getImage(getClass().getResource("image/giden-mini-icon.gif"));
        tracker.addImage(mini_icon,0);
        try{
            tracker.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
        mini_icon_canvas = new GUIImageCanvas(mini_icon);
        version_info.add(mini_icon_canvas,BorderLayout.WEST);
        
        //        version_label = new Label("GIDEN v.2.0a (05211999)   ");
        //        version_label = new Label("GIDEN v.2.0a    ");
        /*
        version_label = new Label("GIDEN v.2.0a ("
                                  +(new SimpleDateFormat("ddMMyyyy",Locale.US)).format(new Date())
                                  +")    ");
        */
        //version_label = new Label("GIDEN  "
        //                          +System.getProperty("giden.version",""));
        version_label = new Label("Giden applet");
        version_label.setFont(new Font("SansSerif",Font.PLAIN,12));
        version_info.add(version_label,BorderLayout.CENTER);
        
        
        bottom_panel.add(version_info,BorderLayout.WEST);
        add(bottom_panel,BorderLayout.SOUTH);
        bottom_panel.setBackground(Color.lightGray);
        
        draw_canvas = new GUIDrawCanvas(parent, this, UiNet);
        draw_canvas.setBackground(Color.white);
        //        add(draw_canvas,BorderLayout.CENTER);

        // now that we have the draw canvas, we can set the directed info
        setDirected(UiNet.GetDirected());

        /*
        // this works fairly well, but it'll take more work to be right
        ScrollPane sp = new ScrollPane();
        sp.add(draw_canvas);
        add(sp,BorderLayout.CENTER);
        */
        add(draw_canvas,BorderLayout.CENTER);

        pack();
        
        status_line_info.setHeight(status_line_panel.getSize().height);
        status_line_input.setVisible(false);
        status_line_input.invalidate();
        status_line_panel.validate();

        setSize(600,400);
        show();
        
        hiddenByParent = false;
    }
    
    public void unhide_net() {
        if (hiddenByParent) {
            hiddenByParent = false;
        }
	setVisible(true);
	toFront();
	if (PCwindow != null && showPCwindow.getState()) {
            PCwindow.setVisible(true);
	    PCwindow.toFront();
	}
    }
    
    public void hide_net() {
        setVisible(false);
	if (PCwindow != null)
	    PCwindow.setVisible(false);
    }

    private void buildGBConstraints(GridBagConstraints gbc, int gx, int gy,
                                    int gw, int gh, int wx, int wy) {
        gbc.gridx = gx;
        gbc.gridy = gy;
        gbc.gridwidth = gw;
        gbc.gridheight = gh;
        gbc.weightx = wx;
        gbc.weighty = wy;
    }
    
    public String getNetworkName() {return netname;}
    
    public void createNodeDataField(String new_array_name, Object fill) // dsd 000824
    {
        createNodeDataField(new_array_name, fill, true);
    }
                                    // dsd 00824 dsd - added change_view    
    public void createNodeDataField(String new_array_name, Object fill, boolean change_view) {
        if (node_arrays.length <= node_array_count) {
            CheckboxMenuItem[] new_node_arrays = new CheckboxMenuItem[node_array_count+1];
            for (int j=0 ; j < node_array_count ; j++)
                new_node_arrays[j] = node_arrays[j];
            node_arrays = new_node_arrays;
        }
        node_arrays[node_array_count] = new CheckboxMenuItem(new_array_name,false);
        node_arrays[node_array_count].addItemListener(this);
        node_data_n.insert(node_arrays[node_array_count],UiNet.GetNodeArrayCount());
        node_array_count++;
        
        if (delete_node_data_n.getItemCount() == 0)
            delete_node_data_n.setEnabled(true);
        delete_node_data_n.add(new_array_name);
        
        UiNodeArray na = UiNet.CreateNodeArray(new_array_name);
        na.Fill(fill);
        
        if(change_view)        // dsd 000824
            setNodeDataView(new_array_name);
    }
    
    
    private void setNodeDataView(String name) {
        for (int i=0 ; i < node_array_count ; i++) {
            if (node_arrays[i] != null) {
                if (name.equals(node_arrays[i].getActionCommand()))
                    node_arrays[i].setState(true);
                else
                    node_arrays[i].setState(false);
            }
        }
        if (draw_canvas != null) {
            boolean editable = (!name.equals(UiNetwork.NodeIdString));
            draw_canvas.updateNodeData(name,editable);
        }
    }
    public void createEdgeDataField(String new_array_name, Object fill) // dsd 000825
    {
        createEdgeDataField(new_array_name, fill, true);
    }
    
                    // dsd 000825 added change_view
    public void createEdgeDataField(String new_array_name, Object fill, boolean change_view) {
        if (edge_arrays.length <= edge_array_count) {
            CheckboxMenuItem[] new_edge_arrays = new CheckboxMenuItem[edge_array_count+1];
            for (int j=0 ; j < edge_array_count ; j++)
                new_edge_arrays[j] = edge_arrays[j];
            edge_arrays = new_edge_arrays;
        }
        edge_arrays[edge_array_count] = new CheckboxMenuItem(new_array_name,false);
        edge_arrays[edge_array_count].addItemListener(this);
        edge_data_n.insert(edge_arrays[edge_array_count],UiNet.GetEdgeArrayCount());
        edge_array_count++;
        
        if (delete_edge_data_n.getItemCount() == 0)
            delete_edge_data_n.setEnabled(true);
        delete_edge_data_n.add(new_array_name);
        
        UiEdgeArray ea = UiNet.CreateEdgeArray(new_array_name);
        ea.Fill(fill);
        
        if(change_view)
            setEdgeDataView(new_array_name);
    }
    
    
    private void setEdgeDataView(String name) {
        for (int i=0 ; i < edge_array_count ; i++) {
            if (edge_arrays[i] != null) {
                if (name.equals(edge_arrays[i].getActionCommand()))
                    edge_arrays[i].setState(true);
                else
                    edge_arrays[i].setState(false);
            }
        }
        if (draw_canvas != null) {
            boolean editable = (!name.equals(UiNetwork.EdgeIdString) &&
                                !name.equals(UiNetwork.EuclideanLengthString));
            draw_canvas.updateEdgeData(name,editable);
        }
    }
    
    /**********************************************************************/
    // action listener method
    /**********************************************************************/
    public void actionPerformed(ActionEvent evt) {
        Object src = evt.getSource();

        if (src instanceof Button) {
            String what = evt.getActionCommand();

            if (what.equals(TRACE)) {
                setActionMode(what);
                animation_control.setEnabled(false);
		if (PCwindow != null)
		    PCwindow.setEnabled(false);
	    }
            if (what.equals(FINAL)) {
                setActionMode(what);
                animation_control.setEnabled(false);
                if (PCwindow != null)
		    PCwindow.setEnabled(false);
            }
	    if (what.equals(STEP)) {
                setActionMode(what);
                animation_control.setEnabled(false);
                if (PCwindow != null)
		    PCwindow.setEnabled(false);
            }
            if (what.equals(GO_CONTINUOUS)) {
                setActionMode(what);
                animation_control.setEnabled(false);
		if (PCwindow != null)
  		    PCwindow.setEnabled(false);
            }
            if (what.equals(PAUSE_CONTINUOUS)) {
                setActionMode(what);
                animation_control.setEnabled(true);
                if (PCwindow != null)
		    PCwindow.setEnabled(true);
            }
            if (what.equals(RESET_SOLVER)) {
                setActionMode(what);
                animation_control.executeReset();
                //                animation_control.setEnabled(true);
                if (PCwindow != null) {
		    PCwindow.setEnabled(true);
		    PCwindow.resetPCTextLine();
		}
            }
	    if (what.equals(PC_NEXT)) {
                setActionMode(what);
	        animation_control.setEnabled(false);
                if (PCwindow != null)
		    PCwindow.setEnabled(false);
	    }
        }

        if (src instanceof GUISetSwatch) {
            ((GUISetSwatch) src).toggle();
            return;
        }
        
        if (src instanceof TextField) {
            clearStatusLine();
            GIDEN.out.println("TextField input = \""+((TextField) src).getText()+"\"");
            return;
        }
        
        if (src.equals(node_data_n)) {
            String what = evt.getActionCommand();
            if ("Add Data Field...".equals(what)) {
                int k=0;
                String name = "";
                String[] existing = new String[UiNet.GetNodeArrayCount()];
                for (k=0, name = UiNet.GetFirstNodeArrayName() ;
                     name != null ; name = UiNet.GetNextNodeArrayName(), k++)
                    existing[k] = name;
                new GUINewDataFieldDialog(this,existing,
                                          GUINewDataFieldDialog.NODE_ARRAY_DATA_FIELD);
            }
        }
        if (src.equals(delete_node_data_n)) {
            // delete the node array
            UiNet.DeleteNodeArray(evt.getActionCommand());
            
            // update the "delete node data" menu
            for (int i=0 ; i < delete_node_data_n.getItemCount() ; i++) {
                if (evt.getActionCommand().equals(delete_node_data_n.getItem(i).getActionCommand())) {
                    delete_node_data_n.remove(i);
                    break;
                }
            }
            if (delete_node_data_n.getItemCount() == 0)
                delete_node_data_n.setEnabled(false);
            
            // update the "view node data" checkbox menu items
            for (int i=0 ; i < node_data_n.getItemCount() ; i++) {
                if (evt.getActionCommand().equals(node_data_n.getItem(i).getActionCommand())) {
                    node_data_n.remove(i);
                    break;
                }
            }
            for (int i=0 ; i < node_array_count ; i++) {
                if (node_arrays[i] != null &&
                    evt.getActionCommand().equals(node_arrays[i].getActionCommand())) {
                    if (node_arrays[i].getState()) {
                        node_arrays[0].setState(true); // set index as display
                        setNodeDataView(node_arrays[0].getLabel()); // update display
                    }
                    node_arrays[i] = null;
                }
            }
        }
        
        
        if (src.equals(edge_data_n)) {
            String what = evt.getActionCommand();
            if ("Add Data Field...".equals(what)) {
                int k=0;
                String name = "";
                String[] existing = new String[UiNet.GetEdgeArrayCount()];
                for (k=0, name = UiNet.GetFirstEdgeArrayName() ;
                     name != null ; name = UiNet.GetNextEdgeArrayName(), k++)
                    existing[k] = name;
                new GUINewDataFieldDialog(this,existing,
                                          GUINewDataFieldDialog.EDGE_ARRAY_DATA_FIELD);
            }
        }
        if (src.equals(delete_edge_data_n)) {
            // delete the edge array
            UiNet.DeleteEdgeArray(evt.getActionCommand());
            
            // update the "delete edge data" menu
            for (int i=0 ; i < delete_edge_data_n.getItemCount() ; i++) {
                if (evt.getActionCommand().equals(delete_edge_data_n.getItem(i).getActionCommand())) {
                    delete_edge_data_n.remove(i);
                    break;
                }
            }
            if (delete_edge_data_n.getItemCount() == 0)
                delete_edge_data_n.setEnabled(false);
            
            // update the "view edge data" checkbox menu items
            for (int i=0 ; i < edge_data_n.getItemCount() ; i++) {
                if (evt.getActionCommand().equals(edge_data_n.getItem(i).getActionCommand())) {
                    edge_data_n.remove(i);
                    break;
                }
            }
            for (int i=0 ; i < edge_array_count ; i++) {
                if (edge_arrays[i] != null &&
                    evt.getActionCommand().equals(edge_arrays[i].getActionCommand())) {
                    if (edge_arrays[i].getState()) {
                        edge_arrays[0].setState(true); // set index as display
                        setEdgeDataView(edge_arrays[0].getLabel()); // update display
                    }
                    edge_arrays[i] = null;
                }
            }
        }
        
        String what = evt.getActionCommand();
        if ("Close".equals(what)) {
            if (PCwindow != null) {
                PCwindow.dispose();
                PCwindow = null;
            }
            parent.closeGUINetworkWindow(this,parent_mi,filename);
            dispose();
        }
        else if ("Help".equals(what)){                                  // dsd 020302
            if(GidenHelpWindow!=null)
                GidenHelpWindow.dispose();
            Rectangle bounds = this.getBounds();
            int x = bounds.x+bounds.width;
            int y = bounds.y;
            GidenHelpWindow = new GdnHtmlWindow(GidenHelpFile,"GIDEN Help",x,y,400,200);
            GidenHelpWindow.makeVisible(true);            
            }
        else if ("Info".equals(what)){                                 // dsd 020302
            if(SolverInfoWindow!=null)
                SolverInfoWindow.dispose();
            Rectangle bounds = this.getBounds();
            int x = bounds.x+bounds.width;
            int y = bounds.y;
            SolverInfoWindow = new GdnHtmlWindow(SolverInfoFile,"GIDEN Solver Info",x,y,400,200);
            SolverInfoWindow.makeVisible(true);            
            }
            
        
        else if ("Save".equals(what) && netfile != null && netfile.exists()) {
        //else if ("Save".equals(what) && !filename.equals("")) {
            if (netfile.lastModified() > modtime) {
                GUIOkayCancelQuery query = new GUIOkayCancelQuery(this,"File has changed on disk.  Overwrite?");
                if (!query.isOkay())
                    return;
                else
                    GIDEN.out.println("overwriting changed file...");
            }

            /* write text based files */
            (new GUINetworkWriter()).writeGUINetwork(dirname+filename,UiNet);

            modtime = netfile.lastModified();
        }
        else if ("Save As...".equals(what) || ("Save".equals(what) 
                                               && netfile != null
                                               && !netfile.exists())) {
            FileDialog d = new FileDialog(this,"Save GIDEN Network...",FileDialog.SAVE);
            d.setFilenameFilter(new EndsWithFilter(".gdn"));
            d.setDirectory("./networks");
            d.setVisible(true);
            
            if (d.getFile() != null && !(d.getFile()).equals("")) {
                
                String oldfilename = new String(filename);
                filename = new String(d.getFile());
                // make sure that filename ends with ".gdn"
                if (!filename.toLowerCase().endsWith(".gdn"))
                    filename = new String(filename+".gdn");

                String olddirname = new String(dirname);
                dirname = new String(d.getDirectory());
                if (dirname.equals("./")) {
                    dirname = System.getProperty("user.dir");
                    if (dirname == null)
                        dirname = new String("./networks/");
                    else
                        dirname = new String(dirname+"/networks/");
                }

                File newnetfile = new File(dirname+filename);
                if (newnetfile.exists()) {
                    
                    if (newnetfile.isFile()) {
                        // prompt to overwrite
                        GUIOkayCancelQuery query = new GUIOkayCancelQuery(this,"About to overwrite existing file:  \n\""+dirname+filename+"\"");
                        
                        if (!query.isOkay()) {
                            filename = oldfilename;
                            dirname = olddirname;
                            return;
                        }
                    }
                    else {
                        // notify that is directory name and cannot overwrite
                        new GUIModalMessageDialog(this,GUIModalMessageDialog.NOTICE,
                                                  "Cannot overwrite directory: \""
                                                  +dirname+filename+"\"");
                        filename = oldfilename;
                        dirname = olddirname;
                        return;
                    }
                }
                
                /* write text based files */
                (new GUINetworkWriter()).writeGUINetwork(dirname+filename,UiNet);

                if (!filename.equals(oldfilename))
                    parent.registerFileameChange(this,parent_mi,oldfilename,filename);

                netfile = newnetfile;
                modtime = netfile.lastModified();
                save_mi.setEnabled(true);
            }
        }
        else if ("Hide".equals(what)) {
	    // 21-Jul-1999           setVisible(false);
	    hide_net();
        }
        else if ("Print Window...".equals(what) 
                 || "Print Network...".equals(what)) {

            PrintJob pjob = this.getToolkit().getPrintJob(this,what,null);
            if (pjob != null) {
                Graphics pg = pjob.getGraphics();
                

                /*
                // (TEMP-owenj) print network window and pseudocode
                if (pg != null) {
                    printAll(pg);

                    if (PCwindow != null) {
                        pg.translate(0, getSize().height);

                        // print pseudocode below network
                        PCwindow.printAll(pg);
                    }
                    pg.dispose(); // flush page
                }
                */

                // print network
                if (pg != null) {
                    // translate to offset northwest corner by 0.5 inch
                    int res = getToolkit().getScreenResolution();
                    pg.translate((int) (.5*res), (int) (.5*res));

                    if ("Print Window...".equals(what) || draw_canvas == null)
                        printAll(pg);
                    else
                        draw_canvas.print(pg);
                        //                        draw_canvas.printAll(pg);
                    pg.dispose(); // flush page
                }

                pjob.end();
            }
        }
        else if ("Paste".equals(what)) {
            draw_canvas.pasteSelectedToCanvas();
        }
        else if ("Cut".equals(what)) {
            draw_canvas.deleteSelectedItems();
        }
        else if ("Copy".equals(what)) {
            draw_canvas.copySelectedToClipboard();
        }
        else if ("Clear".equals(what)) {
            draw_canvas.clearNetwork();
        }
        else if ("Nudge Up".equals(what)) {
            draw_canvas.moveSelectedItems(0,-1);
        }
        else if ("Nudge Down".equals(what)) {
            draw_canvas.moveSelectedItems(0,1);
        }
        else if ("Nudge Left".equals(what)) {
            draw_canvas.moveSelectedItems(-1,0);
        }
        else if ("Nudge Right".equals(what)) {
            draw_canvas.moveSelectedItems(1,0);
        }
        else if ("Select All".equals(what)) {
            draw_canvas.clearSelections();
            draw_canvas.selectAllGUINodesAndGUIEdges();
        }
        else if ("Select All Nodes".equals(what)) {
            draw_canvas.clearSelections();
            draw_canvas.selectAllGUINodes();
        }
        else if ("Toggle Grid".equals(what)) {
            //            MenuItem mi = (MenuItem) evt.getSource();
            if (draw_canvas.canvas_grid.isVisible()) {
                draw_canvas.canvas_grid.setVisible(false);
                draw_canvas.canvas_grid.setEnabled(false);
                grid_mi.setLabel("Enable Grid");
            }
            else {
                draw_canvas.canvas_grid.setVisible(true);
                draw_canvas.canvas_grid.setEnabled(true);
                grid_mi.setLabel("Disable Grid");
            }
            UTILITIES.Repaint(draw_canvas," -- GUINetworkWindow:actionPerformed");
            // draw_canvas.repaint();
        }
        /*
        else if ("Write tracable status for sets...".equals(what)) {
            GIDEN.out.println("\nAnimation Set tracable status");
            GIDEN.out.println("  (standard sets)");
            for (int i=0 ; i < traceset_buttons.length; i++) {
                GIDEN.out.print("     "+traceset_buttons[i].getLabel()+"  .....  ");
                if (traceset_buttons[i].isTracable())
                    GIDEN.out.println("tracable");
                else
                    GIDEN.out.println("not tracable");
            }
            GIDEN.out.println("  (final sets)");
            for (int i=0 ; i < final_traceset_buttons.length ; i++) {
                GIDEN.out.print("     "+final_traceset_buttons[i].getLabel()+"  .....  ");
                if (final_traceset_buttons[i].isTracable())
                    GIDEN.out.println("tracable");
                else
                    GIDEN.out.println("not tracable");
            }
        }
        */
    }
    
    
    
    private boolean directed = true;
    public /*protected*/ synchronized final void setDirected(boolean directed) {
        this.directed = directed;
        if (draw_canvas != null)
            draw_canvas.setDirected(directed);
        drawDirectedNetwork.setState(directed);
    }

    public boolean isAnimationDetailEnabled() {
        return animationDetail.getState();
    }
    private void setAnimationDetail(boolean detail) {

        // this step is redundant if invoked b/c of menu checkbox selection...
        animationDetail.setState(detail); 


        animation_control.setAnimationDetail(detail);

        if (detail) {
            // disable algorithm animation set buttons
            if (traceset_buttons != null)
                for (int j=0 ; j < traceset_buttons.length ; j++)
                    traceset_buttons[j].setEnabled(false);
        }
        else {
            // enable algorithm animation set buttons
            if (traceset_buttons != null)
                for (int j=0 ; j < traceset_buttons.length ; j++)
                    traceset_buttons[j].setEnabled(true);
        }
    }


    String current_anim_mode;
    String old_anim_mode;
    public String getAnimationMode() {
        return current_anim_mode;
    }
    public void setAnimationMode(String modename) {
        old_anim_mode = new String(current_anim_mode);
        current_anim_mode = new String(modename);

        if (current_anim_mode.equals(FINAL) && !old_anim_mode.equals(FINAL)) {
            // update bottom panel
            bottom_panel.remove(algorithm_animation_sets);
            bottom_panel.add(final_animation_sets,BorderLayout.CENTER);
            invalidate(); 
            validate(); 
            if (isShowing())
                UTILITIES.Repaint(this,"setAnimationMode (1)");
        }

        if (!current_anim_mode.equals(FINAL) && old_anim_mode.equals(FINAL)) {
            // update bottom panel
            bottom_panel.remove(final_animation_sets);
            bottom_panel.add(algorithm_animation_sets,BorderLayout.CENTER);
            invalidate(); 
            validate(); 
            if (isShowing())
                UTILITIES.Repaint(this,"setAnimationMode (2)");
        }
    }

    /**********************************************************************/
    // item listener method
    /**********************************************************************/
    public void itemStateChanged(ItemEvent evt) {
        Object src = evt.getSource();
        
        if (src.equals(showPCwindow) && PCwindow != null) {
            PCwindow.setVisible(showPCwindow.getState());
            return;
        }
        if (src.equals(animationDetail)) {
            setAnimationDetail(animationDetail.getState());
            return;
        }
        
        if (src.equals(drawDirectedNetwork)) {
            // rely on the network to callback our setDirected() method
            UiNet.PutDirected(drawDirectedNetwork.getState());
            return;
        }

        // check node data checkboxmenuitems
        for (int i=0 ; i < node_arrays.length ; i++) 
            if (src.equals(node_arrays[i])) {
                setNodeDataView(node_arrays[i].getActionCommand());
                return;
            }
        
        
        // check edge data checkboxmenuitems
        for (int i=0 ; i < edge_arrays.length ; i++) 
            if (src.equals(edge_arrays[i])) {
                setEdgeDataView(edge_arrays[i].getActionCommand());
                return;
            }
    }
    /**********************************************************************/
    // window listener methods
    /**********************************************************************/
    public void windowActivated(WindowEvent evt)   {}
    public void windowClosed(WindowEvent evt)      {}
    public void windowClosing(WindowEvent evt)     {
        if (PCwindow != null) {
            PCwindow.dispose();
            PCwindow = null;
        }
        parent.closeGUINetworkWindow(this,parent_mi,filename);
        dispose();
    }
    public void windowDeactivated(WindowEvent evt) {}
    public void windowDeiconified(WindowEvent evt) {hiddenByParent = false;}
    public void windowIconified(WindowEvent evt)   {
        if (evt.getWindow().equals(parent))          {
	    //            setVisible(false);
	    hide_net();
            hiddenByParent = true;
        }
        else if (!hiddenByParent)
  	    // setVisible(false);
	    hide_net();
    }
    public void windowOpened(WindowEvent evt)      {}


    /********************************************************************/
    // listener class and support method for processing solver selections
    /********************************************************************/
    protected void solverSelected(String text) {}
    class GUISolverMenuListener implements ActionListener {
        public void actionPerformed(ActionEvent evt) {
            String text = evt.getActionCommand();

            // check for "blessed" solvers
            for (int i=0 ; i < solvernames.length ; i++)
                if (text.equals(solvernames[i])) {
                    solverSelected(text);
                    return;
                }
                
            // check for contrib solvers
            String problem_name, solver_name;
            ContribSolverMenu contrib=GetContribSolverMenu();
            problem_name=contrib.FirstProblem();
            while(problem_name!=null) {
                solver_name=contrib.FirstSolver();
                while(solver_name!=null) {
                    if (text.equals(solver_name)) {
                        solverSelected(text);
                        return;
                    }
                    solver_name=contrib.NextSolver();
                }
                problem_name=contrib.NextProblem();
            }
                

            // check for user-implemented solvers
            //String problem_name, solver_name;
            SolverMenu solvermenu=GetSolverMenu();
            problem_name=solvermenu.FirstProblem();
            while(problem_name!=null) {
                solver_name=solvermenu.FirstSolver();
                while(solver_name!=null) {
                    if (text.equals(solver_name)) {
                        solverSelected(text);
                        return;
                    }
                    solver_name=solvermenu.NextSolver();
                }
                problem_name=solvermenu.NextProblem();
            }
        }
    }
}
