package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.*;
import java.lang.String;
import java.awt.*;
import java.awt.event.*;


public class GUINewDataFieldDialog extends Dialog implements ActionListener, 
                                                      ComponentListener,
                                                      WindowListener,
                                                      MouseListener
{
    
    String data_field_name;
    DataFieldName tf;
    Object data_fill_value;
    DataFieldName fill;   //  DataFillValue fill;
    Choice field_type;
    CheckboxGroup field_type_cb;
    Button okay;
    Button cancel;
    String[] known_strings;
    Frame parent;
    int type;
    
    public static int EDGE_ARRAY_DATA_FIELD = 0;
    public static int NODE_ARRAY_DATA_FIELD = 1;
    
    public GUINewDataFieldDialog(Frame parent,
                                 String[] existing,
                                 int type) {
        super(parent,"Add Data Field...",true/*modal*/);
        addWindowListener(this);
        //    setLocation(parent.getLocation());
        
        this.parent = parent;
        this.type = type;
        known_strings = existing;
        
        
        GridBagLayout gbl = new GridBagLayout();
        setLayout(gbl);
        setBackground(Color.lightGray);
        
        // setup default data for components of the gridbag
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(0,0,0,0);    // (top,left,bottom,right)
        
        
        // setup constraints for label
        Label l = new Label("Enter Field Name: ");
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(l,gbc);
        add(l);
        
        
        // setup constraints for the DataFieldName
        tf = new DataFieldName(20);
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 1;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(tf,gbc);
        tf.addActionListener(this);
        add(tf);
        
        // setup constraints for label
        l = new Label("Enter Default Value: ");
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 1;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(l,gbc);
        add(l);
        
        
        // setup constraints for the DataFillValue
        //    fill = new DataFillValue(10);
        fill = new DataFieldName(10);
        fill.setText("0");
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 1;
        gbc.gridy      = 1;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(fill,gbc);
        fill.addActionListener(this);
        add(fill);
        
        // setup constraints for the Data Field Type label
        l = new Label("Data Field Type: ");
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 2;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(l,gbc);
        add(l);
        
        // setup constraints for the Data Field Type choice
        field_type = new Choice();
        field_type.add("integer"); field_type.add("text");
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 1;
        gbc.gridy      = 2;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(field_type,gbc);
        //    /*
        add(field_type);
        //    */
        
        Panel p = new Panel();
        GridBagLayout pgbl = new GridBagLayout();
        p.setLayout(pgbl);
        
        
        // setup panel for checkboxes (and group)
        field_type_cb = new CheckboxGroup();
        Checkbox cb = new Checkbox("integer",true,field_type_cb);
        gbc.anchor = GridBagConstraints.WEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        pgbl.setConstraints(cb,gbc);
        p.add(cb);
        cb = new Checkbox("text",false,field_type_cb);
        gbc.gridx      = 1;
        pgbl.setConstraints(cb,gbc);
        p.add(cb);
        // setup conatraints for the button panel
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx      = 1;
        gbc.gridy      = 2;
        gbl.setConstraints(p,gbc);
        /*
          add(p);
        */
        
        
        
        // reinitialize panel for okay and cancel buttons
        p = new Panel();
        pgbl = new GridBagLayout();
        p.setLayout(pgbl);
        
        
        // setup constraints for the cancel button
        cancel = new Button("Cancel");
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        pgbl.setConstraints(cancel,gbc);
        cancel.addActionListener(this);
        p.add(cancel);
        
        
        // setup constraints for the okay button
        okay = new Button("  OK  ");
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.gridx      = 1;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        pgbl.setConstraints(okay,gbc);
        okay.addActionListener(this);
        p.add(okay);
        
        // setup conatraints for the button panel
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 2;
        gbc.gridheight = 1;
        gbc.gridx      = 0;
        gbc.gridy      = 3;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbc.ipady      = 10;
        gbl.setConstraints(p,gbc);
        gbc.ipady      = 0;
        add(p);
        
        addComponentListener(this);
        pack();
        
        Rectangle parent_bounds = parent.getBounds();
        Rectangle my_bounds = getBounds();
        setLocation(parent_bounds.x + (parent_bounds.width-my_bounds.width)/2,
                    parent_bounds.y + (parent_bounds.height-my_bounds.height)/2);
        
        setVisible(true);
        tf.requestFocus();
    }
    
    
    private String getFormattedFieldName(String buffer) {
        // here we eliminate leading/trailing white space, and we ensure
        // that any consecutive spaces are reduced to a single space
        
        int o_pos;
        char[] o_chars = (buffer.trim()).toCharArray();
        
        int n_pos;
        char[] n_chars = new char[o_chars.length];
        
        char curr_char;
        
        // any char will do here since we've stripped leading white space
        char last_char = 'a'; 
        
        
        for (o_pos = 0, n_pos=0 ; o_pos < o_chars.length ; o_pos++) {
            curr_char = o_chars[o_pos];
            
            if (curr_char != ' ') {
                n_chars[n_pos++] = curr_char;
                last_char = curr_char;
            }
            else if (last_char != ' ') {
                n_chars[n_pos++] = curr_char;
                last_char = curr_char;
            }
        }
        
        return new String(n_chars,0,n_pos);
    }
    
    
    private boolean dataFieldNameIsValid() {
        String name = getFormattedFieldName(tf.getText());
        
        if (name.equals("")) {
            tf.setText("");
            new GUIModalMessageDialog(parent,GUIModalMessageDialog.NOTICE,
                                      "Non-empty name is required.");
            return false;
        }
        
        if (known_strings == null) {
            data_field_name = new String(name);
            return true;
        }
        
        boolean name_conflict = false;
        for (int i=0 ; i < known_strings.length ; i++)
            if (name.equalsIgnoreCase(known_strings[i])) {
                name_conflict = true;
                break;
            }
        
        if (name_conflict) {
            tf.selectAll();
            if (type == NODE_ARRAY_DATA_FIELD)
                new GUIModalMessageDialog(parent,GUIModalMessageDialog.NOTICE,
                                          "Name conflicts with an existing Node Data Field.");
            else // type == EDGE_ARRAY_DATA_FIELD
                new GUIModalMessageDialog(parent,GUIModalMessageDialog.NOTICE,
                                          "Name conflicts with an existing Edge Data Field.");
            return false;
        }
        else {
            data_field_name = new String(name);
            return true;
        }
    }
    
    private boolean dataFillValueIsValid() {
        //        if ("integer".equals(field_type_cb.getSelectedCheckbox().getLabel())) {
        if ("integer".equals(field_type.getSelectedItem())) {
            int fill_int;
            try {
                fill_int = (new Integer(fill.getText())).intValue();
            } catch (NumberFormatException e) {
                fill.selectAll();
                new GUIModalMessageDialog(parent,GUIModalMessageDialog.NOTICE,
                                          "Specified value is not a valid integer.");
                return false;
            }
            
            data_fill_value = new Integer(fill_int);
            return true;
        }
        else { //  "text".equals(field_type.getSelectedItem())
            data_fill_value = new String(fill.getText());
            return true;
        }
    }
    
    
    /**********************************************************************/
    // action listener method
    /**********************************************************************/
    public void actionPerformed(ActionEvent evt) {
        Object source = evt.getSource();
        
        if (source.equals(cancel))
            dispose();
        else if (source.equals(okay)) {
            if (dataFieldNameIsValid() && dataFillValueIsValid()) {
                if (type == NODE_ARRAY_DATA_FIELD)
                    ((GUINetworkWindow) parent).createNodeDataField(data_field_name,
                                                                    data_fill_value);
                else // type == EDGE_ARRAY_DATA_FIELD
                    ((GUINetworkWindow) parent).createEdgeDataField(data_field_name,
                                                                    data_fill_value);
                dispose();
            }
            return;
        }
    }
    
    /**********************************************************************/
    // component listener methods
    /**********************************************************************/
    public void componentResized(ComponentEvent evt) {
        pack(); 
        UTILITIES.Repaint(this,"componentResized");
    }
    public void componentMoved(ComponentEvent evt)   {
        pack(); 
        UTILITIES.Repaint(this,"componentMoved");
    }
    public void componentShown(ComponentEvent evt)   {
        pack(); 
        UTILITIES.Repaint(this,"componentShown");
    }
    public void componentHidden(ComponentEvent evt)  {
        pack(); 
        UTILITIES.Repaint(this,"componentHidden");
    }
    
    
    /**********************************************************************/
    // window listener methods
    /**********************************************************************/
    public void windowActivated(WindowEvent evt)   {}
    public void windowClosed(WindowEvent evt)      {}
    public void windowClosing(WindowEvent evt)     {dispose();}
    public void windowDeactivated(WindowEvent evt) {}
    public void windowDeiconified(WindowEvent evt) {}
    public void windowIconified(WindowEvent evt)   {}
    public void windowOpened(WindowEvent evt)      {}
    
    
    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt) {}
    public void mousePressed(MouseEvent evt) {}
    public void mouseReleased(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt) {tf.requestFocus();}
    public void mouseExited(MouseEvent evt) {}
}


class DataFieldName extends TextField implements KeyListener, MouseListener {
    DataFieldName(int size) {
        super(size);
        
        addKeyListener(this);
        addMouseListener(this);
    }
    
    public void keyTyped(KeyEvent evt) {}
    public void keyReleased(KeyEvent evt) {}
    public void keyPressed(KeyEvent evt) {
        char c = evt.getKeyChar();
        int key_code = evt.getKeyCode();
        
        if (key_code == KeyEvent.VK_ENTER)
            selectAll();
        
        if (!Character.isDigit(c) && !Character.isLetter(c) && 
            c != '-' && key_code != KeyEvent.VK_SUBTRACT &&
            key_code != KeyEvent.VK_LEFT && key_code != KeyEvent.VK_RIGHT &&
            key_code != KeyEvent.VK_BACK_SPACE && key_code != KeyEvent.VK_DELETE &&
            key_code != KeyEvent.VK_ENTER && key_code != KeyEvent.VK_SPACE)
            evt.consume();
    }
    
    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt) {}
    public void mousePressed(MouseEvent evt) {}
    public void mouseReleased(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt) {
        //    GIDEN.out.println("event recv'd");
        requestFocus();
    }
    public void mouseExited(MouseEvent evt) {}
}


class DataFillValue extends TextField implements KeyListener, MouseListener {
    DataFillValue(int size) {
        super(size);
        
        setText("0");
        //    setCaretPosition(1);
        //    selectAll();
        
        addKeyListener(this);
        addMouseListener(this);
    }
    
    public void keyTyped(KeyEvent evt) {}
    public void keyReleased(KeyEvent evt) {}
    public void keyPressed(KeyEvent evt) {
        char c = evt.getKeyChar();
        int key_code = evt.getKeyCode();
        
        //    GIDEN.out.println("Pressed:  "+KeyEvent.getKeyText(key_code));
        
        if (key_code == KeyEvent.VK_ENTER)
            selectAll();
        
        
        if (!Character.isDigit(c) && 
            c != '-' && key_code != KeyEvent.VK_SUBTRACT &&
            key_code != KeyEvent.VK_LEFT && key_code != KeyEvent.VK_RIGHT &&
            key_code != KeyEvent.VK_BACK_SPACE && key_code != KeyEvent.VK_DELETE)
            evt.consume();
    }
    
    /**********************************************************************/
    // mouse listener methods
    /**********************************************************************/
    public void mouseClicked(MouseEvent evt) {}
    public void mousePressed(MouseEvent evt) {}
    public void mouseReleased(MouseEvent evt) {}
    public void mouseEntered(MouseEvent evt) {
        //    GIDEN.out.println("event recv'd");
        requestFocus();
        //    selectAll();
    }
    public void mouseExited(MouseEvent evt) {}
}
