package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.image.*;


public class GUINodeImageComponent extends GUIImageComponent {
    
    transient protected Image newimage = null;
    protected GUIColorFilter imgf = new GUIColorFilter();
    
    GUINodeImageComponent(String filename) {
        super(filename);
    }
    
    synchronized private void filterImage() {
        ImageProducer ip = image.getSource();
        ip = new FilteredImageSource(ip,imgf);
        newimage = getToolkit().createImage(ip);
        
        MediaTracker tracker = new MediaTracker(this);
        tracker.addImage(newimage,1);
        try {
            tracker.waitForAll();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
        
        UTILITIES.Repaint(this,"filterImage");
    }
    
    protected void checkInitialization() {
        // if reading from a file, we need to reload "image" using
        // "filename"; this is necessary since "image" is transient
        super.checkInitialization();
        
        // we need to recreate the filtered image as well
        if (newimage == null) {
            imgf = new GUIColorFilter();
            filterImage();
        }
    }
    
    public Image getImage(Color c) {
        checkInitialization();
        if (!c.equals(imgf.getBaseColor())) {
            imgf.setBaseColor(c);
            filterImage();
        }
        return newimage;
    }
}

