package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class GUIOkayCancelQuery {
    private boolean okay = false;
    
    public boolean isOkay() {
        return okay;
    }
    
    synchronized public void setOkay(boolean okay) {
        this.okay = okay;
    }
    
    public GUIOkayCancelQuery(Frame source, String message) {
        new GUIOkayCancelDialog(source,this,GUIOkayCancelDialog.WARNING,message);
    }
}


/*public*/ class GUIOkayCancelDialog extends Dialog implements ActionListener, 
                                                    ComponentListener,
                                                    WindowListener
{
    Button cancel;
    Button okay;
    GUIOkayCancelQuery wrapper;
    
    public static final String WARNING = new String("Warning!");
    public static final String ERROR   = new String("Error!");
    public static final String NOTICE  = new String("Notice...");
    public static final String NEUTRAL = new String("");
    
    public GUIOkayCancelDialog(Frame parent, GUIOkayCancelQuery wrapper,
                               String title, String message) {
        super(parent, title, true/*modal*/);
        addWindowListener(this);
        
        this.wrapper = wrapper;
        
        GridBagLayout gbl  = new GridBagLayout();
        setLayout(gbl);
        
        // setup default data for components of the gridbag
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth  = 1;
        gbc.gridheight = 1;
        gbc.ipadx      = 0;
        gbc.ipady      = 0;
        gbc.insets     = new Insets(0,0,0,0);    // (top,left,bottom,right)
        
        // setup constraints for the message
        Label l = new Label(message);
        gbc.anchor = GridBagConstraints.WEST;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbl.setConstraints(l,gbc);
        add(l);
        
        
        // create panel for okay and cancel buttons
        Panel p = new Panel();
        GridBagLayout pgbl = new GridBagLayout();
        p.setLayout(pgbl);
        
        // setup constraints for the cancel button
        cancel = new Button("cancel");
        cancel.addActionListener(this);
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx      = 0;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        pgbl.setConstraints(cancel,gbc);
        p.add(cancel);
        
        
        // setup constraints for the okay button
        okay = new Button("  OK  ");
        okay.addActionListener(this);
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx      = 1;
        gbc.gridy      = 0;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        pgbl.setConstraints(okay,gbc);
        p.add(okay);
        
        // setup conatraints for the button panel
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx      = 0;
        gbc.gridy      = 1;
        gbc.weightx    = 0;
        gbc.weighty    = 0;
        gbc.ipady      = 10;
        gbl.setConstraints(p,gbc);
        gbc.ipady      = 0;
        add(p);
        
        addComponentListener(this);
        pack();
        
        Rectangle parent_bounds = parent.getBounds();
        Rectangle my_bounds = getBounds();
        setLocation(parent_bounds.x + (parent_bounds.width-my_bounds.width)/2,
                    parent_bounds.y + (parent_bounds.height-my_bounds.height)/2);
        
        setVisible(true);
        okay.requestFocus();
    }
    
    
    /**********************************************************************/
    // action listener method
    /**********************************************************************/
    public void actionPerformed(ActionEvent evt) {
        Object source = evt.getSource();
        
        if (source.equals(cancel)) {
            wrapper.setOkay(false);
            dispose();
        }
        else if (source.equals(okay)) {
            wrapper.setOkay(true);
            dispose();
        }
    }
    
    
    /**********************************************************************/
    // component listener methods
    /**********************************************************************/
    public void componentResized(ComponentEvent evt) {
        pack(); 
        UTILITIES.Repaint(this,"componentResized");
    }
    public void componentMoved(ComponentEvent evt)   {
        pack();
        UTILITIES.Repaint(this,"componentMoved");
    }
    public void componentShown(ComponentEvent evt)   {
        pack();
        UTILITIES.Repaint(this,"componentShown");
    }
    public void componentHidden(ComponentEvent evt)  {
        pack();
        UTILITIES.Repaint(this,"componentHidden");
    }
    
    
    /**********************************************************************/
    // window listener methods
    /**********************************************************************/
    public void windowActivated(WindowEvent evt)   {}
    public void windowClosed(WindowEvent evt)      {}
    public void windowClosing(WindowEvent evt)     {dispose();}
    public void windowDeactivated(WindowEvent evt) {}
    public void windowDeiconified(WindowEvent evt) {}
    public void windowIconified(WindowEvent evt)   {}
    public void windowOpened(WindowEvent evt)      {}   
}
