package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;

public class GUISetSwatch extends Button {
    
    boolean enabled;
    boolean selected;
    Font selected_font, unselected_font;
    GUINetworkWindow parent;
    Color color;
    String label;
    
    public GUISetSwatch(Color color, String label, GUINetworkWindow parent) {
        super();
        
        // save parent (a GUINetworkWindow)
        this.parent = parent;
        
        // save original color and label info
        this.color = color;
        this.label = label;
        
        // enable by default
        enabled = true;
        
        // add padding to label
        label = "  "+label+"  "; 
        
        
        // setup fonts
        Font default_font = getFont();
        String fontname;
        int fontsize;
        if (default_font != null) {
            fontname = default_font.getName();
            fontsize = default_font.getSize();
        }
        else {
            fontname = "SansSerif";
            fontsize = 14;
        }
        selected_font = new Font(fontname,Font.BOLD|Font.ITALIC,fontsize);
        unselected_font = new Font(fontname,Font.PLAIN,fontsize);
        
        
        // initially unselected
        selected = false;
        this.setFont(unselected_font);
        
        
        // setup color scheme
        setBackground(color);
        
        //    int threshold = 382;
        int threshold = 254;
        int color_weight = color.getRed() + color.getGreen() + color.getBlue();
        //    if (color == Color.black)
        if (color_weight <= threshold)
            setForeground(Color.white);
        else
            setForeground(Color.black);
        
        // set label
        setLabel(label);
    }
    
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
        if (!enabled)
            this.setFont(unselected_font);
        else if (selected)
            this.setFont(selected_font);
    }
    
    public void toggle() {
        if (enabled) {
            selected = !selected;
            
            if (selected)
                this.setFont(selected_font);
            else
                this.setFont(unselected_font);
        }
    }
    
    public boolean isTracable() {
        String animation_mode = parent.getAnimationMode();
        return (selected &&
                (GUINetworkWindow.TRACE.equals(animation_mode)
                 || GUINetworkWindow.PAUSE_CONTINUOUS.equals(animation_mode)));
    }
    
    public Color getColor() {
        return color;
    }
    
    public String getLabel() {
        return label;
    }
}
