package giden.GUI;
import giden.CORE.*;
import giden.gidenSOLVERS.*;
import giden.GRDS.*;
import giden.GUI.*;
//import giden.userSOLVERS.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.net.URL;


/**************************************************************************/
/**************************************************************************/
public class NetworkWindowNameManager {
    private int numnames;
    private String names[];
    private int    open[];
    private int    copy[];
    
    public NetworkWindowNameManager() {
        numnames = 0;
        
        names = new String[5];
        open  = new int[5];
        copy  = new int[5];
    }
    
    public void registerFilename(String filename) {
        int i;
        for (i=0 ; i < numnames ; i++) {
            if (filename.equals(names[i]))
                break;
        }
        
        if (i == numnames) {      // this is a new name!
            if (numnames == names.length)
                resizeArrays();
            
            names[i] = new String(filename);
            open[i] = 1;
            copy[i] = 1;
            numnames++;
        }
        else {                    // an existing name
            open[i]++;
            copy[i]++;
        }
    }
    
    private void resizeArrays() {
        int oldsize = names.length;
        int newsize = (int) (1.5*oldsize);
        
        String new_names[] = new String[newsize];
        int    new_open[]  = new int[newsize];
        int    new_copy[]  = new int[newsize];
        
        for (int i=0 ; i < oldsize ; i++) {
            new_names[i] = new String(names[i]);
            new_open[i]  = open[i];
            new_copy[i]  = copy[i];
        }
        names = new_names;
        open = new_open;
        copy = new_copy;
    }
    
    public void unregisterFilename(String filename) {
        int i;
        for (i=0 ; i < numnames ; i++) {
            if (filename.equals(names[i]))
                break;
        }
        open[i]--;
        
        if (open[i] == 0 && !filename.equals(""))
            copy[i] = 0;
    }
    
    public String getLatestNetname(String filename) {
        int i;
        for (i=numnames-1 ; i >= 0 ; i--) {
            if (filename.equals(names[i]))
                break;
        }
        
        // handle case of unnamed files
        if (filename.equals("")) {
            if (copy[i] == 1)
                return new String("(untitled)");
            else // copy[i] > 1
                return new String("(untitled-"+copy[i]+")");
        }
        
        // handle named files
        else {
            //      String shortname = new String(names[i].substring(0,filename.length()-".gdn".length()));
            if (copy[i] == 1) 
                return filename;
            else // copy[i] > 1
                return new String(filename+" ("+copy[i]+")");
        }
    }
    
    public String getLatestWindowname(String filename) {
        int i;
        for (i=numnames-1 ; i >= 0 ; i--) {
            if (filename.equals(names[i]))
                break;
        }
        
        // handle case of unnamed files
        if (filename.equals("")) {
            if (copy[i] == 1)
                return new String("(untitled)");
            else // copy[i] > 1
                return new String("(untitled-"+copy[i]+")");
        }
        
        // handle named files
        else {
            if (copy[i] == 1)
                return new String("\""+filename+"\"");
            else // copy[i] > 1
                return new String("\""+filename+"\" ("+copy[i]+")");
        }
    }
}
