import java.awt.Color;

/**********************************************************************/
// OwenjSolver
/**********************************************************************/
class OwenjSolver extends ExecBase
{
    Network Net;
    UserBase UserInfo;
    
    /********************************************************************/
    /********************************************************************/
    OwenjSolver(UserBase userinfo) {
        super(userinfo);
        UserInfo=userinfo;
    }

    /********************************************************************/
    /********************************************************************/
    public boolean Setup(Network net)
    {
        if(net==null)
            return false;
        super.Setup(net);  // pass to base class

        Net=net;
        return true;
    }
    /********************************************************************/
    /********************************************************************/
    public boolean Shutdown()
    {
        return super.Shutdown();
    }
    /********************************************************************/
    // Execute
    /********************************************************************/
    public boolean Execute()
    {
        UserBase nullbase = new UserBase(UserInfo.SolverIo);

        /*** MAX FLOW TEST
        //        MaxFlow solver = new GenAugPath();
        //        MaxFlow solver = new ShortAugPath();
        MaxFlow solver = new PreFlowPush(nullbase);


        solver.Setup(Net);

        NodeListIter nit = Net.GetNodeListIter();
        solver.Source = nit.GetFirstNode();

        // set sink to last node... (ugly!!!)
        Node tmp = nit.GetFirstNode();
        do {
            solver.Sink = tmp;
            tmp = nit.GetNextNode();
        } while (tmp != null);
        

        solver.Execute();
        UserInfo.StatusLine("Flow Value= "+solver.FlowValue);

        solver.Shutdown();
        ***/

        /*** MIN COST FLOW TEST ***/
        MinCostFlow solver = new SuccShortPath(nullbase);
        solver.Setup(Net);
        solver.Execute();
        UserInfo.StatusLine("Flow Value = "+solver.FlowValue
                            +"  ;  Flow Cost = "+solver.FlowCost);
        solver.Shutdown();

        return true;
    }

    
}
